/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~
*   MJSMUTDE.C                                                            *
*   Version 2.30                                                          *
*   Copyright (C) 1991-93, MajorSoft Inc. and Eric Furrer                 *
*   This is the MUTANTS! defines module                                   *
*   for the MajorBBS version 6.xx +                                       *
*   E. Furrer      12/24/91        "it's not how you play the game,       *
*                                   it's if you win or lose."             *
*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/
#include "gcomm.h"
#include "majorbbs.h"
#include "mjsmutx.h"           /* msg header file                      */
#include "mjsmuth.h"           /* mutants header file                  */
#include "mjsmutp.h"           /* mutants prototype file               */

char huge *player=NULL;

int dusrnum, 
    dmargc, 
    plybas = 0,
    monstart, 
    maxcreat, 
    nextmon, 
    monturn, 
    moncltu, 
    hlpmsg, 
    dunsiz, 
    sizspell, 
    gloflag, 
    maxtypes, 
    itemsiz,
    activate, 
    syssiz,
    mutstt;             // modified for mutantlink
    
int genx[] = {0, 0, 1, -1};
int geny[] = {1, -1, 0, 0};
int genz[] = {0, 0, 0, 0}; 

long maxroom;

char VERSION[] = {"MUTANTS! V2.30 (C) MAJORSOFT INC."};

char BUFFER[255];
char message[60];

char dmargv[20][200]; 

char *gendir[] = {"north", "south", "east", "west"}; 

PLAYER  *dunwho, 
         dunglb;
        
PLAYMAP *mutmap;

ROOMS proomptr, 
     *cacheptr;
      
SALES psaleptr;
LOGS mlogptr;
DUNHGH dhghptr;
SYSOPT doptions;
MONSTER *pmonsptr;
ITEMS *pitemptr;
REGEN regenptr;
TABLE *tableptr;


BTVFILE *pplybb,
        *proombb,
        *psalebb,
        *plogbb,
        *dhghbb,
        *monsbb,
        *itembb,
	*headbb,        // mutantlink
	*intbb;         // mutantlink

FILE *dunmb;

// sysop routines      KEY    COMMAND     ROUTINE   HELPFILE
SYSOP sysop[] = {
    {TRDKEY, "trade",  dun_trade,   HLPTRD},
    {MNTKEY, "maint",  dun_maint,   HLPMNT},
    {DRKKEY, "dark",   dun_sdark,   HLPDRK},
    {GTEKEY, "gate",   dun_door,    HLPGTE},
    {ITMKEY, "item",   dun_sitem,   HLPITM},
    {SPLKEY, "spell",  dun_aspe,    HLPSPL},
    {BARKEY, "barr",   dun_barr,    HLPBAR},
    {PWRKEY, "edit",   dun_power,   HLPPWR},
    {RPOKEY, "report", dun_reposys, HLPRPO},
    {KILKEY, "kill",   dun_killp,   HLPKIL},
    {WLKKEY, "walk",   dun_walk,    HLPWLK},
    {SALKEY, "sale",   dun_syssale, HLPSAL},
    {RESKEY, "reset",  dun_resetw,  HLPRES}
};

// player command routines     
COMMAND dunarr[]={
  {"?",          dun_help,             0,     0,     -1},
  {"appraise",   dun_appr,             0,     0,     HLPAPPR},
  {"attack",     dun_attk,             0,     0,     -1},
  {"blurb",      dun_blurb,            0,     0,     HLPBLURB},
  {"buy",        dun_buy,              0,     0,     HLPBUY},
  {"cast",       dun_cast,             0,     0,     HLPCAST},
  {"check",      dun_attk,             0,     0,     -1},
  {"close",      dun_clos,             0,     0,     HLPCLOSE},
  {"combat",     dun_comb,             1,     0,     HLPCOMB},
  {"convert",    dun_conv,             1,     0,     HLPCONV},
  {"deaf",       dun_deaf,             0,     0,     HLPDEAF},
  {"deposit",    dun_depo,             0,     0,     HLPDEP},
  {"dispell",    dun_adis,             0,     0,     HLPDISP},
  {"drink",      dun_drnk,             0,     0,     HLPDRNK},
  {"drop",       dun_drop,             0,     0,     HLPDROP},
  {"e",          dun_dirh,             0,     0,     -1},
  {"east",       dun_dirh,             0,     0,     -1},
  {"exit",       dun_gbye,             0,     0,     -1},
  {"fix",        dun_fix,              0,     0,     HLPFIX},
  {"get",        dun_get,              1,     0,     HLPGET},
  {"heal",       dun_heal,             1,     0,     HLPHEAL},
  {"help",       dun_help,             0,     0,     -1},
  {"high",       dun_high,             0,     0,     -1},
  {"hit",        dun_attk,             0,     0,     -1},
  {"inventory",  dun_inv,              0,     0,     HLPINVI},
  {"items",      dun_item,             0,     0,     HLPITEM},
  {"jab",        dun_attk,             0,     0,     -1},
  {"kick",       dun_attk,             0,     0,     -1},
  {"list",       dun_lspe,             0,     0,     HLPLIST},
  {"lock",       dun_lock,             0,     0,     HLPLOCK},
  {"look",       dun_look,             0,     0,     HLPLOOK},
  {"map",        dun_mapw,             0,     0,     HLPMAP},
  {"markdown",   dun_mrkd,             0,     0,     HLPMD},
  {"markup",     dun_mrku,             0,     0,     HLPMU},
  {"memorize",   dun_memo,             0,     0,     HLPMEM},
  {"n",          dun_dirh,             0,     0,     -1},
  {"north",      dun_dirh,             0,     0,     -1},
  {"open",       dun_open,             0,     0,     HLPOPEN}, 
  {"point",      dun_staf,             0,     0,     HLPPOINT}, 
  {"punch",      dun_attk,             0,     0,     -1},
  {"quit",       dun_gbye,             0,     0,     -1},
  {"read",       dun_rdsc,             0,     0,     HLPREAD},
  {"remove",     dun_remo,             0,     0,     HLPREMO},
  {"report",     dun_repo,             0,     0,     HLPREPO},
  {"ressurect",  dun_ress,             0,     0,     HLPRESS},
  {"s",          dun_dirh,             0,     0,     -1},
  {"say",        dun_talk,             1,     0,     -1},
  {"score",      dun_score,            0,     0,     HLPSCORE},
  {"scratch",    dun_attk,             0,     0,     -1},
  {"scream",     dun_talk,             1,     0,     -1},
  {"secure",     dun_secr,             0,     0,     HLPSECR},
  {"sell",       dun_sell,             0,     0,     HLPSELL},
  {"shout",      dun_talk,             1,     0,     -1},
  {"sign",       dun_sign,             0,     0,     HLPSIGN},
  {"sing",       dun_talk,             1,     0,     -1},
  {"slap",       dun_attk,             0,     0,     -1},
  {"south",      dun_dirh,             0,     0,     -1},
  {"stat",       dun_stat,             0,     0,     HLPSTAT},
  {"steal",      dun_stea,             0,     0,     HLPSTEA},
  {"stock",      dun_stok,             0,     0,     HLPSTOCK},
  {"stores",     dun_strs,             0,     0,     HLPLISS},
  {"sys",        dun_sys,              0,     1,     -1},
  {"take",       dun_get,              1,     0,     -1},
  {"telepath",   dun_telp,             1,     0,     -1},
  {"throw",      dun_thro,             0,     0,     HLPTHRO},
  {"travel",     dun_trav,             0,     0,     HLPTRAV},
  {"unlock",     dun_unlo,             0,     0,     HLPUNLO},
  {"unstock",    dun_unst,             0,     0,     HLPUNST},
  {"w",          dun_dirh,             0,     0,     -1},
  {"wear",       dun_wear,             0,     0,     HLPWEAR},
  {"west",       dun_dirh,             0,     0,     -1},
  {"who",        dun_who,              0,     0,     HLPWHO},
  {"wield",      dun_wiel,             1,     0,     HLPWIE},
  {"withdrawl",  dun_with,             0,     0,     HLPWITH},
  {"x",          dun_gbye,             0,     0,     -1},
  {"yell",       dun_talk,             1,     0,     -1}
};

CLASS classptr[] = {
  {"Mutant Thief",       15, 9,  8,  14, 15, 16, 18, 200,  250},
  {"Mutant Barbarian",   20, 12, 13, 17, 17, 14, 30, 750,  150},
  {"Mutant Wizard",      14, 17, 17, 13, 14, 15, 23, 1000, 150},
  {"Mutant Warrior",     23, 12, 14, 20, 19, 9,  40, 750,  200},
  {"Mutant Mage",        18, 23, 20, 16, 15, 20, 28, 1200, 250},
};

LEVEL levelptr[] = {
 {{30000L,     /* level 2  exp required */
   70000L,     /* level 3  exp required */
   100000L,    /* level 4  exp required */
   200000L,    /* level 5  exp required */
   300000L,    /* level 6  exp required */     
   500000L,    /* level 7  exp required */
   750000L,    /* level 8  exp required */
   900000L,    /* level 9  exp required */
   1000000L,   /* level 10 exp required */
   1300000L},   /* level 11 exp required */
   {2,  2,  3,  3,  3,  4,  4,  4,  4,  5},       /* str     */
   {2,  3,  3,  3,  4,  4,  4,  4,  4,  5},       /* int     */
   {2,  2,  2,  2,  2,  3,  3,  3,  3,  4},       /* wis     */
   {2,  2,  2,  3,  3,  4,  4,  4,  4,  5},       /* dex     */
   {3,  3,  4,  4,  4,  4,  4,  4,  4,  5},       /* con     */
   {3,  3,  3,  3,  4,  4,  4,  4,  5,  5},       /* cha     */
   {3,  3,  4,  4,  4,  5,  5,  5,  5,  7},       /* max hp  */
   {1,  1,  0,  1,  0,  1,  1,  1,  1,  0}},      /* spells  */

 {{40000L,     /* level 2  exp required */
   80000L,     /* level 3  exp required */
   120000L,    /* level 4  exp required */
   220000L,    /* level 5  exp required */
   320000L,    /* level 6  exp required */ 
   450000L,    /* level 7  exp required */
   600000L,    /* level 8  exp required */
   800000L,    /* level 9  exp required */
   1000000L,   /* level 10 exp required */
   1200000L},   /* level 11 exp required */
   {3,  3,  3,  4,  4,  5,  6,  7,  8,  8},       /* str     */
   {1,  1,  1,  2,  2,  2,  3,  3,  3,  4},       /* int     */
   {1,  1,  1,  1,  1,  2,  2,  2,  2,  2},       /* wis     */
   {3,  3,  3,  4,  4,  4,  5,  5,  5,  6},       /* dex     */
   {4,  4,  5,  5,  6,  6,  6,  7,  7,  7},       /* con     */
   {2,  2,  2,  2,  2,  2,  3,  3,  3,  3},       /* cha     */
   {4,  4,  4,  5,  5,  5,  5,  6,  6,  7},       /* max hp  */
   {1,  1,  1,  1,  1,  1,  1,  1,  1,  0}},      /* spells   */
   
 {{40000L,      /* level 2  exp required */
   80000L,      /* level 3  exp required */
   140000L,     /* level 4  exp required */
   250000L,     /* level 5  exp required */
   450000L,    /* level 6  exp required */ 
   650000L,    /* level 7  exp required */
   900000L,    /* level 8  exp required */
   1100000L,    /* level 9  exp required */
   1350000L,    /* level 10 exp required */
   1800000L},   /* level 11 exp required */
   {1,  1,  1,  2,  2,  2,  2,  2,  2,  3},       /* str     */
   {3,  3,  4,  5,  6,  6,  6,  7,  7,  7},       /* int     */
   {2,  2,  3,  3,  4,  4,  5,  5,  6,  7},       /* wis     */
   {1,  1,  1,  2,  2,  2,  3,  3,  4,  4},       /* dex     */
   {2,  2,  2,  2,  2,  3,  3,  3,  4,  4},       /* con     */
   {3,  4,  5,  5,  5,  5,  6,  6,  7,  8},       /* cha     */
   {1,  2,  2,  3,  4,  4,  4,  4,  4,  5},       /* max hp  */
   {1,  1,  1,  1,  1,  2,  2,  2,  2,  0}},      /* spells  */
   
 {{50000L,    /* level 2  exp required */
   130000L,    /* level 3  exp required */
   270000L,    /* level 4  exp required */
   420000L,   /* level 5  exp required */
   620000L,   /* level 6  exp required */  
   950000L,   /* level 7  exp required */
   1300000L,   /* level 8  exp required */
   1650000L,   /* level 9  exp required */
   1990000L,   /* level 10 exp required */
   2400000L},   /* level 11 exp required */
   {8,  8,  9,  10,  12,  15,  18,  20,  22,  25},    
   {1,  1,  1,  1,  1,  1,  1,  1,  1,  1},     
   {1,  1,  1,  1,  1,  1,  1,  1,  1,  1},     
   {3,  5,  7,  8,  10,  12,  15,  18,  22,  25}, 
   {3,  4,  6,  8,  10,  11,  13,  15,  18,  20},
   {1,  1,  1,  1,  1,  1,  1,  1,  1,  1},      
   {5,  6,  8,  10, 10, 10, 10, 12,  15, 20},    
   {0,  0,  0,  1,  0,  0,  0,  1,  0,  0}},     
   
 {{40000L,     /* level 2  exp required */
   90000L,     /* level 3  exp required */
   200000L,    /* level 4  exp required */
   520000L,    /* level 5  exp required */
   850000L,   /* level 6  exp required */      /* MUTANT DARK WIZARD */
   1200000L,   /* level 7  exp required */
   1650000L,   /* level 8  exp required */
   2000000L,   /* level 9  exp required */
   2700000L,   /* level 10 exp required */
   3000000L},   /* level 11 exp required */
   {3,  3,  3,  4,  4,  4,  4,  4,  4,  5},       /* str     */
   {8,  8,  8,  9,  9,  9,  9,  9,  9,  10},      /* int     */
   {7,  8,  8,  9,  9,  10, 10, 10, 11, 11},       /* wis     */
   {1,  2,  3,  4,  4,  4,  4,  5,  5,  5},       /* dex     */
   {2,  3,  4,  5,  6,  5,  5,  5,  6,  7},       /* con     */
   {8,  8,  8,  9,  10, 11, 12, 13, 14, 15},       /* cha     */
   {4,  4,  4,  5,  5,  7,  8,  9,  10, 12},       /* max hp  */
   {2,  3,  4,  4,  2,  2,  1,  1,  1,  0}},      /* spells  */
};
   
SPELLS pspelptr[] = {
  {"Light",             30,  1,    dun_ligs,   dun_dislig,  7000L,     500,   -1,   HLPLIGH},
  {"Dispell Magic",     30,  1,    dun_dismag, NULL,        10000L,      0,   -1,   HLPDISPM},
  {"Search",            30,  2,    dun_searc,  NULL,        10000L,      0,   -1,   HLPSEARC},
  {"Darkness",          60,  1,    dun_darks,  NULL,        13000L,      0,   -1,   HLPDARK},
  {"Invisibility",      60,  1,    dun_invi,   dun_disin,   10000L,   1000,   -1,   HLPINV},
  {"Find",              30,  2,    dun_find,   NULL,        5000L,       0,   -1,   HLPFIN},
  {"Hide",              30,  1,    dun_hide,   dun_nhide,   15000L,   1500,   -1,   HLPHIDE},
  {"Write",             60,  2,    dun_write,  NULL,        100000L,     0,   -1,   HLPWRI},
  {"Area Lock",         240, 1,    dun_clai,   NULL,        200000L,     0,   18,   HLPALO},
  {"Wall of ice",       120, 2,    dun_ices,   NULL,        50000L,      0,   -1,   HLPWOIC}, 
  {"Ion Force Field",   240, 2,    dun_forc,   NULL,        400000L,     0,   256,  HLPIFC},
  {"Summon Creature",   240, 2,    dun_summ,   NULL,        250000L,     0,   -1,   HLPSUC},
  {"Command Creature",  60,  2,    dun_comm,   NULL,        2000L,       0,   -1,   HLPCOM},
  {"Poison Bolt",       120, 2,    dun_pois,   NULL,        30000L,      0,   -1,   HLPPOI},
  {"Clone",             120, 2,    dun_clone,  NULL,        100000L,     0,   200,  HLPCLON},
  {"Enchantment",       120, 2,    dun_ench,   NULL,        100000L,     0,    26,  HLPENCH},
  {"Magical Dexterity", 120, 1,    dun_mdex,   dun_nodex,   10000L,   2000,   -1,   HLPMDEX},
  {"Lightning Bolt",    240, 2,    dun_lich,   NULL,        25000L,      0,   -1,   HLPLIGHT},
  {"Meteor Swarm",      240, 1,    dun_mesw,   NULL,        100000L,     0,   -1,   HLPMETS},
  {"Hercules Strength", 120, 1,    dun_hstr,   dun_nostr,   10000L,   2000,  214,   HLPHST},
};
   
void dungdef(void)
{
  dunsiz = (sizeof(dunarr)/sizeof(COMMAND));
  sizspell = (sizeof(pspelptr)/sizeof(SPELLS));
  syssiz = (sizeof(sysop) / sizeof(SYSOP));
}
