/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~
*   MJSMUTH.H                                                             *
*   Version 2.30                                                          *
*   Copyright (C) 1991-93, MajorSoft Inc. and Eric Furrer                 *
*   This is the MUTANTS! header file                                      *
*   for the MajorBBS version 6.xx +                                       *
*   E. Furrer      12/24/91        "it's not how you play the game,       *
*                                   it's if you win or lose."             *
*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/
 
/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
 *                                DEFINE'S                                 *
 *~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/
#define MUTANTS  1
#define LINKFLG  2
#define LIVE     4
 
#define HOSTILE doptions.aggress

#define ENTERED   0     /* entered the game substate */
#define INMENUS   1     /* in the menu's substate    */ 
#define PLAYING   2     /* playing substate          */
#define SELCLASS  3     /* select class substate     */
#define KILLED    4     /* player is dead - reset    */
#define WORLDSC   5     // MUTANT LINK OPTION: DO NOT CHANGE
#define CALLING   6     // MUTANT LINK OPTION: DO NOT CHANGE
#define RECEIVING 7     // MUTANT LINK OPTION: DO NOT CHANGE

#define MAINLM    0     // Mutantlink substate

#define BAIT 265      /* monster bait              */

#define PLYROOM dun_getrm(dunwho->dunxc, dunwho->dunyc, dunwho->dunzc)                      /* players room                */
#define OTHROOM dun_getrm(dunoth->dunxc, dunoth->dunyc, dunoth->dunzc)
#define PLYCORD dunwho->dunxc, dunwho->dunyc, dunwho->dunzc                              /* player co-ordinates         */        
#define PLYNDIR dun_getrm(dunwho->dunxc+genx[dir], dunwho->dunyc+geny[dir], dunwho->dunzc+genz[dir])  /* player cord + direction */

#define SEX (dunwho->dunaptr.plysex == 0 ? "his" : "her")  /* what sex is player? */
#define SEX2 (dunwho->dunaptr.plysex == 0 ? "he" : "she")  /* he or her?          */

#define ITEMSCAN pitemptr[dunwho->dunite[i]]      /* search item  */

#define DUNTIME2 10   /* rtkick routine 1 in seconds */
#define DUNTIMER 5    /* rtkick routine 2 in seconds */
#define MONTIME 2     /* rtkick routine 3 in seconds */
#define DUNTIME3 10   /* rtkick routine 4 in seconds */
#define DUNTIME4 10   /* rtkick routine 5 in seconds */

#define MAXPLEVL 10   /* maximum player levels defined */

#define MAXCLASS 5    /* maximum player classes */

#define MAXSTR (dunwho->dunstr * 5)     /* maximum strength - player gets   */

#define SATAN   166                       /* the power monster              */
#define SATSWD  266                       /* power weapon                   */
#define SATARM  267                       /* power armor                    */                    

#define MAXSPELL 20                     /* maximum spells a player carries */

#define SWORD 0                         /* item = sword  */
#define SKULL 1                         /* item = skull  */
#define ARMOR 2                         /* item = armor  */
#define STAFF 3                         /* item = staff  */
#define KEY 4                           /* item = key    */
#define SCROLL 5                        /* item = scroll */
#define POTION 6                        /* item = potion */
#define MISC 7                          /* item = misc   */

#define NONE4 "\0","\0","\0","\0"       /* macros for dun_msg and dun_prf */
#define NONE3 "\0","\0","\0"            /*  "        "        "       "   */
#define NONE2 "\0","\0"                 /*  "        "        "       "   */
#define NONE1 "\0"                      /*  "        "        "       "   */

#define VERSION mutants_version         /* mutants active version         */
#define BUFFER  sprint_buffer           /* buffer to hold text to sprintf */

#define YELLOW "[1;33m"
#define CYAN   "[1;36m"
#define WHITE  "[1;37m"
#define BLUE   "[1;34m"
#define GREEN  "[1;32m"
#define RED    "[1;31m"
#define GREY   "[0m"

#define NAMSIZ 30                      /* max name size of alias           */

#define WALK   0x00000001L             // walking through walls flag
#define LIGHT  0x00000002L             // player has light source
#define INVIS  0x00000004L             // player invisible
#define HIDDEN 0x00000008L             // player is hidden
#define DEAF   0x00000010L             // player deaf option
#define BLURB  0x00000020L             // player blurb option
#define ENCUMD 0x00000040L             // player encumbered


/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
 *                            PLAYER STRUCTURE                             *
 *~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

typedef struct player {
  char dunname[30];          /* user id              */
  int  duncla;               /* player/monster class */
  int  dunxc;                /* x location           */
  int  dunyc;                /* y location           */
  int  dunzc;                /* z location           */
  int  dunhp;                /* hit points           */
  int  maxhp;                /* max hp's             */
  int  dunlev;               /* level                */
  long dunscr;               /* experience           */
  int  dunint;               /* intelegence          */
  int  dunstr;               /* strength             */
  int  dunwis;               /* wisdom               */
  int  duncha;               /* charisma             */
  int  duncon;               /* constitution         */
  int  dundex;               /* dexterity            */
  int  dunite[10];           /* items in sac         */
  int  dunist[10];           /* item statistics      */
  int  dunspe[20];           /* spells on hand       */
  int  dunarm;               /* wearing armour       */
  int  dunast;               /* armour stat          */
  long dungold;              /* gold pieces          */
  long spcomp;               /* spell components     */
  int  dundead;              /* player dead flag     */
  int  poison;               /* player poisoned      */
  char dunfre[200-156];      /* free file space      */
  
  struct dunarec {
    int plysex;              /* sex of player            */
    int exhaust;             /* exaustion level          */    
    int totwt;               /* total wieght of items    */
    int lespe;               /* length of spell duration */
    int dunrsp;              /* readied spell            */
    int dunmsp;              /* is spell memorized       */
    int summon;              /* monster summoning        */
    int stt;                 /* player status            */
    int combat;              /* player cant exit->combat */
    int lstt;                /* mutantlink status        */
    char pcomba[30];         /* who is player combatting */
    int  displink;           // flag reserved for mutantlink - do not change
    unsigned long mutflags;  // general purpose flags
    long btvpos;             // current btrieve file position
  } dunaptr;
};

#define PLAYER struct player

typedef struct maprec {
  char play_map[10][10];
} PLAYMAP;

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
 *                            ROOM STRUCTURE                               *
 *~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/
 
typedef struct proomrec {
  char prmin[10];         /* room index (x)+(y)+(z)       */
  long prind;             /* room index by rec #          */
  int  prmdir[4];         /* room direction               */
  int  prmst;             /* room stat - fall etc         */
  int  trade;             /* trading allowed here?        */
  int  maint;             /* weopon maintenace allowed?   */
  int  dark;              /* dark in room?                */
  int  pitem[6];          /* items                        */
  int  pitst[6];          /* item statistics              */
  char portal[10];        /* portal to another section    */
  char bared[30];         /* barred player from this room */
  char sign[50];          /* a sign in an area            */
  char prmfre[150-144];   /* free bytes available in file */
} ROOMS;

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
 *                        PLAYER CLASS STRUCTURE                           *
 *~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/
 
typedef struct classrec { 
  char clanam[20];         /* class name */
  int  cminstr;            /* min str */
  int  cminint;            /* min int */
  int  cminwis;            /* min wis */
  int  cmindex;            /* min dex */
  int  cmincon;            /* min con */
  int  cmincha;            /* min cha */
  int  maxchp;             /* max hp's for class */
  int  plheal;             /* healing cost per level */
  int  ioncon;             /* ion consumption/10 secs */
} CLASS;

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
 *                        PLAYER LEVEL STRUCTURE                           *
 *~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/
 
typedef struct levelrec {
  long reqexp[10];        /* required experience for that level */
  int  strinc[10];        /* strength incrementor               */
  int  intinc[10];        /* intellegence incrementor           */
  int  wisinc[10];        /* wisdom incrementor                 */
  int  dexinc[10];        /* dexterity incrementor              */
  int  coninc[10];        /* constitution incrementor           */
  int  chainc[10];        /* charisma incrementor               */
  int  mhpinc[10];        /* maximum hp incrementor             */
  int  mspell[10];        /* spell incrementor                  */
} LEVEL;

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
 *                            ITEM STRUCTURE                               *
 *~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/
 
typedef struct pitemrec {
  long itemind;          /* item index           */
  char pitnam[20];       /* item name            */
  int  pddam;            /* damage item will do  */
  int  pdspe;            /* special item + or -  */
  int  pitty;            /* item type            */ 
  int  pdsta;            /* item statistic       */
  long value;            /* value of item in gld */
  long fixval;           /* charge for repair    */
  int  wieght;           /* item wieght          */
  char itemfree[50-42];  /* free file space      */
} ITEMS;

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
 *                           SPELL STRUCTURE                               *
 *~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

typedef struct pspelrec {
  char spenam[20];   /* spell name                      */
  int  spemem;       /* memorize time                   */
  int  hwords;       /* how many words needed to cast   */
  void (*spout)();   /* item routine call               */
  void (*dispel)();  /* dispelled call                  */
  long castcost;     /* casting cost in ion comps       */
  long durcost;      /* cost*level / sec to maint       */
  int  speitem;      /* item required for casting spell */
  int  hlpspell;     /* help for spells                 */
} SPELLS;

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
 *                         MONSTER CLASS STRUCTURE                         *
 *~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/
 
typedef struct pmonsrec {
  long monind;             /* monster record number                  */
  char monnam[20];         /* monster name                           */
  char montal[20];         /* monster way of talking                 */
  char monbat[30];         /* battle phrase                          */
  int  monite[3];          /* what 3 items can a monster have?       */
  int  monarm;             /* what armor can the monster wear?       */
  int  monlev;             /* what level is this monster?            */
  char monspe[30];         /* special attack phrase                  */
  int  monatdm;            /* special attack damage                  */
  int  monattu;            /* special attacks (higher = less freq)   */
  int  monspell;           /* what spell does it have                */
  int  spebon;             /* bonus + to items                       */
  char monsfree[130-122];  /* free file space                        */ 
} MONSTER;

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
 *                             STORES STRUCTURE                            *
 *~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

typedef struct psalerec {
  char rmind[10];          /* room index                    */
  char namind[30];         /* player index                  */
  int itsale[20];          /* items for sale                */
  int itstat[20];          /* item stats                    */
  long markup;             /* markup of items when sold     */
  long markdown;           /* markdown of items when bought */
  long cash;               /* how much cash does store have */
  long taxrate;            /* taxed rate of store / night   */
  long sellval;            /* selling value                 */
  long security;           /* security of store             */
  char freesale[150-144];  /* free file space               */
} SALES;

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
 *                         EVENT LOGS STRUCTURE                            *
 *~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

typedef struct logrec {
  char logind[30];         /* log index                     */
  char logdes[100];        /* description of log            */
  long logstat;            /* stat for functions            */
  char logfree[150-134];   /* free file space               */
} LOGS;

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
 *                         HIGH SCORE STRUCTURE                            *
 *~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

typedef struct dhghrec {
  char hghnam[30];         /* name index          */
  long hghscr;             /* score index         */
  long hghwrth;            /* player worth        */
  int  highflag;           /* flag for high score */
  char reserved[6];        /* reserved 4 byte ctr */
  char hghfree[50-46];     /* free file space     */
} DUNHGH;

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
 *                         KEYWORD HANDLER STRUCTURE                       *
 *~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

typedef struct duncmd {
  char *duncom;
  void (*dunout)();
  int  liveonly;
  int  sysonly;
  int  cmdhlp;
} COMMAND;


/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
 *                           SYSOP OPTIONS STRUCTURE                       *
 *~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/
 
typedef struct syscorec {
    int  keyreq;                   // key required to do routine
    char syscom[10];               // sysop command
    void (*sysrout)();             // sysop routine
    int  syshelp;                  // sysop help message
} SYSOP;

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
 *                           CNF OPTIONS STRUCTURE                         *
 *~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

typedef struct dunsyso {
  int maxmonst;
  int cachesize;
  long inisell;
  long startax;
  int stormu;
  int stormd;
  int dunclean;
  int range;
  int maxmove;
  int comtime;
  int monexp;
  int aggress;
  int mxwgt;
  long resthf;           // cost of ress. thief
  long resbar;           // cost of ress. barb.
  long reswiz;           // cost of ress. wizard
  long reswar;           // cost of ress. warrior
  long resmag;           // cost of ress. mage
  int  levtpl;           // level thief needs to steal from players
  long crdrte;           // riblets needed for 1 credit
  long ionrte;           // riblets needed for 1 ion
  int  dsplog;           // display logon message
  int  dspcrd;           // display credit purchasing to console
  int  maxyr;            // maximum year a player can travel to
  int  penpl;            // penalize players if carrier dropped
  long maxplp;           // max points awarded for killing other user
  int  surcharge;        // credit surcharge
} SYSOPT;

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
 *                           USER TABLE STRUCTURE                          *
 *~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/
typedef struct temp_tab {
  int table;
} TABLE;

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
 *                        REGENERATED ITEMS STRUCTURE                      *
 *~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/
 
 typedef struct regenrec {
   int regen_ptr[100];
   int regen_stat[100];
   int regen_size;
} REGEN;

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
 *                                GLOBALS                                  *
 *~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

extern
int dusrnum, 
    dmargc, 
    plybas,
    monstart, 
    maxcreat, 
    nextmon, 
    monturn, 
    moncltu, 
    genx[], 
    geny[], 
    genz[], 
    hlpmsg, 
    dunsiz, 
    syssiz,
    sizspell, 
    gloflag, 
    maxtypes, 
    itemsiz,
    mutstt;          // mutants module substate - mutantlink

extern    
long maxroom;

extern 
int activate;

extern
char dmargv[20][200], 
     *gendir[],
     BUFFER[255],
     VERSION[],
     message[60];

extern char huge *player;

extern PLAYER *dunwho,
               dunglb;

extern PLAYMAP *mutmap;

extern ROOMS proomptr, 
             *cacheptr;
	    
extern ITEMS *pitemptr;
extern CLASS classptr[];
extern SPELLS pspelptr[];
extern MONSTER *pmonsptr;
extern LEVEL levelptr[];
extern SALES psaleptr;
extern LOGS mlogptr;
extern DUNHGH dhghptr;
extern COMMAND dunarr[];
extern SYSOPT doptions;
extern REGEN regenptr;
extern TABLE *tableptr;
extern SYSOP sysop[];

extern BTVFILE *pplybb,
               *proombb,
               *psalebb,
               *plogbb,
               *dhghbb,
               *monsbb,
               *itembb,
	       *headbb,       // mutantlink
	       *intbb;        // mutantlink

extern FILE *dunmb;

    
