/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~
*   MJSMUTMA.C                                                            *
*   Version 2.30                                                          *
*   Copyright (C) 1991-93, MajorSoft Inc. and Eric Furrer                 *
*   This is the MUTANTS! mainline                                         *
*   for the MajorBBS version 6.xx +                                       *
*   E. Furrer      12/24/91        "it's not how you play the game,       *
*                                   it's if you win or lose."             *
*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

#include "gcomm.h"
#include "majorbbs.h"
#include "mjsmutx.h"         /* msg header file                       */
#include "mjsmuth.h"         /* mutants header file                   */
#include "mjsmutp.h"         /* mutants prototype file                */

void EXPORT init__mutants(void);
int  dun_logon(void);
int  dun_main(void);
void dun_hang(void);
void dun_clean(void);
void dun_delete(char *uid);
void dun_shut(void);

struct module mutantmod={    /*    module interface block            */
    "",                      /*    name used to refer to this module */
    dun_logon,               /*    user logon supplemental routine   */
    dun_main,                /*    input routine if selected         */
    ml_stat,                 /*    status-input routine if selected  */
    NULL,                    /*    "injoth" routine for this module  */
    NULL,                    /*    user logoff supplemental routine  */
    dun_hang,                /*    hangup (lost carrier) routine     */
    dun_clean,               /*    midnight cleanup routine          */
    dun_delete,              /*    delete-account routine            */
    dun_shut                 /*    finish-up (sys shutdown) routine  */
};

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
*                           COMMAND HANDLER                               *
*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

struct duncmd *pasearch(dunptr, duntab, dunlen)
char *dunptr;
struct duncmd duntab[];
int dunlen;
{
    int cond;
    struct duncmd *low,*mid,*high;
    low=&duntab[0];
    high=&duntab[dunlen-1];
    while (low <= high) {
        mid=low+((int)(high-low))/2;
        if (strlen(dunptr) < 3) cond=strcmp(dunptr,mid->duncom);
        else cond=strncmp(dunptr,mid->duncom,strlen(dunptr));
        if (cond < 0) {
            if (mid == low) {
                break;
            }
            high=mid-1;
        }
        else if (cond > 0) {
            if (mid == high) {
                break;
            }
            low=mid+1;
        }
        else {
            strncpy(dmargv[0], mid->duncom, 20);
            return(mid);
        }
    }
    return(NULL);
}


/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
*                       SYSTEM INITIALIZATION ROUTINE                     *
*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

void EXPORT
init__mutants(void)
{
    char *getmsg();
    int mptr, msx, mex, mctr, mx;
    static char savebf[4000];
    int ii, ctr, ctr2, linc, lctr, sx;
    unsigned n;
    long tindex;
    static long dunlo=0x80000001L, dunhi=0x7FFFFFFFL;
    MONSTER tempmons;
    ITEMS tempitem;
    stzcpy(mutantmod.descrp, gmdnam("MJSMUT.MDF"), MNMSIZ);
    mutstt = register_module(&mutantmod);
    usrnum = -1;
    randomize();
    dunmb=opnmsg("MJSMUTX.MCV");
    setmbk(dunmb);
    doptions.maxmonst = numopt(MAXMONST, 0, 9999);
    doptions.cachesize = (numopt(CACHESZ, 0, 30000) / sizeof(ROOMS));
    doptions.startax = lngopt(STARTAX, dunlo, dunhi);
    doptions.inisell = lngopt(INISELL, dunlo, dunhi);
    doptions.stormu = numopt(STORMU, -1000, 1000);
    doptions.stormd = numopt(STORMD, -1000, 1000);
    doptions.range = numopt(ORANGE, 0, 50);
    doptions.maxmove = numopt(OMAXMOV, 0, 10);
    doptions.comtime = numopt(OCOMTIM, 0, 1000);
    doptions.mxwgt = numopt(MXWIEGHT, 0, 100);
    doptions.resthf = lngopt(RESTHF, dunlo, dunhi);
    doptions.resbar = lngopt(RESBAR, dunlo, dunhi);
    doptions.reswiz = lngopt(RESWIZ, dunlo, dunhi);
    doptions.reswar = lngopt(RESWAR, dunlo, dunhi);
    doptions.resmag = lngopt(RESMAG, dunlo, dunhi);
    doptions.levtpl = numopt(LEVTPL, 0, 100);
    doptions.crdrte = lngopt(CRDRTE, dunlo, dunhi);
    doptions.ionrte = lngopt(IONRTE, dunlo, dunhi);
    doptions.dspcrd = ynopt(DSPCRD);
    doptions.dsplog = ynopt(DSPLOG);
    doptions.maxyr = numopt(MAXYR, 5000, 9900);
    doptions.penpl = numopt(PENPL, 0, 100);
    doptions.maxplp = lngopt(MAXPLP, dunlo, dunhi);
    doptions.surcharge = numopt(SURCHRG, 0, 600);
    HOSTILE = numopt(AGGRESS, 1, 20);
    proombb=opnbtv("MJSROOM.DAT", sizeof(ROOMS));
    psalebb=opnbtv("MJSSALE.DAT", sizeof(SALES));
    pplybb=opnbtv("MJSPLY.DAT", sizeof(PLAYER));
    plogbb=opnbtv("MJSLOG.DAT", sizeof(LOGS));
    dhghbb=opnbtv("MJSHGH.DAT", sizeof(DUNHGH));
    monsbb=opnbtv("MJSMONS.DAT", sizeof(MONSTER));
    itembb=opnbtv("MJSITEM.DAT", sizeof(ITEMS));
    ml_init();
    monstart = nterms;
    maxcreat = monstart + doptions.maxmonst;
    nextmon = monstart;
    #ifndef PHARLAP
    if ((player=getml((long)(maxcreat+1)*(long)sizeof(struct player))) == NULL) {
        memcata();
    }
    #else
    plybas=pltile((long)(maxcreat+1)*(long)sizeof(struct player),0,
    sizeof(struct player), sizeof(struct player));
    player=MK_FP(plybas, 0);
    #endif
    #ifdef ECLIPSE
    if ((plybas=ecltile(player, sizeof(struct(player))) == 0) {
        catastro("PLAYER: NOT ENOUGH SELECTORS");
    }
    #endif
    for (ii=0; ii<maxcreat; ii++) {
        setmem(getply(ii), sizeof(struct player), 0);
        getply(ii)->dunaptr.stt = 0;
        getply(ii)->dunaptr.lstt = 0;
    }
    mutmap=(PLAYMAP *)alcmem((unsigned)(n=((nterms+1) * sizeof(PLAYMAP))));
    setmem(mutmap, n, 0);
    tableptr = (TABLE *)alcmem((unsigned)(n=((nterms+1) * sizeof(TABLE))));
    setmem(tableptr, n, 0);
    cacheptr =(ROOMS *)alcmem((unsigned)(n=(doptions.cachesize+3)*sizeof(ROOMS)));
    for (n = 0; n < doptions.cachesize; n++) {
        setmem(cacheptr[n].prmin, 10, 0);
    }
    setbtv(proombb);
    maxroom = 0L;
    if (qhibtv(1)) {
        gcrbtv(&proomptr, 1);
        maxroom = proomptr.prind;
    }
    else catastro("No rooms found.");
    maxroom++;
    moncltu = 0;
    gloflag = 0;
    doptions.dunclean = 0;
    setbtv(monsbb);
    if (qhibtv(0)) {
        gcrbtv(&tempmons, 0);
    }
    else catastro("NO MONSTERS ON FILE");
    maxtypes = (int)tempmons.monind;
    maxtypes++;
    pmonsptr=(MONSTER *)alcmem(n=(maxtypes + 1)*sizeof(MONSTER));
    setmem(pmonsptr, n, 0);
    tindex = 0;
    if (qeqbtv(&tindex, 0)) {
        ctr = 0;
        do {
            gcrbtv(&pmonsptr[ctr], 0);
            ctr++;
        } while (qnxbtv());
    }
    else catastro("CANNOT FIND FIRST MONSTER RECORD");
    setbtv(itembb);
    if (qhibtv(0)) {
        gcrbtv(&tempitem, 0);
    }
    else catastro("NO ITEMS ON FILE");
    itemsiz = (int)tempitem.itemind;
    itemsiz++;
    pitemptr=(ITEMS *)alcmem(n=(itemsiz * sizeof(ITEMS)));
    setmem(pitemptr, n, 0);
    tindex = 0;
    if (qeqbtv(&tindex, 0)) {
        ctr = 0;
        do {
            gcrbtv(&pitemptr[ctr], 0);
            ctr++;
        } while (qnxbtv());
    }
    else catastro("CANNOT FIND FIRST ITEM RECORD");
    ctr2 = 0;
    for (ctr = 0; ctr < itemsiz; ctr++) {
        if (pitemptr[ctr].pitty == MISC) {
            regenptr.regen_ptr[ctr2] = ctr;
            regenptr.regen_stat[ctr2] = pitemptr[ctr].pdsta;
            ctr2++;
        }
    }
    movmem(frzseg(), savebf, 4000);
    sx = drawit();
    linc = maxcreat - monstart;
    linc = linc / 15;
    mptr = 0; 
    msx = 27;
    mex = 55;
    for (lctr = msx; lctr < mex; lctr++) {
        frzseg()[(lctr*2)+(13*160)] = message[mptr];
	frzseg()[(lctr*2)+(13*160)+1] = 14;
	mptr++;
    }
    lctr = 0;
    mctr = 0;
    regenptr.regen_size = ctr2;
    for (ii = monstart; ii < maxcreat; ii++) {
        dun_genmo(ii);
        if (lctr > linc) {
            frzseg()[(sx*2)+(20*160)] = 178;
            frzseg()[(sx*2)+(20*160)+1] = 14;
            sx++;
            lctr = 0;
        }
        lctr++;
	mctr++;
	if (mctr > 3) {
	    for (mx = msx; mx < mex-1; mx++) {
	        frzseg()[(mx*2)+(13*160)] = frzseg()[((mx+1)*2)+(13*160)];
	    }
	    frzseg()[((mex-1)*2)+(13*160)] = message[mptr];
	    mptr++;
	    if (mptr > (strlen(message)-1)) {
	        mptr = 0;
	    }
	    mctr = 0;
	}
    }
    movmem(savebf, frzseg(), 4000);
    dun_timer2();
    dun_timer();
    dun_montime();
    dun_regni();
    dun_monbait();
    dun_surcharge();
}

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
*                         USER LOG ON SUPPLEMENTAL                        *
*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/


int
dun_logon(void)
{
    if (doptions.dsplog) {
        setmbk(dunmb);
        prfmsg(LOGON, CYAN);
        if (activate&LINKFLG) {
            showhighlink();
        }
        outprf(usrnum);
    }
    return(0);
}

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
*                           CARRIER LOST ROUTINE                          *
*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

void
dun_hang(void)
{
    extern kilipg;
    dunwho=getply(usrnum);
    if (dunwho->dunaptr.stt == PLAYING) {
        dusrnum = usrnum;
        dunwho->dunaptr.stt = 0;
        if (dunwho->dunaptr.combat > 0 && kilipg == 0) {
            dun_punusr();
        }
        dun_saveply();
        btupmt(dusrnum, NULL);
    }
    dunwho->dunaptr.stt = -1;
}

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
*                        MIDNIGHT CLEANUP ROUTINE                         *
*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

void
dun_clean(void)
{
    int ctr, y;
    long tscr, twrth;
    char temp[100], temp_usr[NAMSIZ], yy[4];
    doptions.dunclean = 1;
    if (ml_clean() == 0) {
        usrnum = -1;
        shocst("MUTANTS CLEANUP-1", "MUTANTS CLEANUP-1");
        setbtv(psalebb);  /* adjust the tax rates, deduct, check bankruptcies */
        if (qlobtv(0)) {
            do {
                gcrbtv(&psaleptr, 0);
                if (sameas(psaleptr.namind, "Village Shop\0")) {
                    for (ctr = 0; ctr < 20; ctr++) {
                        psaleptr.itsale[ctr] = -1;
                        psaleptr.itstat[ctr] = -1;
                    }
                    psaleptr.cash = 99999999L;
                    psaleptr.security = 9999999L;
                    updbtv(&psaleptr);
                }
                else {
                    if (!sameas(psaleptr.namind, "FOR SALE")) {
                        psaleptr.cash = psaleptr.cash - psaleptr.taxrate;
                        if (psaleptr.cash < 0) {
                            psaleptr.cash = 0;
			    setmem(yy, 4, 0);
			    usrnum = -1;
			    shocst(proomptr.prmin, yy);
			    yy[0] = proomptr.prmin[7];
			    yy[1] = proomptr.prmin[8];
			    y = atoi(yy) - 19;
                            strncpy(temp_usr, psaleptr.namind, NAMSIZ);
                            strncpy(psaleptr.namind, "FOR SALE", NAMSIZ);
			    setbtv(psalebb);
                            updbtv(&psaleptr);
                            if (dun_load(psaleptr.rmind) != 0) {
                                proomptr.trade = 2;
                                setmem(proomptr.sign, 50, 0);
                                sprintf(proomptr.sign,
                                "POWER OF SALE $ %ld", (doptions.inisell*y));
                                setmem(proomptr.bared, 10, 0);
                                updcas();
                                dun_log(temp_usr,
                                "One of your stores could not meet its tax commitments.", 0);
                            }
                        }
                        else updbtv(&psaleptr);
                    }
                }
                setbtv(psalebb);
            } while (qnxbtv());
        }
        shocst("MUTANTS CLEANUP-2", "MUTANTS CLEANUP-2");
        setbtv(pplybb);    /* -1 days from dead players, reset if 0 */
        if (qlobtv(0)) {
            do {
                gcrbtv(&dunglb, 0);
                if (dunglb.dundead > -1) {
                    dunglb.dundead = dunglb.dundead - 1;
                    if (dunglb.dundead == 0) {
                        dun_resply(dunglb.duncla);
                        updbtv(&dunglb);
                        setmem(temp, 100, 0);
                        sprintf(temp,
                        "Your %s has been buried and layed to rest.",
                        classptr[dunglb.duncla].clanam);
                        dun_log(dunglb.dunname, temp, 0);
                    }
                    else updbtv(&dunglb);
                }
                if (dunglb.duncla == 0) {
                    setbtv(dhghbb);    /* update scores */
                    if (qeqbtv(dunglb.dunname, 0) == 0) {
                        strncpy(dhghptr.hghnam, dunglb.dunname, 30);
                        dhghptr.hghscr = 0;
                        dhghptr.hghwrth = 0;
                        dhghptr.highflag = 0;
                        setmem(dhghptr.reserved, 6, 0);
                        insbtv(&dhghptr);
                    }
                    tscr = 0;
                    twrth = 0;
                }
                tscr+=dunglb.dunscr;
                twrth+=dunglb.dungold;
                if (dunglb.duncla == (MAXCLASS-1)) {
                    setbtv(dhghbb);
                    if (qeqbtv(dunglb.dunname, 0)) {
                        gcrbtv(&dhghptr, 0);
                        dhghptr.hghscr = tscr;
                        dhghptr.hghwrth = twrth;
                        updbtv(&dhghptr);
                    }
                }
                setbtv(pplybb);
            } while (qnxbtv());
        }
        shocst("MUTANTS CLEANUP-3", "MUTANTS CLEANUP-3");
        setbtv(psalebb);    /*  add worth of stores to players */
        if (qlobtv(0)) {
            do {
                gcrbtv(&psaleptr, 0);
                setbtv(dhghbb);
                if (qeqbtv(psaleptr.namind, 0)) {
                    gcrbtv(&dhghptr, 0);
                    dhghptr.hghwrth = dhghptr.hghwrth + psaleptr.cash;
                    updbtv(&dhghptr);
                }
                setbtv(psalebb);
            } while (qnxbtv());
        }
        doptions.dunclean = 0;
    }
}

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
*                        DELETE ACCOUNT ROUTINE                           *
*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

void
dun_delete(char *uid)
{
    char tchr[NAMSIZ];
    PLAYER plytemp;
    setmem(tchr, NAMSIZ, 0);
    strcpy(tchr, uid);
    setbtv(plogbb);   /* remove from logs */
    if (qeqbtv(tchr, 0)) {
        do {
            gcrbtv(&mlogptr, 0);
            if (!sameas(tchr, mlogptr.logind)) break;
            delbtv();
        } while (qnxbtv());
    }
    setbtv(pplybb);
    if (qeqbtv(tchr, 0)) {   /* remove from player file */
        do {
            gcrbtv(&plytemp, 0);
            if (!sameas(tchr, plytemp.dunname)) break;
            delbtv();
        } while (qnxbtv());
    }
    setbtv(dhghbb);    /* remove from score list */
    if (qeqbtv(uid, 0)) {
        do {
            gcrbtv(&dhghptr, 0);
            if (!sameas(uid, dhghptr.hghnam)) break;
            delbtv();
        } while (qnxbtv());
    }
    setbtv(psalebb);
    if (qeqbtv(tchr, 1)) {
        do {
            gcrbtv(&psaleptr, 1);
            if (!sameas(tchr, psaleptr.namind)) break;
            psaleptr.cash = 0;
            updbtv(&psaleptr);
        } while (qnxbtv());
    }
}

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
*                         SYSTEM SHUTDOWN ROUTINE                         *
*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

void
dun_shut(void)
{
    if (doptions.dunclean < 2) {
        dun_flucas();
        clsbtv(pplybb);
        clsbtv(proombb);
        clsbtv(psalebb);
        clsbtv(plogbb);
        clsbtv(dhghbb);
        clsbtv(headbb);
        clsbtv(intbb);
    }
    clsbtv(monsbb);
    clsbtv(itembb);
    clsmsg(dunmb);
}

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
*                            MAIN INPUT ROUTINE                           *
*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

int
dun_main(void)
{
    int i, ii;
    char temp[NAMSIZ], what[255];
    dunwho=getply(usrnum);
    dusrnum = usrnum;
    dmargc = margc;
    if (margc > 0) {
        if (dmargc > 20) dmargc = 20;
        for (i=0; i<20; i++) {
            setmem(dmargv[i], 200, 0);
        }
        for (i=0; i<dmargc; i++) {
            for (ii=0; ii<strlen(margv[i]); ii++) {
                dmargv[i][ii] = tolower(margv[i][ii]);
            }
            dmargv[i][strlen(margv[i])] = '\0';
        }
    }
    else {
        strncpy(dmargv[0], "", 1);
    }
    switch(usrptr->substt) {
        case ENTERED:
        dunwho->dunaptr.stt = 1;
        dun_msg(usrnum, WELCOME, NONE4);
        dun_cmds();
        usrptr->substt = dunwho->dunaptr.stt;
        if (toupper(margv[0][0]) == 'X') return(0);
        break;
        
        case INMENUS:
        dun_cmds();
        usrptr->substt = dunwho->dunaptr.stt;
        if (toupper(margv[0][0]) == 'X') return(0);
        break;
        
        case PLAYING:
        dun_game();
        if (getply(usrnum)->dunaptr.stt == SELCLASS) dispclass();
        usrptr->substt = getply(usrnum)->dunaptr.stt;
        break;
        
        case SELCLASS:
        if (sameas(margv[0], "x")) {
            btupmt(usrnum, NULL);
            dun_msg(dusrnum, PROMPTW, NONE4);
            dunwho->dunaptr.stt = INMENUS;
        }
        else {
            if (sameas(margv[0], "BURY")) dun_bury();
            else {
                if (atoi(margv[0]) < 1 || atoi(margv[0]) > MAXCLASS) {
                    if (margv[0][0] == '?') dispclass();
                    else dun_msg(usrnum, CLASEL, NONE4);
                }
                else {
                    setmem(temp, NAMSIZ, 0);
                    strcpy(temp, uacoff(usrnum)->userid);
                    setbtv(pplybb);
                    if (qeqbtv(temp, 0)) {
                        i = 0;
                        do {
                            i++;
                            gcrbtv(dunwho, 0);
                        } while (aqnbtv(NULL) && i < atoi(margv[0]));
                    }
                    dmargc = 1;
                    if (dunwho->dundead == -1) {
                        btupmt(usrnum, '>');
                        dun_iniply();
                        dun_clrmap();
			prfmsg(STARTR);
			outprf(usrnum);
                        dun_look();
                        prf_msg(MAPP, dunwho->dunname, NONE3);
                        dun_outdun(PLYROOM, dusrnum, -1, 0);
                        dunwho->dunaptr.stt = PLAYING;
                        setmem(what, 255, 0);
                        sprintf(what, "%s %s has just arrived into this world",
                        classptr[dunwho->duncla].clanam, dunwho->dunname);
                        dun_telm(what);
                    }
                    else {
                        dun_msg(dusrnum, HRESS, NONE4);
                        dispclass();
                        dunwho->dunaptr.stt = SELCLASS;
                    }
                }
            }
        }
        break;
        // all mods hereon are for the linking option for 2.3
        case WORLDSC:
        ml_worldsc();
        break;
        case CALLING:
        ml_caller();
        break;
        case RECEIVING:
        ml_receiver();
    }
    usrptr->substt = dunwho->dunaptr.stt;
    return(1);
}

/* main entry command handler */
void
dun_cmds(void)
{
    char ptemp[NAMSIZ];
    setmbk(dunmb);
    if (sameas(margv[0], "p")) {
        if (activate&MUTANTS) {
            setmem(ptemp, NAMSIZ, 0);
            strcpy(ptemp, uacoff(usrnum)->userid);
            setbtv(pplybb);
            if (qeqbtv(ptemp, 0) == 0) {
                dun_creusr();
            }
            dun_flulog();
            dispclass();
            dunwho->dunaptr.stt = SELCLASS;
        }
        else {
            prf("Sorry, this demo has expired!\r");
            prf("Please tell your SYSOP how much you enjoy MUTANTS!\r");
            prf("and ask him/her to register this great game!\r");
            outprf(usrnum);
        }
    }
    else if (sameas(dmargv[0], "I")) dun_info();
    else if (sameas(dmargv[0], "H")) dun_high();
    else if (sameas(dmargv[0], "W")) whatsnew();
    else if (sameas(dmargv[0], "S")) {
        if (activate&LINKFLG) {
            ml_welcome();
            dunwho->dunaptr.stt = WORLDSC;
            dunwho->dunaptr.lstt = MAINLM;
        }
        else {
            prf("Sorry, this option is not available at the moment.\r");
            outprf(usrnum);
        }
    }
    else if (sameas(dmargv[0], "X")) {
        prfmsg(ENDR);
	outprf(usrnum);
        btupmt(usrnum, NULL);
        dunwho->dunaptr.stt = 0;
        usrptr->substt = 0;
    }
    else if (sameas(dmargv[0], "?")) {
        dun_msg(usrnum, WELCOME, NONE4);
        dun_msg(usrnum, PROMPTW, NONE4);
    }
    else dun_msg(usrnum, PROMPTW, NONE4);
    usrptr->substt = dunwho->dunaptr.stt;
}

/* display info to user */
void
dun_info(void)
{
    prfmsg(INFO);
    prfmsg(INFO2);
    outprf(usrnum);
}

/* main game control handler */
void
dun_game(void)
{
    struct duncmd *duncptr;
    if ((duncptr = pasearch(dmargv[0], dunarr, dunsiz)) != NULL) {
        hlpmsg = duncptr->cmdhlp;
        setmbk(dunmb);
        if (!hasmkey(ACTKEY) && duncptr->liveonly == 1) {
            dun_msg(dusrnum, ONLYLIVE, NONE4);
        }
        else {
            (*(duncptr->dunout))();
        }
    }
    else {
        if (dmargc == 1) {
            dun_msg(dusrnum, ACTION, dun_ing(dmargv[0]), NONE3);
            prf_msg(ACTION2, dunwho->dunname, dun_ing(dmargv[0]), NONE2);
            dun_outdun(PLYROOM, dusrnum, -1, 0);
        }
        else {
            dun_msg(dusrnum, HELPPR, NONE4);
        }
    }
    if (dmargc > 0 && getply(usrnum)->dunaptr.stt == PLAYING) {
        dun_monat(dusrnum);
    }
    dusrnum = usrnum;
    dunwho=getply(usrnum);
    if (!(activate&LIVE)) {
        if (dunwho->dunscr > 400000L) {
            prf("Whoops! Since this is only a demo, you can only have\r");
            prf("a maximum of 400000 points! Please ask your SYSOP to\r");
            prf("register this great game, so that you'd be able to get\r");
            prf("the full benifits of the real MUTANTS!\r");
            outprf(usrnum);
            dunwho->dunscr = 400000L;
        }
    }
    prf("%s", WHITE);
    outprf(dusrnum);
}

void
whatsnew(void)
{
    setmbk(dunmb);
    prfmsg(WHATSNEW);
    outprf(usrnum);
}

int
drawit(void)
{
    // mutant image
    char image[] = {
    32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,220,2,219,2,219,2,219,2,219,2,219,2,219,2,219,2,
219,2,219,2,219,2,219,2,219,2,219,2,219,2,219,2,219,2,219,2,219,2,219,2,220,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,15,112,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,219,2,178,2,177,2,223,66,219,4,223,66,32,66,
176,2,176,2,177,2,178,2,219,2,178,2,177,2,176,2,176,2,32,76,223,66,219,4,223,66,
177,2,178,2,219,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,219,2,178,2,177,2,219,4,219,4,219,4,
219,4,219,4,32,76,32,76,177,2,178,2,219,2,178,2,177,2,32,76,32,76,32,76,219,4,
219,4,219,4,219,4,177,2,178,2,219,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,219,2,178,2,177,2,221,66,219,4,
219,4,219,4,32,76,32,10,219,4,32,76,32,76,178,2,219,2,178,2,32,76,219,4,219,4,
32,4,32,64,219,4,32,68,32,68,222,66,177,2,178,2,219,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,219,2,178,2,178,2,
177,2,220,66,219,4,219,4,219,4,219,4,219,4,32,68,220,66,178,2,219,2,178,2,220,66,
219,4,219,4,219,4,219,4,219,4,219,4,220,66,177,2,178,2,178,2,219,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,219,2,
178,2,177,2,178,2,176,2,176,2,176,2,176,2,176,2,176,2,176,2,177,2,178,2,219,2,
178,2,177,2,176,2,176,2,176,2,176,2,176,2,176,2,177,2,178,2,178,2,178,2,219,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,223,2,219,2,178,2,177,2,178,2,223,120,176,2,219,15,176,2,219,15,176,2,219,15,
176,2,219,15,176,2,219,15,176,2,219,15,176,2,219,15,176,2,223,120,178,2,178,2,178,2,
219,2,223,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,220,2,219,2,219,2,220,2,220,2,
218,1,208,1,208,1,208,1,208,1,208,1,208,1,208,1,208,1,208,1,208,1,208,1,208,1,
208,1,208,1,208,1,208,1,208,1,208,1,208,1,208,1,208,1,208,1,208,1,208,1,208,1,
208,1,208,1,208,1,208,1,208,1,208,1,191,1,220,2,219,2,219,2,220,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,220,2,219,2,219,2,219,2,219,2,219,2,178,2,177,2,
219,2,219,2,219,2,220,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,220,2,219,2,219,2,219,2,178,2,177,2,
219,2,219,2,219,2,219,2,220,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,219,2,219,2,219,2,223,2,223,2,219,2,219,2,
219,2,219,2,219,2,32,2,181,1,223,2,223,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,77,14,97,14,106,14,111,14,114,14,83,14,111,14,102,14,116,14,32,14,73,14,110,14,
99,14,46,14,32,14,32,14,32,14,32,14,32,14,32,14,223,2,223,2,198,1,32,1,219,2,
219,2,219,2,219,2,223,2,223,2,219,2,219,2,219,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,34,176,10,32,10,32,10,32,10,
32,10,32,10,32,10,32,34,32,34,32,7,181,1,32,1,32,1,32,1,32,1,32,1,32,1,
32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,
32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,198,1,
32,1,32,34,32,34,32,7,32,7,32,7,32,7,32,7,176,10,32,34,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,7,32,7,32,7,32,7,
32,7,32,7,32,7,32,7,32,7,32,7,32,7,32,7,32,7,32,7,32,42,176,10,32,10,
32,10,32,10,32,10,32,10,32,10,32,42,32,42,32,7,181,1,32,1,32,1,32,1,32,1,
32,1,32,1,32,1,32,1,32,1,32,1,84,11,72,11,65,11,78,11,75,11,83,11,32,11,
89,11,79,11,85,11,33,11,32,11,32,11,32,11,32,11,32,11,32,11,32,11,32,11,32,11,
32,11,198,1,32,1,32,42,32,42,32,7,32,7,32,7,32,7,32,7,176,10,32,42,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,7,32,7,
32,7,32,7,32,7,32,7,32,7,32,7,32,7,32,7,32,7,32,7,32,7,32,7,219,2,
176,10,32,10,32,10,32,10,32,10,32,10,32,10,223,2,223,2,219,2,219,2,219,2,219,2,
220,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,220,2,219,2,219,2,219,2,223,2,32,2,32,2,32,2,32,2,32,2,32,2,176,10,
219,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,219,2,176,10,32,10,32,10,32,10,32,10,32,10,32,10,32,10,32,10,32,10,181,1,
32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,
32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,
32,1,32,1,32,1,32,1,32,1,198,1,32,1,32,1,32,1,32,1,32,1,32,1,32,1,
32,1,176,10,219,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,219,2,176,10,32,10,32,10,32,10,32,10,32,10,32,10,32,10,32,10,
32,10,192,1,210,1,210,1,210,1,210,1,210,1,210,1,210,1,210,1,210,1,210,1,210,1,
210,1,210,1,210,1,210,1,210,1,210,1,210,1,210,1,210,1,210,1,210,1,210,1,210,1,
210,1,210,1,210,1,210,1,210,1,210,1,210,1,217,1,32,1,32,1,32,1,32,1,32,1,
32,1,32,1,32,1,176,10,219,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,32,2,
32,2,32,2,32,2,32,2,32,2,32,2};
    char *heading = "Mutants! V2.30 (C) 1991-93 MajorSoft Inc. Initializing: _______________";
    int x, y, sx, ex, sy, ey, rx, ctr, ctr2;
    // draw mutant image
    ctr2 = 0;
    for (ctr = 0; ctr < sizeof(image); ctr++) {
        if (ctr2 > 20 && ctr2 < 142) {
            frzseg()[ctr] = image[ctr];
            frzseg()[ctr+1] = image[ctr+1];
	}
	ctr2 = ctr2 + 2;
	if (ctr2 > 158) {
	    ctr2 = 0;
	}
	ctr++;
    }
    rx = 0;
    sx = 3;
    ex = 77;
    sy = 19;
    ey = 22;
    // draw main box
    for (y = sy; y < ey; y++) {
        for (x = sx; x < ex; x++) {
            frzseg()[(x*2)+(y*160)] = 32;
            frzseg()[(x*2)+(y*160)+1] = 62;
        }
    }
    // draw shadow
    for (x = sx+1; x < ex+1; x++) {
        frzseg()[(x*2)+(ey*160)+1] = 8;
    }
    for (y = sy+1; y < ey+1; y++) {
        frzseg()[(ex*2)+(y*160)+1] = 8;
    }
    // draw heading
    for (x = sx+1; *heading != '\0'; x++, heading++) {
        if (*heading != '_') {
            frzseg()[(x*2)+((sy+1)*160)] = *heading;
        }
        else {
            frzseg()[(x*2)+((sy+1)*160)+1] = 0;
            frzseg()[(x*2)+((sy+1)*160)] = 32;
            if (rx == 0) {
                rx = x;
            }
        }
    }
    return(rx);
}
