/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~
*   MJSMUTMO.C                                                            *
*   Version 2.30                                                          *
*   Copyright (C) 1991-93, MajorSoft Inc. and Eric Furrer                 *
*   This is the MUTANTS! monster intellegence handler                     *
*   for the MajorBBS version 6.xx +                                       *
*   E. Furrer      12/24/91        "it's not how you play the game,       *
*                                   it's if you win or lose."             *
*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

#include "gcomm.h"
#include "majorbbs.h"
#include "mjsmutx.h"           /* msg header file                      */
#include "mjsmuth.h"           /* mutants header file                  */
#include "mjsmutp.h"           /* mutants prototype file               */

void
dun_inimon(char ptemp[], int flag)  /* initialize a monster */
{
    int i, type, flag2, output[1000], ctr;
    PLAYER *dunoth;
    dusrnum = flag;
    dunoth=getply(flag);
    dunoth->dunaptr.stt = PLAYING;
    if (flag > monstart) {
        dunoth->dunxc = atoi(spr("%c%c%c\0",ptemp[0], ptemp[1], ptemp[2]));            dunoth->dunyc = atoi(spr("%c%c%c\0",ptemp[3], ptemp[4], ptemp[5]));
        dunoth->dunzc = atoi(spr("%c%c%c\0",ptemp[6], ptemp[7], ptemp[8]));
        flag2 = abs(dunoth->dunzc);
        if (flag2 > ((doptions.maxyr-2000)/100)) {
	    flag2 = ((doptions.maxyr-2000)/100);
	}
        if (flag2 < 1) {
	    flag2 = 1;
	}
        ctr = 0;
        for (i=0; i<maxtypes; i++) {
            if (flag2 >= pmonsptr[i].monlev) {
                output[ctr] = i;
                ctr++;
            }
        }
        type = output[dun_rand(ctr)];
        dunoth->duncla = type;
    }
    else {
        dunoth->dunxc = -21;
        dunoth->dunyc = -19;
        dunoth->dunzc = 30;
        flag2 = 30;
        ctr = 0;
        type = SATAN;
        dunoth->duncla = type;
    }
    setmem(dunoth->dunname, NAMSIZ, 30);
    sprintf(dunoth->dunname, "%s-%d", pmonsptr[type].monnam, flag-nterms+1);
    dunoth->dunlev = pmonsptr[type].monlev;
    dunoth->dunint = 10 + dun_rand(20 * dunoth->dunlev);
    dunoth->dunstr = 10 + dun_rand(10 * dunoth->dunlev);
    dunoth->duncon = 10 + dun_rand(20 * dunoth->dunlev);
    dunoth->dundex = 10 + dun_rand(5 * dunoth->dunlev);
    dunoth->dunwis = 10 + dun_rand(20 * dunoth->dunlev);
    dunoth->duncha = 10 + dun_rand(20 * dunoth->dunlev);
    dunoth->dunscr = 10000 * ((long)dunoth->dunlev+1);
    dunoth->dunarm = pmonsptr[type].monarm;
    if (dunoth->dunarm > -1) {
        dunoth->dunast = pitemptr[dunoth->dunarm].pdsta;
    }
    else {
        dunoth->dunast = -1;
    }
    dunoth->dunhp = 10 + dun_rand(30 * dunoth->dunlev);
    dunoth->maxhp = dunoth->dunhp;
    dunoth->dungold = (dun_rand(dunoth->dunlev + 1) * 1200) + 280;
    if (dunoth->dungold < 0) dunoth->dungold = 1000000L;
    for (i=0; i<10; i++) {
        if (i > 2) {
            dunoth->dunite[i] = -1;
            dunoth->dunist[i] = -1;
        }
        else {
            dunoth->dunite[i] = pmonsptr[type].monite[i];
            if (dunoth->dunite[i] > -1) {
                dunoth->dunist[i] = pitemptr[dunoth->dunite[i]].pdsta;
            }
            else {
                dunoth->dunist[i] = -1;
            }
        }
    }
    dunoth->dunist[0]+=pmonsptr[type].spebon;
    dunoth->dunaptr.mutflags = 0L;
    dunoth->dunaptr.totwt = 0;
    dunoth->dunaptr.lespe = 0;
    dunoth->dunaptr.dunrsp = pmonsptr[type].monspell;
    dunoth->dunaptr.dunmsp = 0;
    dunoth->spcomp = 10000;
    dunoth->dunaptr.summon = 0;
    dunoth->dunaptr.combat = 0;
    dunoth->poison = 0;
    dunoth->dunaptr.totwt = 0;
    strncpy(dunoth->dunaptr.pcomba, "ROAM IT", NAMSIZ);
    prf_msg(MAPP, dunoth->dunname, NONE3);
    dun_outdun(OTHROOM, dusrnum, -1, 0);
}

void 
dun_genmo(int which)    /* generate a monster */
{ 
    int tmpusr;
    long pirm;
    tmpusr = dusrnum;
    pirm = dun_rand((int)maxroom);
    setbtv(proombb);
    if (qeqbtv(&pirm, 1)) {
        gcrbtv(&proomptr, 1);
        dun_inimon(proomptr.prmin, which);
    }
    dusrnum = tmpusr;
    if (dusrnum > -1) {
        dunwho=getply(dusrnum);
    }
}

void 
dun_monat(duid)    /* monster intellegence function handler */
int duid;
{
    int i, ctr;
    char temp[10];
    PLAYER *dunoth;
    if (duid > -1) {
        dunoth=getply(duid);
        monturn = 0;
        for (i=monstart; i<maxcreat; i++) {
            if (getply(i)->dunaptr.stt == PLAYING) {
                if (sameas(getply(i)->dunaptr.pcomba, dunoth->dunname)) {
                    dunwho=getply(i);
                    dusrnum = i;
                    strncpy(temp, PLYROOM, 10);
                    if (!sameas(temp, OTHROOM)) {
                        if (dunwho->dunhp > 10) dun_monfol(duid);
                    }
                    if (dunwho->dunhp < 11) {
                        if (dunoth->dunhp > 10) {
                            dun_monret(duid);
                        }
                        else {
                            if (!sameas(temp, OTHROOM)) {
                                dun_monfol(duid);
                            }
                        }
                    }
                    if (dunwho->dunaptr.summon == 0) {
                        dun_monatt();
                        dun_monheal();
                        dun_monwear();
                        dun_monrem();
                        dun_monconv();
                        dun_monpick();
                        dun_mondrop();
                        dun_moncast();
                        dun_mondumb();
                    }
                }
            }
        }
    }
    else {
        ctr = 0;
        do {
            nextmon++;
            if (nextmon > (maxcreat-1)) {
	        nextmon = monstart;
	    }
            if (getply(nextmon)->dunaptr.stt != PLAYING) {
                do {
                    nextmon++;
                } while(nextmon < maxcreat && getply(nextmon)->dunaptr.stt
                != PLAYING);
                if (nextmon == maxcreat) {
		    // this error can be caused by modified room maps
		    // and the indexing is damaged. RUN MUTMAP6, and
		    // select reindex
		    catastro("ERROR IN MJSMUTMO.C:1000");
		}
            }
            dusrnum = nextmon;
            dunwho=getply(nextmon);
            strncpy(temp, PLYROOM, 10);
            monturn = 0;
            if (!sameas(dunwho->dunaptr.pcomba, "ROAM IT")) {
                for (i=0; i<maxcreat; i++) {
                    if (getply(i)->dunaptr.stt == PLAYING) {
                        dunoth=getply(i);
                        if (sameas(dunoth->dunname, dunwho->dunaptr.pcomba)) {
                            if (sameas(temp, OTHROOM)) {
                                if (dunwho->dunhp > 10) {
                                    dun_monatt();
                                }
                                else {
                                    if (dunoth->dunhp < 11) {
                                        dun_monatt();
                                    }
                                    else {
                                        dun_monret(i);
                                    }
                                }
                            }
                            else {
                                if (dunwho->dunhp > 10) {
                                    dun_monfol(i);
                                }
                                else {
                                    if (dunoth->dunhp < 11) {
                                        dun_monfol(i);
                                    }
                                    else {
                                        dun_monret(i);
                                    }
                                }
                            }
                            i = maxcreat;
                        }
                        else {
                            if (dunwho->dunhp < 11 && dunoth->dunhp > 10) dun_monret(i);
                        }
                    }
                }
            }
            if (dunwho->dunaptr.summon == 0) {
                
                /* monster action priority list */
                
                dun_monheal();  /* heal          */
                dun_monwear();  /* wear armor    */
                dun_monrem();   /* remove armor  */
                dun_monpick();  /* pick up item  */
                dun_monconv();  /* convert item  */
                dun_mondrop();  /* drop item     */
                dun_moncast();  /* cast spell    */
                dun_mondumb();  /* dumb thing    */
            }
            if (sameas(dunwho->dunaptr.pcomba, "ROAM IT")) dun_monroam();
            ctr++;
        } while (ctr < doptions.maxmove);
    }
}

void 
dun_monpick(void)    /* monster picking up an item */
{
    int ii, ok;
    if (monturn == 0) {
        ok = 0;
        for (ii=0; ii<10; ii++) {
            if (dunwho->dunite[ii] == -1) {
                ii = 11;
                ok = 1;
            }
        }
        if (ok == 1) {
            dun_load(PLYROOM);
            for (ii=0; ii<6; ii++) {   /* pick something up */
                if (proomptr.pitem[ii] > 1 && dun_rand(2) == 0) {
                    strncpy(dmargv[0], "get", 10);
                    strncpy(dmargv[1], pitemptr[proomptr.pitem[ii]].pitnam, 20);
                    dmargc = 2;
                    dun_get();
                    ii = 6;
                    monturn = 1;
                }
            }
        }
    }
}

void 
dun_mondrop(void)   /* drop broken stuff */
{
    int i;
    if (monturn == 0) {
        for (i=0; i<10; i++) {
            if (dunwho->dunite[i] > -1) {
                if (dunwho->dunite[i] < 2) {
                    strncpy(dmargv[0], "drop", 10);
                    strncpy(dmargv[1], pitemptr[dunwho->dunite[i]].pitnam, 20);
                    dmargc = 2;
                    dun_drop();
                    monturn = 1;
                    i = 10;
                }
            }
        }
    }
}

void 
dun_monroam(void)      /* make a monster roam */
{
    int i;
    if (monturn == 0) {
        strncpy(dmargv[0], gendir[dun_rand(4)], 10);
        dmargc = 1;
        dun_dirh();
        /* mod v2.20 - make monsters hostile towards other monsters */
        for (i = monstart; i < maxcreat; i++) {
            if (i != dusrnum && getply(i)->dunaptr.stt == PLAYING) {
                if (dunwho->dunzc == getply(i)->dunzc &&
                dunwho->dunyc == getply(i)->dunyc &&
                dunwho->dunxc == getply(i)->dunxc) {
                    strncpy(dunwho->dunaptr.pcomba, getply(i)->dunname, NAMSIZ);
                    if (dun_rand(HOSTILE) == 0) {
                        strncpy(dunwho->dunaptr.pcomba, getply(i)->dunname, NAMSIZ);
                        prf("%s ",   dunwho->dunname);
                        prf("%s's ", pmonsptr[dunwho->duncla].montal);
                        prf("%s, ",  pmonsptr[dunwho->duncla].monbat);
                        prf("%s!\r",   dunwho->dunaptr.pcomba);
                        dun_outdun(PLYROOM, -1, -1, 4);
                        i = maxcreat;
                    }
                }
            }
        }
	monturn = 1;
    }
}

void 
dun_monfol(dwho)   /* make a monster follow */
int dwho;
{
    char temp[10];
    PLAYER *dunoth;
    dunoth=getply(dwho);
    if (monturn == 0) {
        if (dunoth->dunzc == dunwho->dunzc) {
            if (dun_rand(0) == 0) {
                prf("%s %s's %s, %s!\r", dunwho->dunname,
                pmonsptr[dunwho->duncla].montal,
                pmonsptr[dunwho->duncla].monbat,
                dunwho->dunaptr.pcomba);
                dun_outdun(PLYROOM, dusrnum, -1, 4);
            }
            strncpy(temp, PLYROOM, 10);
            if (dunwho->dunxc > dunoth->dunxc) dmargv[0][0] = 'w';
            else if (dunwho->dunxc < dunoth->dunxc) dmargv[0][0] = 'e';
            if (dunwho->dunyc > dunoth->dunyc) dmargv[0][0] = 's';
            else if (dunwho->dunyc < dunoth->dunyc) dmargv[0][0] = 'n';
            dmargv[0][1] = '\0';
            dmargc = 1;
            dun_dirh();
            monturn = 1;
        }
    }
}

void 
dun_monret(dwho)   /* make a monster retreat */
int dwho;
{
    PLAYER *dunoth;
    dunoth=getply(dwho);
    if (dun_rand(3) == 0 && monturn == 0) {
        if (!(dunoth->dunaptr.mutflags&INVIS)) {
            dun_monconf(dusrnum);
            dmargv[0][0] = '\0';
            if (dunwho->dunzc == dunoth->dunzc &&
            dunwho->dunyc == dunoth->dunyc &&
            dunwho->dunxc == dunoth->dunxc) {
                strncpy(dmargv[0], gendir[dun_rand(4)], 10);
            }
            else {
                if (dunwho->dunxc > dunoth->dunxc) dmargv[0][0] = 'e';
                else if (dunwho->dunxc < dunoth->dunxc) dmargv[0][0] = 'w';
                if (dunwho->dunyc > dunoth->dunyc) dmargv[0][0] = 'n';
                else if (dunwho->dunyc < dunoth->dunyc) dmargv[0][0] = 's';
            }
            if (dmargv[0][0] != '\0') {
                dmargv[0][1] = '\0';
                dmargc = 1;
                prf("%s screams: Get away from me, %s!!!\r", dunwho->dunname, dunwho->dunaptr.pcomba);
                dun_outdun(PLYROOM, dusrnum, -1, 0);
                dun_dirh();
                monturn = 1;
            }
        }
    }
}

void 
dun_monatt(void)   /* make a monster attack */
{
    int flag, i, flag2;
    long a, b;
    if (dunwho->dunaptr.summon == 0) {
        if (monturn == 0) {
            flag2 = 0;
            if (dunwho->dunlev > 5) flag2 = 1;
            else {
                if (dun_rand(2) == 0) flag2 = 1;
            }
            if (flag2 == 1) {
                if (dun_rand(pmonsptr[dunwho->duncla].monattu) == 0) {
                    flag = dun_isply(dunwho->dunaptr.pcomba, PLYROOM, 10);
                    if (flag > -1) {
                        dun_load(PLYROOM);
                        if (dun_dark(0) == 0 && !(getply(flag)->dunaptr.mutflags&INVIS)) {
                            prf("The %s %s you!\r", dunwho->dunname, pmonsptr[dunwho->duncla].monspe);
                            dun_outply(flag);
                            prf("The %s %s %s!\r", dunwho->dunname, pmonsptr[dunwho->duncla].monspe, dunwho->dunaptr.pcomba);
                            dun_outdun(PLYROOM, flag, -1, 0);
                            dun_dam2(dusrnum, flag, pmonsptr[dunwho->duncla].monatdm, dunwho->dunlev);
                        }
                    }
                }
                else {
                    chk_staff();
                    if (monturn == 0) {
                        b = -1000;
                        flag = -1;
                        for (i=0; i<10; i++) {
                            if (dunwho->dunite[i] > -1) {
                                a = dun_howgood(dunwho->dunite[i], dunwho->dunist[i]);
                                if (a > b) {
                                    b = a;
                                    flag = i;
                                }
                            }
                        }
                        if (flag > -1) {
                            strncpy(dmargv[0], "wield", 10);
                            strncpy(dmargv[1], pitemptr[dunwho->dunite[flag]].pitnam, 20);
                            dmargc = 2;
                            dun_wiel();
                            monturn = 1;
                        }
                    }
                }
            }
        }
    }
    else {
        if (dun_rand(5) == 0) {
            prf("%s says: Awaiting your command, Master %s.\r", dunwho->dunname, dunwho->dunaptr.pcomba);
            dun_outdun(PLYROOM, -1, dusrnum, 0);
        }
    }
}

void 
dun_monrem(void)   /*  if carrying better armor, then remove, wear */
{
    long a, b;
    int i, flag;
    if (monturn == 0) {
        if (dunwho->dunarm > -1) {
            a = dun_howgood(dunwho->dunarm, dunwho->dunast);
            flag = -1;
            for (i=0; i<10; i++) {
                if (dunwho->dunite[i] > -1) {
                    if (pitemptr[dunwho->dunite[i]].pitty == 2) {
                        b = dun_howgood(dunwho->dunite[i], dunwho->dunist[i]);
                        if (a < b) flag = i;
                    }
                }
            }
            if (flag > -1) {
                strncpy(dmargv[0], "remove", 10);
                dmargc = 1;
                dun_remo();
                if (dunwho->dunarm == -1) monturn = 1;
            }
        }
    }
}

void 
dun_monwear(void)   /* monster puts on some armor */
{
    int i, flag;
    long a, b;
    if (monturn == 0) {
        if (dunwho->dunarm == -1) {
            flag = -1;
            for (i=0; i<10; i++) {
                if (dunwho->dunite[i] > -1) {
                    if (pitemptr[dunwho->dunite[i]].pitty == 2) {
                        a = dun_howgood(dunwho->dunite[i], dunwho->dunist[i]);
                        if (flag > -1) {
                            b = dun_howgood(dunwho->dunite[flag], dunwho->dunist[flag]);
                        }
                        else b = -1;
                        if (a > b) flag = i;
                    }
                }
            }
            if (flag > -1) {
                strncpy(dmargv[0], "wear", 10);
                strncpy(dmargv[1], pitemptr[dunwho->dunite[flag]].pitnam, 20);
                dmargc = 2;
                dun_wear();
                if (dunwho->dunarm > -1) monturn = 1;
            }
        }
    }
}

void 
dun_monconv(void)    /* convert skulls/items to ions */
{
    int i;
    for (i=0; i<10; i++) {
        if (dunwho->dunite[i] == 2) {
            strncpy(dmargv[0], "convert", 10);
            strncpy(dmargv[1], "skull", 10);
            dmargc = 2;
            dun_conv();
            monturn = 1;
            i = 10;
        }
    }
    if (monturn == 0) {
        if (dunwho->dunite[9] > -1) {
            strncpy(dmargv[0], "convert", 10);
            strncpy(dmargv[1], pitemptr[dunwho->dunite[9]].pitnam, 20);
            dmargc = 2;
            dun_conv();
            monturn = 1;
        }
    }
}

void 
dun_moncast(void)    /* cast a spell (If they have one) */
{
    if (monturn == 0 && dun_rand(20) == 0) {
        if (dunwho->dunaptr.dunrsp > -1 && dunwho->dunaptr.lespe == 0) {
            strncpy(dmargv[0], "cast", 10);
            dmargc = 1;
            dunwho->spcomp = dunwho->spcomp + pspelptr[dunwho->dunaptr.dunrsp].castcost;
            dun_cast();
            if (dunwho->dunaptr.lespe > 0) monturn = 1;
        }
    }
}

void 
dun_monconf(who)   /* summon spell is broken */
int who;
{
    int temp;
    if (getply(who)->dunaptr.summon == 1) {
        temp = dusrnum;
        dusrnum = who;
        dunwho=getply(who);
        prf("%s gets a confused look on %s face.\r", dunwho->dunname, SEX);
        dun_outdun(PLYROOM, -1, -1, 0);
        dunwho->dunaptr.summon = 0;
        dunwho=getply(temp);
        dusrnum = temp;
    }
}

void 
dun_monheal(void)   /* heal a monster */
{
    int rem;
    if (dun_rand(2) == 0) {
        if (dunwho->dunhp < dunwho->maxhp && dunwho->dunhp > 9) {
            rem = dunwho->dunhp;
            dunwho->dunhp = dunwho->dunhp - 2;   /* monsters only heal 3 points */
            dun_heal();
            if (rem != dunwho->dunhp) monturn = 1;
        }
    }
}

void 
dun_mondumb(void)    /* make the monster do something totally stupid */
{
    /* to add new actions, add to list - thats all! */
    char *stupid_list[] = {
        "looking around dumbfounded.",
        "sniffing around.",
        "grunting.",
        "looking at you.",
        "gasping in amazement!",
        "wondering what your doing.",
        "looking at you stupidly.",
        "looking awefully sad.",
        "looking very happy.",
        "smiling at you.",
        "saying: what?",
        "sitting down.",
        "crying.",
        "pleading with you.",
        "begging you.",
        "trying to make friends with you.",
        "looking away from you.",
        "thinking.",
        "making strange noises.",
        "singing a strange song.",
        "laughing.",
    };
    if (monturn == 0 && dun_rand(3) == 0) {
        prf("%s is %s\r", dunwho->dunname, stupid_list[dun_rand(sizeof(stupid_list)/sizeof(*stupid_list))]);
        dun_outdun(PLYROOM, -1, -1, 0);
        monturn = 1;
    }
}

void /* check to see if monster has staff, if so, use it! */
chk_staff(void)
{
    int i, ctr, who, what;
    char direction[10];
    what = -1;
    for (i = 0; i < 10; i++) {
        if (pitemptr[dunwho->dunite[i]].pitty == STAFF) {
            if (dunwho->dunist[i] > 1) {
                what = i;
                i = 10;
            }
        }
    }
    if (what > -1) {
        setmem(direction, 10, 0);
        who = -1;
        for (ctr = 0; ctr < nterms; ctr++) {
            if (sameas(getply(ctr)->dunname, dunwho->dunaptr.pcomba)) {
                who = ctr;
                ctr = nterms;
            }
        }
        if (who > -1) {
            if (dunwho->dunzc == getply(who)->dunzc) {
                if (dunwho->dunyc == getply(who)->dunyc) {
                    if (dunwho->dunxc < getply(who)->dunxc) strcpy(direction, "east");
                    else strcpy(direction, "west");
                }
                else {
                    if (dunwho->dunxc == getply(who)->dunxc) {
                        if (dunwho->dunyc < getply(who)->dunyc) strcpy(direction, "north");
                        else strcpy(direction, "south");
                    }
                }
                if (strlen(direction) > 0) {
                    strncpy(dmargv[0], "point", 10);
                    strncpy(dmargv[1], direction, 12);
                    strncpy(dmargv[2], pitemptr[dunwho->dunite[what]].pitnam, 25);
                    dmargc = 3;
                    dun_staf();
		    if (dunwho->dunist[what] < 1) {
	  	        dunwho->dunist[what]++;
		    }
                    monturn = 1;
                }
            }
        }
    }
}

















