/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~
*   MJSMUTPR.C                                                            *
*   Version 2.30                                                          *
*   Copyright (C) 1991-93, MajorSoft Inc. and Eric Furrer                 *
*   This is the MUTANTS! player routine handler                           *
*   for the MajorBBS version 6.xx +                                       *
*   E. Furrer      12/24/91        "it's not how you play the game,       *
*                                   it's if you win or lose."             *
*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

#include "gcomm.h"
#include "majorbbs.h"
#include "mjsmutx.h"         /* msg header file                       */
#include "mjsmuth.h"         /* mutants header file                   */
#include "mjsmutp.h"         /* mutants prototype file                */

/* direction handler */
void
dun_dirh(void)
{
    int dir, dir2, ok, flag;
    flag = 0;
    if (dunwho->dunaptr.mutflags&ENCUMD) {
        dun_msg(dusrnum, ENCUMB2, NONE4);
    }
    else {
        dun_load(PLYROOM);
        dir = dun_getdir(dmargv[0]);
        dir2 = 1;
        if (dir == 1 || dir == 3) dir2 = -1;
        if (proomptr.prmdir[dir] == 0) {
            if (dunwho->dunaptr.mutflags&WALK) {
	        if (dunwho->dunxc+genx[dir] > 99 || dunwho->dunxc+genx[dir] < -99 ||
		    dunwho->dunyc+geny[dir] > 99 || dunwho->dunyc+geny[dir] < -99) {
		        prf("You get thrown back!\r");
			outprf(dusrnum);
	        }
		else {
                    dun_crm(dunwho->dunxc+genx[dir],
                    dunwho->dunyc+geny[dir],
                    dunwho->dunzc+genz[dir]);
                    dun_load(PLYROOM);
		}
            }
            else dun_msg(dusrnum, BLOCK, NONE4);
        }
        if (proomptr.prmdir[dir] == 1 || proomptr.prmdir[dir] == 10) {
            if (dun_dark(0) == 0 && !(dunwho->dunaptr.mutflags&INVIS)) {
                prf_msg(SOLEFT, dunwho->dunname, gendir[dir], NONE2);
                dun_outdun(PLYROOM, dusrnum, -1, 0);
            }
            dunwho->dunxc = dunwho->dunxc + genx[dir];
            dunwho->dunyc = dunwho->dunyc + geny[dir];
            dunwho->dunzc = dunwho->dunzc + genz[dir];
	    // thanks to SHELBY from AOS for this one! EGF 04/01/93
	    if (dunwho->dunxc < -99 || dunwho->dunxc > 99 || 
	    dunwho->dunyc < -99 || dunwho->dunyc > 99) {
	        prf("You get thrown back!\r");
	        outprf(dusrnum);
	        dunwho->dunxc = dunwho->dunxc - genx[dir];
                dunwho->dunyc = dunwho->dunyc - geny[dir];
                dunwho->dunzc = dunwho->dunzc - genz[dir];
            }
            if (dun_dark(0) == 0) dun_chknlig();
            dun_load(PLYROOM);
            dun_mapit(genx[dir],geny[dir]);
            ok = 0;
            if (!sameas("Sysop", dunwho->dunname) &&
            !sameas(proomptr.bared, "")) {
                if (!sameas(dunwho->dunname, proomptr.bared)) {
                    flag = 1;
                    dun_msg(dusrnum, STRUCK, NONE4);
                    dunwho->dunxc = dunwho->dunxc - genx[dir];
                    dunwho->dunyc = dunwho->dunyc - geny[dir];
                    dunwho->dunzc = dunwho->dunzc - genz[dir];
                    dun_load(PLYROOM);
                    dun_mapit(-genx[dir], -geny[dir]);
                    prf_msg(STRUCK2, dunwho->dunname, gendir[dir+dir2], NONE2);
                    dun_outdun(PLYROOM, dusrnum, -1, 0);
                    ok = 1;
                }
            }
            if (dun_dark(0) == 0 && !(dunwho->dunaptr.mutflags&INVIS)) {
                if (ok == 0) {
                    prf_msg(ARRIVE, dunwho->dunname, gendir[dir+dir2], NONE2);
                    dun_outdun(PLYROOM, dusrnum, -1, 3);
                }
            }
            else {
                if (ok == 0) {
                    prf_msg(FOOTCL, NONE4);
                    dun_outdun(PLYROOM, dusrnum, -1, 0);
                }
            }
            if (dusrnum < monstart && flag == 0) dun_look();
            if (!sameas(proomptr.portal, "NONE") && ok == 0 && dusrnum < monstart) {
                dun_msg(dusrnum, PORTAL, NONE4);
                prf_msg(DISAP, dunwho->dunname, NONE3);
                dun_outdun(PLYROOM, dusrnum, -1, 0);
                dunwho->dunxc = atoi(spr("%c%c%c",
                proomptr.portal[0],
                proomptr.portal[1],
                proomptr.portal[2]));
                dunwho->dunyc = atoi(spr("%c%c%c", proomptr.portal[3], 
		proomptr.portal[4], proomptr.portal[5]));
                dunwho->dunzc = atoi(spr("%c%c%c", proomptr.portal[6],
                proomptr.portal[7], proomptr.portal[8]));
                dun_clrmap();
                dun_look();
                prf_msg(MAPP, dunwho->dunname, NONE3);
                dun_outdun(PLYROOM, dusrnum, -1, 0);
            }
        }
        else if (proomptr.prmdir[dir] == 2) dun_msg(dusrnum, CANWI, NONE4);
        else if (proomptr.prmdir[dir] > 10 && proomptr.prmdir[dir] < 20) {
            dun_msg(dusrnum, CANDO, NONE4);
        }
        else if (proomptr.prmdir[dir] > 19) dun_msg(dusrnum, CANFO, NONE4);
    }
}


void
dun_mapw(void)  /* display map */
{
    int x, y;
    if (dusrnum < monstart) {
        prf("\r       NORTH\r");
        for (y=0; y<9; y++) {
            for (x=0; x<9; x++) {
                if (y == 4 && x == 4) {
                    prf("Y ");
                }
                else prf("%c ", mutmap[dusrnum].play_map[x][y]);
            }
            prf("\r");
        }
        prf("\rm - maintenance shop\rt - trading center\r# - roadway\r");
        dun_outply(dusrnum);
    }
}

void
dun_door(void)      /* add a door */
{
    int dir, dir2;
    if (dmargc <3) dun_hlp();
    else {
        dir = dun_getdir(dmargv[2]);
        dir2 = 1;
        if (dir == 1 || dir == 3) dir2 = -1;
        if (dir > -1) {
            dun_load(PLYROOM);
            proomptr.prmdir[dir] = 10;
            updcas();
            dun_load(dun_getrm(dunwho->dunxc+genx[dir],
            dunwho->dunyc+geny[dir],
            dunwho->dunzc+genz[dir]));
            proomptr.prmdir[dir+dir2] = 10;
            updcas();
            dun_msg(dusrnum, ROODR, gendir[dir], NONE3);
        }
        else {
            dun_hlp();
        }
    }
}


void
dun_gbye(void)      /* see ya user! */
{
    char what[255];
    dusrnum = usrnum;
    dunwho = getply(dusrnum);
    if (dunwho->dunaptr.combat > 0) {
        dun_msg(dusrnum, CNTINCOM, NONE4);
    }
    else {
        btupmt(usrnum, NULL);
        dun_saveply();
        dunwho->dunaptr.stt = SELCLASS;
        usrptr->substt = SELCLASS;
    }
    sprintf(what, "%s %s has just dematerialized from this world.",
    classptr[dunwho->duncla].clanam, dunwho->dunname);
    dun_telm(what);
}

void
dun_look(void)
{
    // look around
    int i, dir, dir2;
    dun_load(PLYROOM);
    if (dun_dark(0) == 1) {
        dun_msg(dusrnum, TOODARK, NONE4);
    }
    else {
        if (dmargc == 1) {
            dun_desc();
        }
        else {
            if ((i = dun_isply(dmargv[1], PLYROOM, 2)) > -1) {
                prf_msg(ULOOKA, dunwho->dunname, getply(i)->dunname, NONE2);
                dun_outdun(PLYROOM, i, dusrnum, 0);
                dun_msg(i, LOOKU, dunwho->dunname, NONE3);
                if (i < monstart) {
                    dun_msg(dusrnum, ITSPL, spr("%d", getply(i)->dunlev),
                    classptr[getply(i)->duncla].clanam, NONE2);
                }
                else {
                    dun_msg(dusrnum, ITSPL, spr("%d", getply(i)->dunlev),
                    pmonsptr[getply(i)->duncla].monnam, NONE2);
                }
                if (getply(i)->dunhp == getply(i)->maxhp) {
                    dun_msg(dusrnum, GOODHE, getply(i)->dunname, NONE3);
                }
                else if (getply(i)->dunhp >
                (getply(i)->maxhp - (getply(i)->maxhp/4))) {
                    dun_msg(dusrnum, HEAL20, getply(i)->dunname, NONE3);
                }
                else if (getply(i)->dunhp >
                (getply(i)->maxhp - (getply(i)->maxhp/3))) {
                    dun_msg(dusrnum, HEAL40, getply(i)->dunname, NONE3);
                }
                else if (getply(i)->dunhp >
                (getply(i)->maxhp - (getply(i)->maxhp/2))) {
                    dun_msg(dusrnum, HEAL60, getply(i)->dunname, NONE3);
                }
                else {
                    dun_msg(dusrnum, HEAL80, getply(i)->dunname, NONE3);
                }
                if (getply(i)->dunite[0] > -1) {
                    dun_msg(dusrnum, PLCAR, getply(i)->dunname,
                    pitemptr[getply(i)->dunite[0]].pitnam, NONE2);
                }
            }
            else if (dun_ihand(dmargv[1], 2) > -1) {
                i = dun_ihand(dmargv[1], 2);
                if (pitemptr[dunwho->dunite[i]].pitty == STAFF) {
                    dun_msg(dusrnum, STBL, ITEMSCAN.pitnam,
                    spr("%d", dunwho->dunist[i]), NONE2);
                }
                else if (pitemptr[dunwho->dunite[i]].pitty == SWORD) {
                    if (dunwho->dunist[i] > 100) {
                        dun_msg(dusrnum, MAGICAL, ITEMSCAN.pitnam,
                        spr("%d", dunwho->dunist[i] - 100),
                        ITEMSCAN.pitnam, NONE1);
                    }
                    else {
                        prf("The %s ", ITEMSCAN.pitnam);
                        if (dunwho->dunist[i] > 90) prf_msg(VERSH, NONE4);
                        else if (dunwho->dunist[i] > 70) prf_msg(SOMSH, NONE4);
                        else if (dunwho->dunist[i] > 50) prf_msg(SOBAT, NONE4);
                        else if (dunwho->dunist[i] > 30) prf_msg(SOCHI, NONE4);
                        else if (dunwho->dunist[i] > 10) prf_msg(SODUL, NONE4);
                        else prf_msg(SOUSE, NONE4);
                        dun_outply(dusrnum);
                    }
                }
                else if (pitemptr[dunwho->dunite[i]].pitty == ARMOR) {
                    if (dunwho->dunist[i] > 100) {
                        dun_msg(dusrnum, MAGICAL,
                        ITEMSCAN.pitnam,
                        spr("%d", dunwho->dunist[i] - 100),
                        ITEMSCAN.pitnam, NONE1);
                    }
                    else {
                        prf_msg(ARMIS, NONE4);
                        if (dunwho->dunist[i] > 90) prf_msg(AREXC, NONE4);
                        else if (dunwho->dunist[i] > 70) prf_msg(ARGOO, NONE4);
                        else if (dunwho->dunist[i] > 50) prf_msg(ARBAT, NONE4);
                        else if (dunwho->dunist[i] > 30) prf_msg(ARCHI, NONE4);
                        else if (dunwho->dunist[i] > 10) prf_msg(ARDAM, NONE4);
                        else prf_msg(ARFAL, NONE4);
                        dun_outply(dusrnum);
                    }
                }
                else if (pitemptr[dunwho->dunite[i]].pitty == SKULL) {
                    if (dunwho->dunist[i] == 111) dun_msg(dusrnum, BONES, "a human", NONE3);
                    else {
                        sprintf(BUFFER, "%s%s", dun_aoran(pmonsptr[dunwho->dunist[i]].monnam, 1), pmonsptr[dunwho->dunist[i]].monnam);
                        dun_msg(dusrnum, BONES, BUFFER, NONE3);
                    }
                }
                else if (pitemptr[dunwho->dunite[i]].pitty == SCROLL) {
                    dun_msg(dusrnum, SCROLLID, dun_aoran(pspelptr[dunwho->dunist[i]].spenam, 1), pspelptr[dunwho->dunist[i]].spenam, NONE2);
                }
                else {
                    dun_msg(dusrnum, LOOKL, pitemptr[dunwho->dunite[i]].pitnam, NONE3);
                }
            }
            else {
                dir = dun_getdir(dmargv[1]);
                if (dir > -1) {
                    dir2 = 1;
                    if (dir == 1 || dir == 3) dir2 = -1;
                    if (dun_load(dun_getrm(dunwho->dunxc+genx[dir], dunwho->dunyc+geny[dir], dunwho->dunzc+genz[dir])) == 1) {
                        if (proomptr.prmdir[dir+dir2] == 1 || proomptr.prmdir[dir+dir2] == 10) {
                            dunwho->dunxc = dunwho->dunxc + genx[dir];
                            dunwho->dunyc = dunwho->dunyc + geny[dir];
                            dunwho->dunzc = dunwho->dunzc + genz[dir];
                            gloflag = 1;
                            prf("You're looking %s...\r", gendir[dir]);
                            dun_outply(dusrnum);
                            dun_desc();
                            gloflag = 0;
                            prf_msg(PEER, dunwho->dunname, gendir[dir+dir2], NONE2);
                            dun_outdun(PLYROOM, dusrnum, -1, 0);
                            dunwho->dunxc = dunwho->dunxc - genx[dir];
                            dunwho->dunyc = dunwho->dunyc - geny[dir];
                            dunwho->dunzc = dunwho->dunzc - genz[dir];
                            prf_msg(LOOKT, dunwho->dunname, gendir[dir], NONE2);
                            dun_outdun(PLYROOM, dusrnum, -1, 0);
                        }
                        else dun_msg(dusrnum, CANSEE, NONE4);
                    }
                    else dun_msg(dusrnum, CANSEE, NONE4);
                }
                else dun_msg(dusrnum, CANSEEW, dmargv[1], NONE3);
            }
        }
    }
}

void dun_desc(void)
{
    int i;
    dun_load(PLYROOM);
    sprintf(BUFFER, "%s%s\r", RED, proomptr.sign);
    prf("%s", BUFFER);
    sprintf(BUFFER, "%sCompass: (%dE : %dN)\r", GREEN, dunwho->dunxc, dunwho->dunyc);
    prf("%s", BUFFER);
    for (i=0; i<4; i++) {
        if (proomptr.prmdir[i] == 10) {
            sprintf(BUFFER, "%s%-6s - %sopen gate.\r", YELLOW, gendir[i], CYAN);
        }
        else if (proomptr.prmdir[i] == 2) {
            sprintf(BUFFER, "%s%-6s - %swall of ice.\r", YELLOW, gendir[i], CYAN);
        }
        else if (proomptr.prmdir[i] > 10 && proomptr.prmdir[i] < 20) {
            sprintf(BUFFER, "%s%-6s - %sclosed gate.\r", YELLOW, gendir[i], CYAN);
        }
        else if (proomptr.prmdir[i] > 19) {
            sprintf(BUFFER, "%s%-6s - %sion force field.\r", YELLOW, gendir[i], CYAN);
        }
        else if (proomptr.prmdir[i] == 1) {
            sprintf(BUFFER, "%s%-6s - %sarea continues.\r", YELLOW, gendir[i], CYAN);
        }
        if (proomptr.prmdir[i] > 0) prf("%s", BUFFER);
    }
    dun_outply(dusrnum);
    dun_item();
    dun_who();
}

void
dun_who(void)   /* who's here and around */
{
    int i, ctr, ref[100], ii, flag, alshad[4];
    char dshad[100], stat[10];
    PLAYER *dunoth;
    dun_load(PLYROOM);
    ctr = 0;
    setmem(dshad, 100, 0);
    for (i = 0; i < 4; i++) {
        alshad[i] = 0;
    }
    strcpy(stat, " ");
    for (i=0; i<maxcreat; i++) {
        if (i != dusrnum && getply(i)->dunaptr.stt == PLAYING) {
            dunoth=getply(i);
            if (dunwho->dunxc == dunoth->dunxc && 
	        dunwho->dunyc == dunoth->dunyc && 
		dunwho->dunzc == dunoth->dunzc) {
                if (!(dunoth->dunaptr.mutflags&INVIS) && ctr < 99) {
		    ref[ctr] = i;
		    ctr++;
                }
            }
            else {
	        // modified 04.13.93
                for (ii=0; ii<4; ii++) {
                    if (proomptr.prmdir[ii] > 0 && proomptr.prmdir[ii] < 11) {
                        if (dunwho->dunxc == dunoth->dunxc-genx[ii] && 
	                    dunwho->dunyc == dunoth->dunyc-geny[ii] &&
	                    dunwho->dunzc == dunoth->dunzc) {
                            if (!(dunoth->dunaptr.mutflags&INVIS)) {
			        if (alshad[ii] == 0) {
                                    strcpy(stat, " to the ");
                                    strcat(dshad, gendir[ii]);
                                    strcat(dshad, ", ");
	  	   	  	    alshad[ii] = 1;
				}
                            }
                        }
                    }
                }
            }
        }
    }
    if (ctr > 0) {
        for (i=0; i<ctr; i++) {
            prf("%s", getply(ref[i])->dunname);
            if (i < (ctr-1)) prf(", ");
            else prf(" ");
            if (i == (ctr - 2) && ctr > 1) prf("and ");
        }
        if (ctr > 1) prf("are here with you.\r");
        else prf("is here.\r");
        dun_outply(dusrnum);
    }
    if (sameas(dmargv[0], "who")) {
        if (ctr == 0) dun_msg(dusrnum, LOONO, NONE4);
        prf_msg(LOOW, dunwho->dunname, NONE3);
        dun_outdun(PLYROOM, dusrnum, -1, 0);
    }
    if (dshad[0] != '\0' && gloflag == 0) {
        dshad[strlen(dshad)-2] = '\0';
        dun_msg(dusrnum, SHADO, stat, dshad, NONE2);
    }
    /* monsters hostile v 2.20 */
    if (!(dunwho->dunaptr.mutflags&INVIS)) {
        flag = 0;
        if (dmargc == 1 && ctr > 0) {
            for (i = 0; i < ctr; i++) {
                if (dun_rand(HOSTILE) == 0) {
	            if (sameas(getply(ref[i])->dunaptr.pcomba, "ROAM IT")) {
		        flag = 1;
  	                strncpy(getply(ref[i])->dunaptr.pcomba, dunwho->dunname, NAMSIZ);
      	                if (i > 0) prf("***\r");
	                prf("%s ",   getply(ref[i])->dunname);
	                prf("%s's ", pmonsptr[getply(ref[i])->duncla].montal);
	                prf("%s, ",  pmonsptr[getply(ref[i])->duncla].monbat);
	                prf("%s!\r", dunwho->dunname);
	  	    }
  	        }
            }
            if (flag == 1) dun_outdun(PLYROOM, -1, -1, 4);
        }
    }
}

void
dun_stat(void)   /* player statistics */
{
    prf("\r");
    prf("%sName: %s%s / %s\r", CYAN, YELLOW, dunwho->dunname, classptr[dunwho->duncla].clanam);
    prf("%sExhaustion    : %s%-3d%\r", CYAN, YELLOW, dunwho->dunaptr.exhaust);
    prf("%sStr: %s%-3d    %sInt: %s%-3d   %sWis: %s%-3d\r", CYAN, YELLOW, dunwho->dunstr, CYAN, YELLOW, dunwho->dunint, CYAN, YELLOW, dunwho->dunwis);
    prf("%sDex: %s%-3d    %sCon: %s%-3d   %sCha: %s%-3d\r", CYAN, YELLOW, dunwho->dundex, CYAN, YELLOW, dunwho->duncon, CYAN, YELLOW, dunwho->duncha);
    prf("%sHit Points    %s: %-3d / %-3d", CYAN, YELLOW, dunwho->dunhp, dunwho->maxhp);
    if (dunwho->poison > 0) prf(" %sPOISONED!", RED);
    prf("\r");
    prf("%sExp. Points   : %s%-7s %sLevel: %s%-3d\r", CYAN, YELLOW, spr("%ld", dunwho->dunscr), YELLOW, YELLOW, dunwho->dunlev);
    prf("%sRiblets       : %s%-7s\r", CYAN, YELLOW, spr("%ld", dunwho->dungold));
    prf("%sIons          : %s%-7s\r", CYAN, YELLOW, spr("%ld", dunwho->spcomp));
    prf("%sWearing Armor : ", CYAN);
    if (dunwho->dunarm > -1) prf("%s%s ", YELLOW, pitemptr[dunwho->dunarm].pitnam);
    else prf("%sNothing.", YELLOW);
    prf(" %sArmour Class: %s%-3d\r", CYAN, YELLOW, dun_armor(dusrnum));
    prf("%sReady to Combat: %s%-30s\r", CYAN, YELLOW, dunwho->dunaptr.pcomba);
    prf("%sReadied Spell  : %s", CYAN, YELLOW);
    dun_spre();
    prf("%sYear A.D.      : %s%d\r", CYAN, YELLOW, (dunwho->dunzc * 100) + 2000);
    prf("\r");
    dun_inv();
}

void
dun_inv(void)    /* player inventory */
{
    int i, pstat[1000], pflag;
    char ptemp[200];
    strcpy(ptemp, "");
    for (i=0; i<itemsiz; i++) {
        pstat[i] = 0;
    }
    prf_msg(INV, YELLOW, spr("%d", dunwho->dunaptr.totwt), NONE2);
    pflag = 0;
    for (i=0; i<10; i++) {
        if (dunwho->dunite[i] > -1) {
            strcat(ptemp, ITEMSCAN.pitnam);
            if (pstat[dunwho->dunite[i]] > 0) {
                strcat(ptemp, spr(" (%d)",pstat[dunwho->dunite[i]]));
            }
            strcat(ptemp, ", ");
            pstat[dunwho->dunite[i]]++;
            pflag = 1;
        }
    }
    if (pflag == 0) strcat(ptemp, "Nothing.");
    else ptemp[strlen(ptemp)-2] = '.';
    prf("%s%s\r", ptemp, CYAN);
    dun_outply(dusrnum);
    dun_load(PLYROOM);
    if (sameas(dmargv[0], "inv") && dun_dark(0) == 0 && !(dunwho->dunaptr.mutflags&INVIS)) {
        prf_msg(SUP, dunwho->dunname, SEX, NONE2);
        dun_outdun(PLYROOM, dusrnum, -1, 0);
    }
}

void
dun_item(void)    /* items on the ground */
{
    int i, pflag, pstat[1000];
    char ptemp[255], temp[30];
    strcpy(ptemp, "");
    pflag = 0;
    for (i=0; i<itemsiz; i++) {
        pstat[i] = 0;
    }
    dun_load(PLYROOM);
    for (i=0; i<6; i++) {
        if (proomptr.pitem[i] > -1) {
            strncpy(temp, pitemptr[proomptr.pitem[i]].pitnam, 30);
            if (temp[strlen(temp)-1] != 's') {
                strcat(ptemp, dun_aoran(temp, 0));
            }
            strcat(ptemp, temp);
            if (pstat[proomptr.pitem[i]] > 0) {
                strcat(ptemp, spr(" (%d)", pstat[proomptr.pitem[i]]));
            }
            strcat(ptemp, ", ");
            pstat[proomptr.pitem[i]]++;
            pflag = 1;
        }
    }
    if (pflag != 0) {
        ptemp[strlen(ptemp)-2] = '.';
        dun_msg(dusrnum, GRO, YELLOW, CYAN, ptemp, NONE1);
    }
    if (sameas(dmargv[0], "items")) {
        if (pflag == 0) dun_msg(dusrnum, LONGR, NONE4);
        prf_msg(PLLOO, dunwho->dunname, NONE3);
        dun_outdun(PLYROOM, dusrnum, -1, 0);
    }
}

void
dun_drop(void)   /* drop an item */
{
    int flag, flag2, i, tempi, temps;
    if (dmargc < 2) dun_hlp();
    else {
        flag = dun_ihand(dmargv[1], 2);
        if (flag > -1) {
            dun_msg(dusrnum, DROPI, pitemptr[dunwho->dunite[flag]].pitnam, NONE3);
            if (dun_dark(0) == 0 && !(dunwho->dunaptr.mutflags&INVIS)) {
                prf("%s dropped %s %s.\r", dunwho->dunname, SEX, pitemptr[dunwho->dunite[flag]].pitnam);
            }
            else {
                dun_msg(dusrnum, HITGR, NONE4);
            }
            dun_outdun(PLYROOM, dusrnum, -1, 0);
            dun_load(PLYROOM);
            flag2 = -1;
            for (i=0; i<6; i++) {
                if (proomptr.pitem[i] == -1) {
                    flag2 = i;
                    i = 6;
                }
            }
            if (flag2 == -1) {
                flag2 = dun_rand(6);
                if (dun_dark(0) == 0) {
                    dun_msg(dusrnum, IMA, dun_aoran(pitemptr[proomptr.pitem[flag2]].pitnam, 0), pitemptr[proomptr.pitem[flag2]].pitnam, NONE2);
                    prf_msg(IDI, pitemptr[proomptr.pitem[flag2]].pitnam, NONE3);
                    dun_outdun(PLYROOM, dusrnum, -1, 0);
                }
                else dun_msg(dusrnum, MENT, pitemptr[dunwho->dunite[flag]].pitnam, NONE3);
            }
            tempi = proomptr.pitem[flag2];
            temps = proomptr.pitst[flag2];
            proomptr.pitem[flag2] = dunwho->dunite[flag];
            proomptr.pitst[flag2] = dunwho->dunist[flag];
            dunwho->dunaptr.totwt-=pitemptr[dunwho->dunite[flag]].wieght;
            updcas();
            dunwho->dunite[flag] = tempi;
            dunwho->dunist[flag] = temps;
            if (tempi > -1) {
                dunwho->dunaptr.totwt+=pitemptr[dunwho->dunite[flag]].wieght;
            }
            if (dunwho->dunaptr.mutflags&ENCUMD && dunwho->dunaptr.totwt < 
	    (doptions.mxwgt * dunwho->dunstr)) {
                dunwho->dunaptr.mutflags&=~ENCUMD;
            }
        }
        else dun_msg(dusrnum, NOTCAR, dmargv[1], NONE3);
    }
}

void
dun_get(void)   /* get an item */
{
    int i, pflag1, pflag2, ptemp, ptemp2;
    if (dmargc < 2) dun_hlp();
    else {
        dun_load(PLYROOM);
        if (dun_dark(0) == 1) {
            dun_msg(dusrnum, TOODARK, NONE4);
        }
        else {
            pflag1 = -1;
            for (i=0; i<10; i++) {
                if (dunwho->dunite[i] == -1) {
                    pflag1 = i;
                    i = 11;
                }
            }
            pflag2 = dun_ifloor(dmargv[1], 2);
            if (pflag2 > -1) {
                ptemp = -1;
                ptemp2 = -1;
                if (pitemptr[proomptr.pitem[pflag2]].wieght > (MAXSTR * 2) && dusrnum < monstart) dun_msg(dusrnum, NOSTR, NONE4);
                else {
                    if (pflag1 == -1) {
                        pflag1 = dun_rand(10);
                        dun_msg(dusrnum, FESAC, pitemptr[dunwho->dunite[pflag1]].pitnam, NONE3);
                        if (!(dunwho->dunaptr.mutflags&INVIS)) {
                            prf_msg(OFES, dun_aoran(pitemptr[dunwho->dunite[pflag1]].pitnam, 0), pitemptr[dunwho->dunite[pflag1]].pitnam, dunwho->dunname, NONE1);
                        }
                        else {
                            prf_msg(IMAP, dun_aoran(pitemptr[dunwho->dunite[pflag1]].pitnam, 0), pitemptr[dunwho->dunite[pflag1]].pitnam, NONE2);
                        }
                        dun_outdun(PLYROOM, dusrnum, -1, 0);
                        ptemp = dunwho->dunite[pflag1];
                        ptemp2 = dunwho->dunist[pflag1];
                    }
                    dun_msg(dusrnum, PIC, pitemptr[proomptr.pitem[pflag2]].pitnam, NONE3);
                    if (!(dunwho->dunaptr.mutflags&INVIS)) {
                        prf_msg(HPIC, dunwho->dunname, pitemptr[proomptr.pitem[pflag2]].pitnam, NONE2);
                    }
                    else {
                        prf_msg(IDI, pitemptr[proomptr.pitem[pflag2]].pitnam, NONE3);
                    }
                    dun_outdun(PLYROOM, dusrnum, -1, 0);
                    if (proomptr.pitem[pflag2] > -1) {
                        dunwho->dunaptr.totwt+=pitemptr[proomptr.pitem[pflag2]].wieght;
                    }
                    dunwho->dunite[pflag1] = proomptr.pitem[pflag2];
                    dunwho->dunist[pflag1] = proomptr.pitst[pflag2];
                    if (ptemp > -1) {
                        dunwho->dunaptr.totwt-=pitemptr[pflag2].wieght;
                    }
                    proomptr.pitem[pflag2] = ptemp;
                    proomptr.pitst[pflag2] = ptemp2;
                    updcas();
                }
            }
            else dun_msg(dusrnum, NOI, dmargv[1], NONE3);
        }
    }
}

void
dun_thro(void)    /* throw something! */
{
    char ptemrm[10];
    int i, pflag, dir, dir2, dira, tstat, titem, itemh;
    if (dmargc < 3) dun_hlp();
    else {
        itemh = dun_ihand(dmargv[2], 3);
        if (itemh == -1) dun_msg(dusrnum, NOTCAR, dmargv[1], NONE3);
        else {
            dun_load(PLYROOM);
            strcpy(ptemrm, "0\0");
            dir = dun_getdir(dmargv[1]);
            if (dir > -1) {
                dun_msg(dusrnum, THRO, pitemptr[dunwho->dunite[itemh]].pitnam, gendir[dir], NONE2);
                if (!(dunwho->dunaptr.mutflags&INVIS)  && dun_dark(0) == 0) {
                    prf_msg(HTHRO, dunwho->dunname, SEX, pitemptr[itemh].pitnam, gendir[dir]);
                    dun_outdun(PLYROOM, dusrnum, -1, 1);
                }
                dunwho->dunaptr.totwt-=pitemptr[dunwho->dunite[itemh]].wieght;
                dir2 = 1;
                if (dir == 1 || dir == 3) dir2 = -1;
                dira = proomptr.prmdir[dir];
                strncpy(ptemrm, dun_getrm(dunwho->dunxc+genx[dir], dunwho->dunyc+geny[dir], dunwho->dunzc+genz[dir]), 10);
                if (dira != 1 && dira != 10) strncpy(ptemrm, PLYROOM, 10);
                if (!sameas(PLYROOM, ptemrm)) dun_load(ptemrm);
                pflag = -1;
                for (i=0; i<6; i++) {
                    if (proomptr.pitem[i] == -1) {
                        pflag = i;
                        i = 7;
                    }
                }
                titem = -1;
                tstat = -1;
                if (pflag == -1) {
                    pflag = dun_rand(6);
                    dun_msg(dusrnum, IMA, dun_aoran(pitemptr[proomptr.pitem[pflag]].pitnam,0), pitemptr[proomptr.pitem[pflag]].pitnam, NONE2);
                    dun_outply(dusrnum);
                    if (dun_dark(0) == 0) {
                        prf_msg(IDI, pitemptr[proomptr.pitem[pflag]].pitnam, NONE3);
                        dun_outdun(ptemrm, dusrnum, -1, 0);
                    }
                    titem = proomptr.pitem[pflag];
                    tstat = proomptr.pitst[pflag];
                    dunwho->dunaptr.totwt+=pitemptr[titem].wieght;
                }
                proomptr.pitem[pflag] = dunwho->dunite[itemh];
                proomptr.pitst[pflag] = dunwho->dunist[itemh];
                updcas();
                if (dira == 1) {
                    if (dun_dark(0) == 0) {
                        prf_msg(LANDD, pitemptr[dunwho->dunite[itemh]].pitnam, gendir[dir+dir2], NONE2);
                        dun_outdun(ptemrm, dusrnum, -1, 1);
                    }
                }
                else {
                    if (dun_dark(0) == 0) {
                        prf_msg(LANDF, pitemptr[dunwho->dunite[itemh]].pitnam, NONE3);
                    }
                    else {
                        prf_msg(HITGR, NONE4);
                    }
                    dun_outdun(PLYROOM, -1, -1, 1);
                }
                dunwho->dunite[itemh] = titem;
                dunwho->dunist[itemh] = tstat;
                if (dunwho->dunaptr.totwt <= (doptions.mxwgt * dunwho->dunstr)
		&& dunwho->dunaptr.mutflags&ENCUMD) {
		    dunwho->dunaptr.mutflags&=~ENCUMD;
		}
            }
            else dun_hlp();
        }
    }
}

void
dun_comb(void)  /* combat a player */
{
    int flag;
    if (dmargc < 2) dun_hlp();
    else {
        dun_load(PLYROOM);
        if (dun_dark(0) == 1) dun_msg(dusrnum, TOODARK, NONE4);
        else {
            flag = dun_isply(dmargv[1], PLYROOM, 2);
            if (flag == -1) dun_msg(dusrnum, NOI, dmargv[1], NONE3);
            else {
                if (flag == dusrnum) dun_msg(dusrnum, CANTCOY, NONE4);
                else {
                    strncpy(dunwho->dunaptr.pcomba, getply(flag)->dunname , NAMSIZ);
                    if (dusrnum > monstart -1) {
                        prf("The %s %s's %s, %s!\r", dunwho->dunname, pmonsptr[dunwho->duncla].montal, pmonsptr[dunwho->duncla].monbat, dunwho->dunaptr.pcomba);
                        dun_outdun(PLYROOM, dusrnum, -1, 4);
                        dun_monconf(dusrnum);
                    }
                    if (dunwho->dunaptr.mutflags&INVIS) {
		        dun_disin();
		    }
                    dun_msg(dusrnum, RCOM1, dunwho->dunaptr.pcomba, NONE3);
                    dun_msg(flag, RCOM2, dunwho->dunname, NONE3);
                    prf_msg(RCOM3, dunwho->dunname, dunwho->dunaptr.pcomba, NONE2);
                    dun_outdun(PLYROOM, dusrnum, flag, 0);
                }
            }
        }
    }
}

void
dun_attk(void)  /* attack a player with hand-hand combat */
{
    int flag;
    char ptemp[NAMSIZ];
    dun_load(PLYROOM);
    if (dun_dark(0) == 1) {
        dun_msg(dusrnum, TOODARK, NONE4);
    }
    else {
        if (dmargc == 1) strncpy(ptemp, dunwho->dunaptr.pcomba, NAMSIZ);
        else strncpy(ptemp, dmargv[1], NAMSIZ);
        ptemp[19] = '\0';
        flag = dun_isply(ptemp, PLYROOM, 2);
        if (flag == -1) {
            if (dmargc == 1) {
                if (!sameas(dunwho->dunaptr.pcomba, "")) dun_msg(dusrnum, NOI, dunwho->dunaptr.pcomba, NONE3);
                else dun_msg(dusrnum, COMWHO, NONE4);
            }
            else dun_msg(dusrnum, WNH, dmargv[1], NONE3);
        }
        else {
            if (sameas(getply(flag)->dunname, dunwho->dunname)) {
                dun_msg(dusrnum, CANTCOY, NONE4);
            }
            else {
                if (dunwho->dunaptr.mutflags&INVIS) {
		    dun_disin();
		}
                if (dun_chkhit(flag, -1) == 1) {
                    dun_msg(dusrnum, MIS2, dun_ing(dmargv[0]), getply(flag)->dunname, NONE2);
                    dun_msg(flag, MIS3, dunwho->dunname, dun_ing(dmargv[0]), NONE2);
                    prf_msg(MIS4, dunwho->dunname, dun_ing(dmargv[0]), getply(flag)->dunname, NONE1);
                    dun_outdun(PLYROOM, dusrnum, flag, 5);
                    if (flag > monstart-1) dun_monconf(flag);
                    dun_dam(dusrnum, flag, -1);
                }
                else {
                    dun_msg(dusrnum, UMIS, NONE4);
                    prf_msg(HMIS, dunwho->dunname, dun_ing(dmargv[0]), getply(flag)->dunname, NONE1);
                    dun_outdun(PLYROOM, dusrnum, flag, 0);
                    dun_msg(flag, YMIS, dunwho->dunname, dun_ing(dmargv[0]), NONE2);
                }
            }
        }
    }
}

void
dun_wiel(void)      /* wield a weopon */
{
    int flag, tex, itemh;
    if (dmargc < 2) dun_hlp();
    else {
        dun_load(PLYROOM);
        if (dun_dark(0) == 1) {
            dun_msg(dusrnum, TOODARK, NONE4);
        }
        else {
            flag = dun_isply(dunwho->dunaptr.pcomba, PLYROOM, 10);
            if (flag > -1) {
                itemh = dun_ihand(dmargv[1], 2);
                if (itemh > -1) {
                    if (pitemptr[dunwho->dunite[itemh]].wieght > MAXSTR && dusrnum < monstart) {
                        dun_msg(dusrnum, NSTRW, NONE4);
                    }
                    else if (dunwho->dunaptr.mutflags&ENCUMD && dusrnum < monstart) {
		        dun_msg(dusrnum, TOEN, NONE4);                    
		    }
		    else if (dunwho->dunaptr.exhaust > 99 && dusrnum < monstart) {
		        dun_msg(dusrnum, TOEX, NONE4);
		    }
                    else {
                        if (dunwho->dunaptr.mutflags&INVIS) {
			    dun_disin();
			}
                        if (dun_chkhit(flag, itemh) == 1) {
                            dun_msg(dusrnum, PLHIT, getply(flag)->dunname, pitemptr[dunwho->dunite[itemh]].pitnam, NONE2);
                            dun_msg(flag, WHHIT, dunwho->dunname, SEX, pitemptr[dunwho->dunite[itemh]].pitnam, NONE1);
                            prf_msg(ALHIT, dunwho->dunname, getply(flag)->dunname, SEX, pitemptr[dunwho->dunite[itemh]].pitnam);
                            dun_outdun(PLYROOM, dusrnum, flag, 5);
                            if (flag > monstart - 1) dun_monconf(flag);
                            tex = pitemptr[dunwho->dunite[itemh]].wieght - dunwho->duncon;
                            if (tex > 0) dunwho->dunaptr.exhaust+=tex;
                            if (dunwho->dunaptr.exhaust > 100) dunwho->dunaptr.exhaust = 100;
                            dun_dam(dusrnum, flag, itemh);
                        }
                        else {
                            dun_msg(dusrnum, DODGE, getply(flag)->dunname, NONE3);
                            dun_msg(flag, MISS5, dunwho->dunname, SEX, pitemptr[dunwho->dunite[itemh]].pitnam, NONE1);
                            prf_msg(MISS6, dunwho->dunname, getply(flag)->dunname, SEX, pitemptr[dunwho->dunite[itemh]].pitnam);
                            dun_outdun(PLYROOM, dusrnum, flag, 0);
                        }
                    }
                }
                else dun_msg(dusrnum, NOTCAR, dmargv[1], NONE3);
            }
            else {
                if (!sameas(dunwho->dunaptr.pcomba, "")) dun_msg(dusrnum, WHN, dunwho->dunaptr.pcomba, NONE3);
                else dun_msg(dusrnum, NOTRC, NONE4);
            }
        }
    }
}

void
dun_lspe(void)  /* list a players spells */
{
    int i, flag, ctr, cost;
    flag = 0;
    ctr = 0;
    for (i=0; i<20; i++) {
        if (dunwho->dunspe[i] > -1) {
            if (flag == 0) prf_msg(TRIO, NONE4);
            cost = pspelptr[dunwho->dunspe[i]].spemem - dunwho->dunint;
            if (cost < 0) cost = 0;
            prf("%-20s: %-3d ", pspelptr[dunwho->dunspe[i]].spenam, cost);
            flag = 1;
            ctr++;
            if (ctr > 2) {
                prf("\r");
                ctr = 0;
            }
        }
    }
    if (flag == 0) prf_msg(TRII, NONE4);
    else if (flag == 1) prf("\r");
    dun_outply(dusrnum);
}

void
dun_wear(void)     /* wear some armor */
{
    int flag, flag2, flag3;
    if (dmargc < 2) dun_hlp();
    else {
        flag = dun_ihand(dmargv[1], 2);
        if (flag == -1) dun_msg(dusrnum, NOTCAR, dmargv[1], NONE3);
        else {
            flag2 = -1;
            flag3 = -1;
            if (pitemptr[dunwho->dunite[flag]].pitty != 2) dun_msg(dusrnum, NOTAR, NONE4);
            else {
                if (dunwho->dunarm > -1) {
                    flag2 = dunwho->dunarm;
                    flag3 = dunwho->dunast;
                    dunwho->dunaptr.totwt = dunwho->dunaptr.totwt + pitemptr[flag2].wieght;
                    dun_msg(dusrnum, REAR, pitemptr[flag2].pitnam, NONE3);
                    prf_msg(REARA, dunwho->dunname, SEX, pitemptr[flag2].pitnam, NONE1);
                    dun_outdun(PLYROOM, dusrnum, -1, 0);
                }
                dunwho->dunarm = dunwho->dunite[flag];
                dunwho->dunast = dunwho->dunist[flag];
                if (flag2 == -1) {
                    dunwho->dunite[flag] = -1;
                    dunwho->dunist[flag] = -1;
                }
                else {
                    dunwho->dunite[flag] = flag2;
                    dunwho->dunist[flag] = flag3;
                }
                dunwho->dunaptr.totwt = dunwho->dunaptr.totwt - pitemptr[dunwho->dunarm].wieght;
                dun_msg(dusrnum, PUTAR, pitemptr[dunwho->dunarm].pitnam, NONE3);
                prf_msg(PUTARA, dunwho->dunname, SEX, pitemptr[dunwho->dunarm].pitnam, NONE1);
                dun_outdun(PLYROOM, dusrnum, -1, 0);
            }
        }
    }
}

void
dun_remo(void)   /* remove armor */
{
    int flag, i;
    if (dunwho->dunarm > -1) {
        flag = -1;
        for (i=0; i<10; i++) {
            if (dunwho->dunite[i] == -1) {
                flag = i;
                i = 10;
            }
        }
        if (flag > -1) {
            dun_msg(dusrnum, REMAR, pitemptr[dunwho->dunarm].pitnam, NONE3);
            prf_msg(REMARA, dunwho->dunname, SEX, pitemptr[dunwho->dunarm].pitnam, NONE1);
            dun_outdun(PLYROOM, dusrnum, -1, 0);
            dunwho->dunaptr.totwt = dunwho->dunaptr.totwt + pitemptr[dunwho->dunarm].wieght;
            dunwho->dunite[flag] = dunwho->dunarm;
            dunwho->dunist[flag] = dunwho->dunast;
            dunwho->dunarm = -1;
            dunwho->dunast = -1;
        }
        else dun_msg(dusrnum, TOENT, NONE4);
    }
    else dun_msg(dusrnum, NOTARM, NONE4);
}

void
dun_sell(void)
{
    int flag, i, flag2;
    long amount;
    char temp[200];
    if (dmargc < 2) dun_hlp();
    else {
        if (sameas(dmargv[1], "store")) {
            if (dmargc < 3) dun_hlp();
            else {
                setbtv(psalebb);
                if (qeqbtv(PLYROOM, 0)) {
                    gcrbtv(&psaleptr, 0);
                    if (sameas(psaleptr.namind, dunwho->dunname)) {
                        psaleptr.sellval = atol(dmargv[2]);
                        dunwho->dungold = dunwho->dungold + psaleptr.cash;
                        dun_msg(dusrnum, YOUSELL, spr("%ld", psaleptr.cash), NONE3);
                        psaleptr.cash = 0L;
                        updbtv(&psaleptr);
                        dun_load(PLYROOM);
                        setmem(proomptr.sign, 50, 0);
                        sprintf(proomptr.sign, "FOR SALE BY OWNER $ %ld", psaleptr.sellval);
                        proomptr.trade = 2;
                        updcas();
                    }
                    else dun_msg(dusrnum, NOTYERS, NONE4);
                }
                else dun_msg(dusrnum, NOTYERS, NONE4);
            }
        }
        else {
            dun_load(PLYROOM);
            if (proomptr.trade != 1) {
                dun_msg(dusrnum, NOTRADE, NONE4);
            }
            else {
                flag = dun_ihand(dmargv[1], 2);
                if (flag > -1) {
                    setbtv(psalebb);
                    if (qeqbtv(PLYROOM, 0)) {
                        gcrbtv(&psaleptr, 0);
                        flag2 = -1;
                        for (i=0; i<20; i++) {
                            if (psaleptr.itsale[i] == -1) {
                                flag2 = i;
                                i = 20;
                            }
                        }
                    }
                    if (flag2 > -1) {
                        amount = dun_worth(dunwho->dunist[flag], dunwho->dunite[flag]);
                        amount = amount + ((amount * dun_mark(0))/100);
                        if (amount < 1) dun_msg(dusrnum, DONTWANT, NONE4);
                        else if (amount > psaleptr.cash) dun_msg(dusrnum, CANTAFF, NONE4);
                        else {
			    dunwho->dunaptr.totwt-=pitemptr[dunwho->dunite[flag]].wieght;
                            dun_msg(dusrnum, SOLD, pitemptr[dunwho->dunite[flag]].pitnam, spr("%ld", amount), NONE2);
                            dunwho->dungold = dunwho->dungold + amount;
                            psaleptr.itsale[flag2] = dunwho->dunite[flag];
                            psaleptr.itstat[flag2] = dunwho->dunist[flag];
                            if (!sameas(psaleptr.namind, "Village Shop")) {
                                psaleptr.cash = psaleptr.cash - amount;
                            }
                            updbtv(&psaleptr);
                            dunwho->dunite[flag] = -1;
                            dunwho->dunist[flag] = -1;
                            setmem(temp, 200, 0);
                            sprintf(temp, "%s sold one of your stores a %s for $ %ld!",
                            dunwho->dunname, pitemptr[psaleptr.itsale[flag2]].pitnam, amount);
                            dun_log(psaleptr.namind, temp, -10);
                        }
                    }
                    else dun_msg(dusrnum, OVS, NONE4);
                }
                else dun_msg(dusrnum, NOTCAR, dmargv[1], NONE3);
            }
        }
    }
}

void
dun_appr(void)      /* appraise an item */
{
    int flag;
    long amount;
    dun_load(PLYROOM);
    if (dmargc < 2) dun_hlp();
    else {
        if (proomptr.maint == 1) {
            dun_cost();
        }
        else {
            if (proomptr.trade != 1) {
                dun_msg(dusrnum, NOTRADE, NONE4);
            }
            else {
                flag = dun_ihand(dmargv[1], 2);
                if (flag > -1) {
                    amount = dun_worth(dunwho->dunist[flag], dunwho->dunite[flag]);
                    amount = amount + ((amount * dun_mark(0))/100);
                    if (amount < 1) {
                        dun_msg(dusrnum, WONOT, NONE4);
                    }
                    else {
                        dun_msg(dusrnum, APPR, pitemptr[dunwho->dunite[flag]].pitnam, spr("%ld", amount), NONE2);
                    }
                }
                else dun_msg(dusrnum, NOTCAR, dmargv[1], NONE3);
            }
        }
    }
}

void
dun_cost(void)     /* how much will an item cost to fix */
{
    int flag;
    long cost;
    if (dmargc < 2) dun_hlp();
    else {
        dun_load(PLYROOM);
        if (proomptr.maint > 0) {
            flag = dun_ihand(margv[1], 2);
            if (flag > -1) {
                if (dunwho->dunist[flag] > 0) {
                    cost = (pitemptr[dunwho->dunite[flag]].pdsta - dunwho->dunist[flag]) * pitemptr[dunwho->dunite[flag]].fixval;
                    if (cost < 1) {
                        dun_msg(dusrnum, NOCOST, pitemptr[dunwho->dunite[flag]].pitnam, NONE3);
                    }
                    else {
                        dun_msg(dusrnum, COSTS, spr("%ld", cost), NONE3);
                    }
                }
                else dun_msg(dusrnum, CANTFIX, NONE4);
            }
            else dun_msg(dusrnum, NOTCAR, dmargv[1], NONE3);
        }
        else dun_msg(dusrnum, NOTRADE, NONE4);
    }
}

void
dun_fix(void)    /* fix an item */
{
    int flag;
    long cost;
    if (dmargc < 2) dun_hlp();
    else {
        dun_load(PLYROOM);
        if (proomptr.maint > 0) {
            flag = dun_ihand(dmargv[1], 2);
            if (flag > -1) {
                if (dunwho->dunist[flag] > 0) {
                    cost = (pitemptr[dunwho->dunite[flag]].pdsta - dunwho->dunist[flag]) * pitemptr[dunwho->dunite[flag]].fixval;
                    if (cost <= dunwho->dungold) {
                        if (cost <= 0) dun_msg(dusrnum, NOCOST, pitemptr[dunwho->dunite[flag]].pitnam, NONE3);
                        else {
                            dun_msg(dusrnum, FIXED, spr("%ld", cost), pitemptr[dunwho->dunite[flag]].pitnam, NONE2);
                            dunwho->dungold = dunwho->dungold - cost;
                            dunwho->dunist[flag] = pitemptr[dunwho->dunite[flag]].pdsta;
                        }
                    }
                    else {
                        dun_msg(dusrnum, NOGOLD, spr("%ld", cost), NONE3);
                    }
                }
                else dun_msg(dusrnum, CANTFIX, NONE4);
            }
            else dun_msg(dusrnum, NOTCAR, dmargv[1], NONE3);
        }
        else dun_msg(dusrnum, NOTRADE, NONE4);
    }
}

void
dun_buy(void)  
{
    // purchase stuff
    int i, flag, which, hand, flag2, ctr;
    char temp[200];
    long amount;
    dun_load(PLYROOM);
    flag2 = 0;
    if (dmargc > 1) {
        if (sameas(dmargv[1], "credits")) {
	    buycreds();
	    flag2 = 1;
	}
	else if (sameas(dmargv[1], "ions")) {
	    buyions();
	    flag2 = 1;
	}
        else if (sameas(dmargv[1], "store")) {
            flag2 = 1;
            if (proomptr.trade == 2) {
                i = dun_mark(0);
                if (dunwho->dungold >= psaleptr.sellval) {
                    dunwho->dungold = dunwho->dungold - psaleptr.sellval;
                    if (!sameas(psaleptr.namind, "FOR SALE")) {
                        setmem(temp, 200, 0);
                        sprintf(temp, "%s has purchased one of your stores!", dunwho->dunname);
                        dun_log(psaleptr.namind, temp, 0);
                        dun_log(psaleptr.namind, "POST\0", psaleptr.sellval);
                        setbtv(psalebb);
                    }
                    strncpy(psaleptr.namind, dunwho->dunname, NAMSIZ);
                    updbtv(&psaleptr);
                    proomptr.trade = 1;
                    setmem(proomptr.sign, 50, 0);
                    strcat(proomptr.sign, "STORE OWNED BY ");
                    strcat(proomptr.sign, dunwho->dunname);
                    updcas();
                    dun_msg(dusrnum, BUYSTR, NONE4);
                }
                else dun_msg(dusrnum, NOGOLD2, spr("%ld", psaleptr.sellval), NONE3);
            }
            else dun_msg(dusrnum, NOSALE, NONE4);
        }
    }
    if (flag2 == 0) {
        if (proomptr.trade == 1) {
            setbtv(psalebb);
            qeqbtv(PLYROOM, 0);
            gcrbtv(&psaleptr, 0);
            if (dmargc > 1) {
                which = atoi(dmargv[1]);
                if (which > 0 && which < 21) {
                    which--;
                    if (psaleptr.itsale[which] > -1) {
                        amount = dun_worth(psaleptr.itstat[which], psaleptr.itsale[which]);
                        amount = amount + ((amount * dun_mark(1))/100);
                        if (amount < 0) amount = 0;
                        if (dunwho->dungold >= amount) {
                            hand = -1;
                            for (i=0; i<6; i++) {
                                if (dunwho->dunite[i] == -1) {
                                    hand = i;
                                    i = 6;
                                }
                            }
                            if (hand > -1) {
                                dunwho->dunite[hand] = psaleptr.itsale[which];
                                dunwho->dunist[hand] = psaleptr.itstat[which];
				dunwho->dunaptr.totwt+=pitemptr[dunwho->dunite[hand]].wieght;
                                psaleptr.itsale[which] = -1;
                                psaleptr.itstat[which] = -1;
                                psaleptr.cash = psaleptr.cash + amount;
                                updbtv(&psaleptr);
                                dun_msg(dusrnum, SOLDIT, spr("%ld", amount), pitemptr[dunwho->dunite[hand]].pitnam, NONE2);
                                dunwho->dungold = dunwho->dungold - amount;
                                setmem(temp, 200, 0);
                                sprintf(temp, "%s purchased a %s for $ %ld!", dunwho->dunname, pitemptr[dunwho->dunite[hand]].pitnam, amount);
                                dun_log(psaleptr.namind, temp, -10);
				// mod 05/01/93
				if (pitemptr[dunwho->dunite[hand]].wieght > (MAXSTR * 2) 
				&& dusrnum < monstart) { 
				    prf("It's too heavy to carry!\r");
				    outprf(dusrnum);
				    strncpy(dmargv[0], "drop", 10);
				    strncpy(dmargv[1], pitemptr[dunwho->dunite[hand]].pitnam, 20);
				    dmargc = 2;
				    dun_drop();
				}
                            }
                            else dun_msg(dusrnum, NOROOM, NONE4);
                        }
                        else dun_msg(dusrnum, NOGOLD, spr("%ld", amount), NONE3);
                    }
                    else dun_msg(dusrnum, NOTSELL, NONE4);
                }
                else dun_msg(dusrnum, NOTSELL, NONE4);
            }
            else {
                flag = 0;
                ctr = 0;
                for (i=0; i<20; i++) {
                    if (psaleptr.itsale[i] > -1) {
                        amount = dun_worth(psaleptr.itstat[i], psaleptr.itsale[i]);
                        amount = amount + ((amount * dun_mark(1))/100);
                        if (amount < 0) amount = 0;
                        if (flag == 0) dun_msg(dusrnum, FORSALE, NONE4);
                        prf("%2d. %-20s $ %-10s", i+1, pitemptr[psaleptr.itsale[i]].pitnam, spr("%ld", amount));
                        flag = 1;
                        ctr++;
                        if (ctr > 1) {
                            prf("\r");
                            ctr = 0;
                        }
                    }
                }
                if (flag == 0) dun_msg(dusrnum, NOSTOCK, NONE4);
                else {
                    prf("\r");
                    dun_outply(dusrnum);
                }
            }
        }
        else {
            if (proomptr.trade == 2) dun_hlp();
            else  dun_msg(dusrnum, NOTRADE, NONE4);
        }
    }
}

void
dun_repo(void)   /* report on a store */
{
    int flag, i;
    setbtv(psalebb);
    flag = 0;
    if (qeqbtv(PLYROOM, 0)) {
        gcrbtv(&psaleptr, 0);
        if (sameas(psaleptr.namind, dunwho->dunname)) {
            setmbk(dunmb);
            prfmsg(REPORT, spr("%ld", psaleptr.markup), spr("%ld", psaleptr.markdown), spr("%ld", psaleptr.cash), spr("%ld", psaleptr.taxrate));
            prfmsg(REPORT2, spr("%ld", psaleptr.security), spr("%ld", psaleptr.taxrate * 50));
            outprf(dusrnum);
        }
        else flag = 1;
    }
    else flag = 1;
    if (flag == 1) {
        dun_load(PLYROOM);
        if (proomptr.trade == 2) {
            setbtv(psalebb);
            if (qeqbtv(PLYROOM, 0)) {
                gcrbtv(&psaleptr, 0);
                dun_msg(dusrnum, ASSESS, spr("%ld", psaleptr.sellval), spr("%ld", psaleptr.taxrate * 50), spr("%ld", psaleptr.taxrate), NONE1);
                if (!sameas(psaleptr.namind, "FOR SALE")) prf("Owned By       : %s\r", psaleptr.namind);
                else prf("Owned By       : VILLAGE\r");
                outprf(dusrnum);
                flag = 0;
                for (i=0; i<20; i++) {
                    if (psaleptr.itsale[i] > -1) {
                        if (flag == 0) prf_msg(WSALE, NONE4);
                        prf("%d. %s\r", i+1, pitemptr[psaleptr.itsale[i]].pitnam);
                        flag = 1;
                    }
                }
                if (flag == 1) dun_outply(dusrnum);
            }
            else dun_msg(dusrnum, NOSALE2, NONE4);
        }
        else dun_msg(dusrnum, NOSALE2, NONE4);
    }
}

void
dun_stok(void)   /* stock a store with items */
{
    int flag, i, memb;
    if (dmargc < 2) dun_hlp();
    else {
        setbtv(psalebb);
        if (qeqbtv(PLYROOM, 0)) {
            gcrbtv(&psaleptr, 0);
            if (sameas(psaleptr.namind, dunwho->dunname)) {
                flag = dun_ihand(dmargv[1], 2);
                if (flag > -1) {
                    memb = -1;
                    for (i=0; i<20; i++) {
                        if (psaleptr.itsale[i] == -1) {
                            memb = i;
                            i = 20;
                        }
                    }
                    if (memb > -1) {
                        psaleptr.itsale[memb] = dunwho->dunite[flag];
                        psaleptr.itstat[memb] = dunwho->dunist[flag];
			dunwho->dunaptr.totwt-=pitemptr[dunwho->dunite[flag]].wieght;
                        dun_msg(dusrnum, INST, pitemptr[dunwho->dunite[flag]].pitnam, NONE3);
                        updbtv(&psaleptr);
                        dunwho->dunite[flag] = -1;
                        dunwho->dunist[flag] = -1;
                    }
                    else dun_msg(dusrnum, NOMR, NONE4);
                }
                else dun_msg(dusrnum, NOTCAR, dmargv[1], NONE3);
            }
            else dun_msg(dusrnum, NOTYERS, NONE4);
        }
        else dun_msg(dusrnum, NOTRADE, NONE4);
    }
}

void
dun_unst(void)  /* unstock an item from the store */
{
    int i, ctr, flag;
    setbtv(psalebb);
    if (qeqbtv(PLYROOM, 0)) {
        gcrbtv(&psaleptr, 0);
        if (sameas(psaleptr.namind, dunwho->dunname)) {
            if (dmargc < 2) {
                ctr = 0;
                flag = 0;
                prf("Stock Report\r------------\r");
                for (i=0; i<20; i++) {
                    if (psaleptr.itsale[i] > -1) {
                        prf("%2d. %-20s", i+1, pitemptr[psaleptr.itsale[i]].pitnam);
                        flag = 1;
                        ctr++;
                        if (ctr > 2) {
                            prf("\r");
                            ctr = 0;
                        }
                    }
                }
                if (flag == 0) prf("No inventory.");
                prf("\r\r");
                dun_hlp();
            }
            else {
                ctr = atoi(dmargv[1]);
                if (ctr > 0 && ctr < 21) {
                    ctr--;
                    if (psaleptr.itsale[ctr] > -1) {
                        flag = -1;
                        for (i=0; i<10; i++) {
                            if (dunwho->dunite[i] == -1) {
                                flag = i;
                                i = 10;
                            }
                        }
                        if (flag > -1) {
                            dunwho->dunite[flag] = psaleptr.itsale[ctr];
                            dunwho->dunist[flag] = psaleptr.itstat[ctr];
			    dunwho->dunaptr.totwt+=pitemptr[dunwho->dunite[flag]].wieght;
                            psaleptr.itsale[ctr] = -1;
                            psaleptr.itstat[ctr] = -1;
                            updbtv(&psaleptr);
                            dun_msg(dusrnum, GRABI, pitemptr[dunwho->dunite[flag]].pitnam, NONE3);
                        }
                        else dun_msg(dusrnum, TOEN5, NONE4);
                    }
                    else dun_msg(dusrnum, NOTIS, dmargv[1], NONE3);
                }
                else dun_hlp();
            }
        }
        else dun_msg(dusrnum, NOTYERS, NONE4);
    }
    else dun_msg(dusrnum, NOTRADE, NONE4);
}

void
dun_mrku(void) /* change markup */
{
    long newval;
    setbtv(psalebb);
    if (qeqbtv(PLYROOM, 0)) {
        gcrbtv(&psaleptr, 0);
        if (sameas(psaleptr.namind, dunwho->dunname)) {
            if (dmargc < 1) dun_hlp();
            else {
                newval = atol(dmargv[1]);
                if (newval < -3000 || newval > 3000) dun_msg(dusrnum, UNRE, NONE4);
                else {
                    psaleptr.markup = newval;
                    dun_msg(dusrnum, NMR, spr("%ld", psaleptr.markup), NONE3);
                    updbtv(&psaleptr);
                }
            }
        }
        else dun_msg(dusrnum, NOTYERS, NONE4);
    }
    else dun_msg(dusrnum, NOTYERS, NONE4);
}

void
dun_mrkd(void) /* change markdown */
{
    long newval;
    setbtv(psalebb);
    if (qeqbtv(PLYROOM, 0)) {
        gcrbtv(&psaleptr, 0);
        if (sameas(psaleptr.namind, dunwho->dunname)) {
            if (dmargc < 1) dun_hlp();
            else {
                newval = atol(dmargv[1]);
                if (newval < -3000 || newval > 3000) dun_msg(dusrnum, UNRE, NONE4);
                else {
                    psaleptr.markdown = newval;
                    dun_msg(dusrnum, NDR, spr("%ld", psaleptr.markdown), NONE3);
                    updbtv(&psaleptr);
                }
            }
        }
        else dun_msg(dusrnum, NOTYERS, NONE4);
    }
    else dun_msg(dusrnum, NOTYERS, NONE4);
}

void
dun_with(void)  /* withdrawl money from store */
{
    long temp;
    setbtv(psalebb);
    if (qeqbtv(PLYROOM, 0)) {
        gcrbtv(&psaleptr, 0);
        if (sameas(psaleptr.namind, dunwho->dunname)) {
            if (dmargc < 1) dun_hlp();
            else {
                temp = atol(dmargv[1]);
                if (temp < 0) temp = 0;
                if (temp <= psaleptr.cash) {
                    psaleptr.cash = psaleptr.cash - temp;
                    updbtv(&psaleptr);
                    dunwho->dungold = dunwho->dungold + temp;
                    dun_msg(dusrnum, WITHH, spr("%ld", temp), NONE3);
                }
                else dun_msg(dusrnum, NOTEN, NONE4);
            }
        }
        else dun_msg(dusrnum, NOTYERS, NONE4);
    }
    else dun_msg(dusrnum, NOTYERS, NONE4);
}

void
dun_depo(void)   /* deposit ribblets into store */
{
    long temp;
    setbtv(psalebb);
    if (qeqbtv(PLYROOM, 0)) {
        gcrbtv(&psaleptr, 0);
        if (sameas(psaleptr.namind, dunwho->dunname)) {
            if (dmargc < 1) dun_hlp();
            else {
                temp = atol(dmargv[1]);
                if (temp < 0) temp = 0;
                if (temp <= dunwho->dungold) {
                    dunwho->dungold = dunwho->dungold - temp;
                    psaleptr.cash = psaleptr.cash + temp;
                    updbtv(&psaleptr);
                    dun_msg(dusrnum, DEPH, spr("%ld", temp), NONE3);
                }
                else dun_msg(dusrnum, TOMUCH, NONE4);
            }
        }
        else dun_msg(dusrnum, NOTYERS, NONE4);
    }
    else dun_msg(dusrnum, NOTYERS, NONE4);
}

void 
dun_bury(void)
{
    int ii;
    char temp[30];
    if (margc < 2) {
        dun_msg(usrnum, BURYHLP2, NONE4);
	dun_msg(usrnum, CLASEL, NONE4);
    }
    else {
        if (atoi(margv[1]) < 1 || atoi(margv[1]) > MAXCLASS) {
            dun_msg(usrnum, RNGCLAS, NONE4);
	    dun_msg(usrnum, CLASEL, NONE4);
        }
        else {
	    ii = 0;
	    setbtv(pplybb);
	    strncpy(temp, uacoff(usrnum)->userid, 30);
            if (qeqbtv(temp, 0)) {
                do {
                    gcrbtv(&dunglb, 0);
                    if (dunglb.duncla == (atoi(margv[1])-1)) ii = 1;
                    else if (aqnbtv(&dunglb) == 0) ii = 1;
                } while (ii == 0);
            }
            else catastro("PLAYER NOT FOUND - DUN_ERROR: 2402");
            dun_resply(atoi(margv[1])-1);
            updbtv(&dunglb);
            dun_msg(usrnum, BRNC, classptr[atoi(margv[1])-1].clanam, NONE3);
        }
    }
}


void
dun_talk(void)   /* player talk routine */
{
    int i;
    if (dmargc > 1) {
        prf("%s %ss: ", dunwho->dunname, dmargv[0]);
        for (i=1; i<dmargc; i++) {
            prf("%s ", dmargv[i]);
        }
        prf("\r");
        dun_outdun(PLYROOM, dusrnum, -1, 8);
        prf("Understood!\r");
        dun_outply(dusrnum);
    }
    else dun_hlp();
}

void
dun_ress(void)  
{
    // ressurect a player
    int i, ii, flag, flag2;
    long rescost;
    flag = 0;
    if (dmargc > 1) {
        if (atoi(dmargv[1]) < 1 || atoi(dmargv[1]) > MAXCLASS) {
	    flag = 1;
	}
    }
    if (dmargc < 2) {
        flag = 1;
    }
    if (flag == 1) {
        setbtv(pplybb);
        i = 0;
        flag2 = 0;
        if (qeqbtv(dunwho->dunname, 0)) {
            ii = 0;
            do {
                i++;
                gcrbtv(&dunglb, 0);
                if (sameas(dunwho->dunname, dunglb.dunname)) {
                    if (dunglb.dundead > -1) {
                        prf("%d. %s (READY FOR RESSURECTION)\r", i, classptr[i-1].clanam);
                        flag2 = 1;
                    }
                }
                else {
                    ii = 1;
                }
                if (aqnbtv(&dunglb) == 0) ii = 1;
            } while (ii == 0);
            if (flag2 == 0) prf_msg(NCD, NONE4);
            dun_outply(dusrnum);
        }
        else catastro("PLAYER NOT FOUND - DUN_ERROR: 2334");
    }
    else {
        i = atoi(dmargv[1]) - 1;
        ii = 0;
        setbtv(pplybb);
        if (qeqbtv(dunwho->dunname, 0)) {
            do {
                gcrbtv(&dunglb, 0);
                if (dunglb.duncla == i) ii = 1;
                else if (aqnbtv(&dunglb) == 0) ii = 1;
            } while (ii == 0);
        }
        else catastro("PLAYER NOT FOUND - DUN_ERROR: 2348");
	// mod: EGF 04.01.93
        if (dunglb.dundead > -1) {
	    switch (dunglb.duncla) {
	    case 0:
	        rescost = doptions.resthf;
		break;
	    case 1:
	        rescost = doptions.resbar;
	        break;
	    case 2:
	        rescost = doptions.reswiz;
		break;
	    case 3:
	        rescost = doptions.reswar;
		break;
	    case 4:
	        rescost = doptions.resmag;
	    }
	    rescost = rescost * dunglb.dunlev;
            if (dunwho->dungold < rescost) {
	        dun_msg(dusrnum, RESNOCAS, spr("%ld", rescost), NONE3);
	    }
            else {
                dunwho->dungold = dunwho->dungold - rescost;
                dunglb.dundead = -1;
                dunglb.dunhp = dunglb.maxhp;
                dunglb.spcomp = 10000;
                updbtv(&dunglb);
                dun_msg(dusrnum, SRE, classptr[i].clanam, NONE3);
            }
        }
        else dun_msg(dusrnum, CND, NONE4);
    }
}

void
dun_open(void)  /* open a door */
{
    int dir, dir2;
    if (dmargc < 2) dun_hlp();
    else {
        dir = dun_getdir(dmargv[1]);
        dir2 = 1;
        if (dir == 1 || dir == 3) dir2 = -1;
        if (dir > -1) {
            dun_load(PLYROOM);
            if (proomptr.prmdir[dir] == 11) {
                prf_msg(PODR, dunwho->dunname, gendir[dir], NONE2);
                dun_outdun(PLYROOM, dusrnum, -1, 0);
                dun_msg(dusrnum, PLDO, gendir[dir], NONE3);
                proomptr.prmdir[dir] = 10;
                updcas();
                dun_load(PLYNDIR);
                prf_msg(PLDO2, gendir[dir+dir2], NONE3);
                dun_outdun(PLYNDIR, dusrnum, -1 , 0);
                proomptr.prmdir[dir+dir2] = 10;
                updcas();
            }
            else if (proomptr.prmdir[dir] == 10) dun_msg(dusrnum, DOALO, NONE4);
            else if (proomptr.prmdir[dir] > 11 && proomptr.prmdir[dir] < 20) dun_msg(dusrnum, DOLOC, NONE4);
            else dun_msg(dusrnum, NODR, NONE4);
        }
        else dun_hlp();
    }
}

void
dun_clos(void)  /* close a door */
{
    int dir, dir2;
    if (dmargc < 2) dun_hlp();
    else {
        dir = dun_getdir(dmargv[1]);
        dir2 = 1;
        if (dir == 1 || dir == 3) dir2 = -1;
        if (dir > -1) {
            dun_load(PLYROOM);
            if (proomptr.prmdir[dir] == 10) {
                prf_msg(CLDR, dunwho->dunname, gendir[dir], NONE2);
                dun_outdun(PLYROOM, dusrnum, -1, 0);
                dun_msg(dusrnum, YCLDR, gendir[dir], NONE3);
                proomptr.prmdir[dir] = 11;
                updcas();
                dun_load(PLYNDIR);
                prf_msg(DOORCL, gendir[dir+dir2], NONE3);
                dun_outdun(PLYNDIR, dusrnum, -1, 0);
                proomptr.prmdir[dir+dir2] = 11;
                updcas();
            }
            else if (proomptr.prmdir[dir] > 10) dun_msg(dusrnum, DRAC, NONE4);
            else dun_msg(dusrnum, NODR, NONE4);
        }
        else dun_hlp();
    }
}

void
dun_lock(void)   /* lock a door */
{
    int dir, dir2, ihand;
    if (dmargc < 3) dun_hlp();
    else {
        dir = dun_getdir(dmargv[1]);
        if (dir > -1) {
            dir2 = 1;
            if (dir == 1 || dir == 3) dir2 = -1;
            ihand = dun_ihand(dmargv[2], 3);
            if (ihand == -1) dun_msg(dusrnum, NOTCAR, dmargv[2], NONE3);
            else {
                if (pitemptr[dunwho->dunite[ihand]].pitty == KEY) {
                    dun_load(PLYROOM);
                    if (proomptr.prmdir[dir] == 11) {
                        proomptr.prmdir[dir] = 1 + dunwho->dunist[ihand];
                        dun_msg(dusrnum, YLODR, gendir[dir], NONE3);
                        prf_msg(HLODR, dunwho->dunname, gendir[dir], NONE2);
                        dun_outdun(PLYROOM, dusrnum, -1, 0);
                        updcas();
                        dun_load(PLYNDIR);
                        proomptr.prmdir[dir+dir2] = 1 + dunwho->dunist[ihand];
                        prf_msg(CLSND, gendir[dir+dir2], NONE3);
                        dun_outdun(PLYNDIR, dusrnum, -1, 0);
                        updcas();
                    }
                    else {
                        if (proomptr.prmdir[dir] == 10) dun_msg(dusrnum, DCLFS, NONE4);
                        else if (proomptr.prmdir[dir] > 11) dun_msg(dusrnum, DALK, NONE4);
                        else dun_msg(dusrnum, NODR, NONE4);
                    }
                }
                else dun_msg(dusrnum, NOTKEY, NONE4);
            }
        }
        else dun_hlp();
    }
}

void
dun_unlo(void)  /* unlock a door */
{
    int dir, dir2, ihand;
    if (dmargc < 3) dun_hlp();
    else {
        dir = dun_getdir(dmargv[1]);
        if (dir > -1) {
            ihand = dun_ihand(dmargv[2], 3);
            if (ihand == -1) dun_msg(dusrnum, NOTCAR, dmargv[2], NONE3);
            else {
                dir2 = 1;
                if (dir == 1 || dir == 3) dir2 = -1;
                if (pitemptr[dunwho->dunite[ihand]].pitty == KEY) {
                    dun_load(PLYROOM);
                    if (proomptr.prmdir[dir] > 11 && proomptr.prmdir[dir] < 20) {
                        if (proomptr.prmdir[dir] == dunwho->dunist[ihand] + 1) {
                            proomptr.prmdir[dir] = 11;
                            dun_msg(dusrnum, YUNDR, gendir[dir], NONE3);
                            prf_msg(HUNDR, dunwho->dunname, gendir[dir], NONE2);
                            dun_outdun(PLYROOM, dusrnum, -1, 0);
                            updcas();
                            dun_load(PLYNDIR);
                            proomptr.prmdir[dir+dir2] = 11;
                            prf_msg(CLSND, gendir[dir+dir2], NONE3);
                            dun_outdun(PLYNDIR, dusrnum, -1, 0);
                            updcas();
                        }
                        else dun_msg(dusrnum, DRWUN, NONE4);
                    }
                    else {
                        if (proomptr.prmdir[dir] == 10) dun_msg(dusrnum, DOALO, NONE4);
                        else if (proomptr.prmdir[dir] == 11) dun_msg(dusrnum, DRAUN, NONE4);
                        else dun_msg(dusrnum, NODR, NONE4);
                    }
                }
                else dun_msg(dusrnum, NOTKEY, NONE4);
            }
        }
        else dun_hlp();
    }
}

void
dun_conv(void)   /* convert an item */
{
    int i;
    long cnv;
    if (dmargc < 2) dun_hlp();
    else {
        i = dun_ihand(dmargv[1], 2);
        if (i > -1) {
            cnv = dun_howgood(dunwho->dunite[i], dunwho->dunist[i]) * 100;
            if (pitemptr[dunwho->dunite[i]].pitty == SKULL) {
                if (cnv > 15000L) cnv = 15000L;
            }
            if (cnv < 1) cnv = 100;
            prf_msg(VANF, pitemptr[dunwho->dunite[i]].pitnam, NONE3);
            prf_msg(CONVV, pitemptr[dunwho->dunite[i]].pitnam, spr("%ld", cnv), NONE2);
            dun_outply(dusrnum);
            prf_msg(FLAH, dunwho->dunname, NONE3);
            dun_outdun(PLYROOM, dusrnum, -1, 0);
            dunwho->dunaptr.totwt-=pitemptr[dunwho->dunite[i]].wieght;
            dunwho->dunite[i] = -1;
            dunwho->dunist[i] = -1;
            dunwho->spcomp+=cnv;
        }
        else dun_msg(dusrnum, NOTCAR, dmargv[1], NONE3);
    }
}

void
dun_sign(void)  /* paint a sign in player store */
{
    int i;
    char temp[200], nsign[50];
    setbtv(psalebb);
    if (qeqbtv(PLYROOM, 0)) {
        gcrbtv(&psaleptr, 0);
        if (sameas(psaleptr.namind, dunwho->dunname)) {
            setmem(temp, 200, 0);
            strcpy(temp, "");
            for (i=1; i<dmargc; i++) {
                strcat(temp, dmargv[i]);
                strcat(temp, " ");
            }
            setmem(nsign, 50, 0);
            strncat(nsign, temp, 49);
            dun_load(PLYROOM);
            setmem(proomptr.sign, 50, 0);
            strcat(proomptr.sign, nsign);
            updcas();
            dun_msg(dusrnum, WOAT, NONE4);
        }
        else dun_msg(dusrnum, NOTYERS, NONE4);
    }
    else dun_msg(dusrnum, NOTYERS, NONE4);
}

void
dun_heal(void)  /* heal player */
{
    long cost;
    if (dusrnum < monstart) {
        cost = ((long)classptr[dunwho->duncla].plheal * (long)dunwho->dunlev);
    }
    else {
        cost = (long)(dunwho->dunlev/2) * 350L;
    }
    if (dunwho->spcomp < cost) {
        dun_msg(dusrnum, NITH, NONE4);
    }
    else {
        if (dunwho->dunhp < dunwho->maxhp && dunwho->dunhp > 0) {
            dun_msg(dusrnum, HEAL, spr("%d", 5+dunwho->dunlev), NONE3);
            dunwho->dunhp+=(5+dunwho->dunlev);
            dunwho->spcomp-=cost;
            if (dunwho->dunhp > dunwho->maxhp) {
                dunwho->dunhp = dunwho->maxhp;
                prf("You're healed to the maximum!\r");
                dun_outply(dusrnum);
            }
            prf("%s's body is glowing!\r", dunwho->dunname);
            dun_outdun(PLYROOM, dusrnum, -1, 0);
        }
        else dun_msg(dusrnum, NOTHAP, NONE4);
    }
}

void
dun_adis(void)   /* dispell your current spell */
{
    if (dunwho->dunaptr.lespe > 0) dun_dispell();
    else dun_msg(dusrnum, NOSC, NONE4);
}

void
dun_drnk(void)  /* drink a potion */
{
    int flag;
    if (dmargc < 2) dun_hlp();
    else {
        flag = dun_ihand(dmargv[1], 2);
        if (flag > -1) {
            if (pitemptr[dunwho->dunite[flag]].pitty == POTION) {
                dun_msg(dusrnum, DRNK, NONE4);
                prf_msg(HDRNK, dunwho->dunname, NONE3);
                dun_outdun(PLYROOM, dusrnum, -1, 0);
                if (dunwho->dunist[flag] == 0) dunwho->dunstr++;
                else if (dunwho->dunist[flag] == 1) dunwho->dunint++;
                else if (dunwho->dunist[flag] == 2) dunwho->dunwis++;
                else if (dunwho->dunist[flag] == 3) dunwho->dundex++;
                else if (dunwho->dunist[flag] == 4) dunwho->duncon++;
                else if (dunwho->dunist[flag] == 5) dunwho->duncha++;
                else {
                    dun_msg(dusrnum, DRNKP, NONE4);
                    prf_msg(HCHK, dunwho->dunname, NONE3);
                    dun_outdun(PLYROOM, dusrnum, -1, 0);
                    dunwho->poison = dunwho->poison + (dunwho->dunlev * 5);
                }
                dunwho->dunite[flag] = -1;
                dunwho->dunist[flag] = -1;
            }
            else dun_msg(dusrnum, TODIDR, pitemptr[dunwho->dunite[flag]].pitnam, NONE3);
        }
        else dun_hlp();
    }
}

void
dun_trav(void)   /* travel through time */
{
    int tm, oldz, scratch;
    long cost;
    if (dmargc < 2) dun_hlp();
    else {
        tm = atoi(dmargv[1]);
        if (tm < 2000 || tm > doptions.maxyr) {
	    dun_msg(dusrnum, CANTTRA, spr("%d", doptions.maxyr), NONE3);
	}
        else {
            tm = tm - 2000;
            tm = (tm / 100);
            oldz = dunwho->dunzc;
            dunwho->dunxc = 0;
            dunwho->dunyc = 0;
            dunwho->dunzc = tm;
            if (oldz == dunwho->dunzc) dun_msg(dusrnum, ALYR, spr("%d", (((oldz+1) * 100) + 2000)/100), NONE3);
            else {
                if (dunwho->spcomp < 3000L) {
                    dun_msg(dusrnum, NOTENIO, NONE4);
                    dunwho->dunzc = oldz;
                }
                else {
                    prf_msg(HEWPORT, dunwho->dunname, NONE3);
                    dun_outdun(dun_getrm(dunwho->dunxc, dunwho->dunyc, oldz), dusrnum, -1, 0);
                    if (dun_load(dun_getrm(dunwho->dunxc, dunwho->dunyc, dunwho->dunzc)) == 0) {
		        // create the room if it doesnt exist
                        dun_crm(dunwho->dunxc, dunwho->dunyc, dunwho->dunzc);
                        dun_clrmap();
                    }
                    scratch = abs(oldz - dunwho->dunzc);
                    cost = 3000L * (long)scratch;
                    if (cost <= dunwho->spcomp) {
                        dunwho->spcomp = dunwho->spcomp - cost;
                        prf_msg(HECPORT, dunwho->dunname, NONE3);
                        dun_outdun(PLYROOM, dusrnum, -1, 0);
                        dun_msg(dusrnum, TRAVY, spr("%d", (dunwho->dunzc * 100) + 2000), NONE3);
                        dun_clrmap();
                    }
                    else {
                        dun_msg(dusrnum, TRAVUH, NONE4);
                        dunwho->spcomp = 0;
                        dunwho->dunzc = dun_rand(12);
                        prf_msg(HECPORT, dunwho->dunname, NONE3);
                        dun_outdun(PLYROOM, dusrnum, -1, 0);
                        dun_clrmap();
                    }
                }
            }
        }
    }
}

void
dun_stea(void)   
{
    // thief steals from player or store
    char what[100];
    PLAYER *dunoth;
    int i, flag, which, ok, damage, flag2, ctr, ctr2, stflag, donext;
    donext = 0;
    ok = 0;
    if (dunwho->dunlev < doptions.levtpl || dunwho->duncla != 0) {
        dun_msg(dusrnum, CANTSTE, spr("%d", doptions.levtpl), NONE3);
        ok = 1;
        donext = 1;
    }
    if (dusrnum > monstart - 1) {
        ok = 0;
    }
    if (dmargc > 1 && ok == 0) {
        flag2 = dun_isply(dmargv[1], PLYROOM, 2);
        if (flag2 > -1) {
            donext = 1;
            dunoth = getply(flag2);
            stflag = 0;
            if (dunwho->dunlev > dunoth->dunlev) {
                for (ctr = 0; ctr < 10; ctr++) {
                    if (dunoth->dunite[ctr] > -1) {
                        for (ctr2 = 0; ctr2 < 10; ctr2++) {
                            if (dunwho->dunite[ctr2] == -1) {
			        dunwho->dunaptr.totwt+=pitemptr[dunwho->dunite[ctr]].wieght;
                                dunwho->dunite[ctr2] = dunoth->dunite[ctr];
                                dunwho->dunist[ctr2] = dunoth->dunist[ctr];
                                dunoth->dunite[ctr] = -1;
                                dunoth->dunist[ctr] = -1;
				dunoth->dunaptr.totwt-=pitemptr[dunwho->dunite[ctr2]].wieght;
                                dun_msg(dusrnum, YOUSTEP, spr("%c", dun_aoran(pitemptr[dunwho->dunite[ctr2]].pitnam, 0)), pitemptr[dunwho->dunite[ctr2]].pitnam, dunoth->dunname, NONE1);
                                dun_msg(flag2, YOUMISS, NONE4);
                                stflag = 1;
                                ctr2 = 11;
                                ctr = 11;
                            }
                        }
                    }
                }
            }
            if (stflag == 0) {
                dun_msg(dusrnum, CAUGHTU, dunoth->dunname, NONE3);
                dun_msg(flag2, CAUGHTH, dunwho->dunname, NONE3);
            }
        }
    }
    if (donext == 0) {
        setbtv(psalebb);
        if (qeqbtv(PLYROOM, 0) == 0) dun_msg(dusrnum, NOTRADE, NONE4);
        else {
            if (sameas(psaleptr.namind, dunwho->dunname)) dun_msg(dusrnum, INSANE, NONE4);
            else {
                ok = 0;
                if (dunwho->dunlev < 3 || dunwho->duncla != 0) {
                    dun_msg(dusrnum, CANTSTE, NONE4);
                    ok = 1;
                }
                if (dusrnum > monstart - 1) ok = 0;
                if (ok == 0) {
                    gcrbtv(&psaleptr, 0);
                    if (psaleptr.security > 0) {
                        dun_msg(dusrnum, FAILSTE, NONE4);
                        prf_msg(FAILSTE2, dunwho->dunname, NONE3);
                        dun_outdun(PLYROOM, dusrnum, -1, 0);
                        psaleptr.security = psaleptr.security - (psaleptr.security / 10);
                        if (psaleptr.security < 0) psaleptr.security = 0;
                        damage = ((int)(psaleptr.security/1000L));
                        if (damage < 0 || damage > 15000) damage = 15000;
                        dunwho->dunhp = dunwho->dunhp - damage;
                        dunwho->spcomp = (dunwho->spcomp - psaleptr.security / 100);
                        prf("You suffer %d hit points of damage and ion drainage!\r", damage);
                        if (psaleptr.security < 1000) psaleptr.security = 0;
                        dun_outply(dusrnum);
                        if (dunwho->spcomp < 0) dunwho->spcomp = 0;
                        if (dunwho->dunhp < 1) dunwho->dunhp = 0;
                        if (!sameas(psaleptr.namind, "Village Shop\0")) updbtv(&psaleptr);
                        if (dusrnum > monstart -1) {
                            prf_msg(DISFLA, dunwho->dunname, dunwho->dunaptr.pcomba, dunwho->dunname, NONE1);
                            dun_outdun(PLYROOM, -1, -1, 4);
                            dunwho->dunaptr.stt = -1;
                        }
                    }
                    else {
                        if (dmargc == 1) {
                            if (psaleptr.cash < 1) dun_msg(dusrnum, NOCASH, NONE4);
                            else {
                                dun_msg(dusrnum, YOUSTEA, spr("%ld", psaleptr.cash), NONE3);
                                dunwho->dungold = dunwho->dungold + psaleptr.cash;
                                psaleptr.cash = 0;
                                updbtv(&psaleptr);
                                setmem(what, 100, 0);
                                strcpy(what, dunwho->dunname);
                                strcat(what, " has stolen cash from one of your stores!");
                                dun_log(psaleptr.namind, what, 0);
                            }
                        }
                        else {
                            flag = -1;
                            for (i=0; i<10; i++) {
                                if (dunwho->dunite[i] == -1) {
                                    flag = i;
                                    i = 10;
                                }
                            }
                            if (flag == -1) dun_msg(dusrnum, TOOMUCH, NONE4);
                            else {
                                which = atoi(dmargv[1]);
                                if (which > 0 && which < 21) {
                                    which--;
                                    if (psaleptr.itsale[which] == -1) {
                                        dun_msg(dusrnum, TYPBUY, NONE4);
                                    }
                                    else {
                                        dun_msg(dusrnum, YOUSTOLE, pitemptr[psaleptr.itsale[which]].pitnam, NONE3);
                                        dunwho->dunite[flag] = psaleptr.itsale[which];
                                        dunwho->dunist[flag] = psaleptr.itstat[which];
					dunwho->dunaptr.totwt+=pitemptr[dunwho->dunite[flag]].wieght;
                                        psaleptr.itsale[which] = -1;
                                        psaleptr.itstat[which] = -1;
                                        updbtv(&psaleptr);
                                        setmem(what, 100, 0);
                                        strcpy(what, dunwho->dunname);
                                        strcat(what, " has stolen an item from one of your stores!");
                                        dun_log(psaleptr.namind, what, 0);
                                    }
                                }
                                else dun_msg(dusrnum, TYPBUY, NONE4);
                            }
                        }
                    }
                }
            }
        }
    }
}

void
dun_telp(void)                   /* send a telepathic message */
{
    int i;
    char what[255];
    if (dmargc < 2) dun_hlp();
    else {
        if (dunwho->spcomp > 100) {
            dunwho->spcomp-=100;
            setmem(what, 255, 0);
            strcpy(what, dunwho->dunname);
            strcat(what, ": ");
            for (i=1; i<dmargc; i++) {
                strcat(what, dmargv[i]);
                strcat(what, " ");
            }
            dun_telm(what);
            prf("You telepathically send the message.\r");
            dun_outply(dusrnum);
        }
        else dun_msg(dusrnum, NOIG, NONE4);
    }
}

void
dun_secr(void)    /* transfer ions to security system */
{
    long trans;
    if (dmargc < 2) dun_hlp();
    else {
        trans = atol(dmargv[1]);
        if (trans > dunwho->spcomp) dun_msg(dusrnum, NOTEIO, NONE4);
        else {
            setbtv(psalebb);
            if (qeqbtv(PLYROOM, 0)) {
                gcrbtv(&psaleptr, 0);
                if (trans >= 0) {
                    psaleptr.security+=trans;
                    dunwho->spcomp = dunwho->spcomp - trans;
                    updbtv(&psaleptr);
                    dun_msg(dusrnum, TROK, spr("%ld", trans), NONE3);
                }
                else {
                    dunwho->spcomp+=trans;
                    if (dunwho->spcomp < 0) dunwho->spcomp = 0;
                    dun_msg(dusrnum, CRAZY, NONE4);
                    dunwho->dunhp-=12;
                    if (dunwho->dunhp < 0) {
                        dunwho->dunhp = 0;
                        dun_msg(dusrnum, YOUDEAD, NONE4);
                        fade2blk(dusrnum);
                    }
                }
            }
            else dun_msg(dusrnum, NOTYET, NONE4);
        }
    }
}

void
dun_strs(void)   /* list a players stores */
{
    int x, y, z, ok, zp;
    setbtv(psalebb);
    if (qeqbtv(dunwho->dunname, 1)) {
        prf("Year           Relative             Worth\r\r");
        gcrbtv(&psaleptr, 1);
        ok = 1;
        do {
            z = atoi(spr("%c%c", psaleptr.rmind[7], psaleptr.rmind[8]));
            z = z * 100;
            z = z + 2000;
            x = atoi(spr("%c%c%c", psaleptr.rmind[0], psaleptr.rmind[1], psaleptr.rmind[2]));
            y = atoi(spr("%c%c%c", psaleptr.rmind[3], psaleptr.rmind[4], psaleptr.rmind[5]));
            zp = dunwho->dunzc * 100;
            zp = zp + 2000;
            if (zp == z) {
                prf("%d A.D.    east: %-4d north: %-4d  $ %-8s\r", z, x-dunwho->dunxc, y-dunwho->dunyc, spr("%ld", psaleptr.cash));
            }
            else {
                prf("%d A.D.    NOT AVAILABLE           $ %-8s\r", z, spr("%ld", psaleptr.cash));
            }
            if (qnxbtv()) {
                gcrbtv(&psaleptr, 1);
                if (!sameto(dunwho->dunname, psaleptr.namind)) ok = 0;
            }
            else ok = 0;
        } while (ok);
        dun_outply(dusrnum);
    }
    else {
        prf("You don't have any stores established.\r");
        dun_outply(dusrnum);
    }
}

void
dun_high(void)      /* list high scores */
{
    int ctr;
    char color_t[20];
    setbtv(dhghbb);
    if (qhibtv(1)) {
        ctr = 0;
        prf("%sPLAYER                          SCORE         NET WORTH\r", CYAN);
        prf("%s=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=\r", YELLOW);
        do {
            gcrbtv(&dhghptr, 1);
	    // Look for a mutantlink ID - DO NOT CHANGE
	    if (!sameas(dhghptr.hghnam, "ML")) {
                if (ctr == 0) strcpy(color_t, WHITE);
                else strcpy(color_t, RED);
                prf("%s%-30s   %-10s   $ %-10s\r", color_t, dhghptr.hghnam, spr("%ld", dhghptr.hghscr), spr("%ld", dhghptr.hghwrth));
                ctr++;
	    }
        } while (qprbtv() && ctr < 15);
        outprf(dusrnum);
    }
    else dun_msg(dusrnum, NOHIGH, NONE4);
}

void
dun_help(void)    /* display help files */
{
    int i, ctr, flag, ii;
    char spell[20];
    struct duncmd *duncptr;
    LEVEL *levptr;
    CLASS *claptr;
    if (dmargc < 2) {
        ctr = 0;
        prf("%sKeywords:\r\r", RED);
        for (i=0; i<dunsiz; i++) {
            if (dunarr[i].cmdhlp > -1) {
                prf("%s%-10s  ", YELLOW, dunarr[i].duncom);
                ctr++;
                if (ctr > 5) {
                    prf("\r");
                    ctr = 0;
                }
            }
        }
        setmbk(dunmb);
        prf("%s", CYAN);
        prfmsg(ADDHELP);
        prf("%s", WHITE);
        dun_outply(dusrnum);
    }
    else {
        prf("\r");
        if (sameas(dmargv[1], "combat")) dun_msg(dusrnum, HLPCOMBT, NONE4);
        else if (sameas(dmargv[1], "talking")) dun_msg(dusrnum, HLPTALK, NONE4);
        else if (sameas(dmargv[1], "items")) dun_msg(dusrnum, HLPITEMS, NONE4);
        else if (sameas(dmargv[1], "moving")) dun_msg(dusrnum, HLPMOVE, NONE4);
        else if (sameas(dmargv[1], "strategy")) dun_msg(dusrnum, HLPSTRAT, NONE4);
        if (sameas(dmargv[1], "class")) {
            if (dmargc < 3) {
                prf("\r");
                for (i=0; i<MAXCLASS; i++) {
                    prf("%d. %s\r", i+1, classptr[i].clanam);
                }
                prf("\r");
                dun_msg(dusrnum, HLPPCLA, NONE4);
            }
            else {
                i = atoi(dmargv[2]);
                i--;
                if (i > -1 && i < MAXCLASS) {
                    claptr=&classptr[i];
                    levptr=&levelptr[i];
                    prf("\r%sCLASS NAME: %s%s\r\r", YELLOW, RED, claptr->clanam);
                    prf("%sStrength:        %s%d\r", CYAN, RED, claptr->cminstr);
                    prf("%sIntellengence:   %s%d\r", CYAN, RED, claptr->cminint);
                    prf("%sWisdom:          %s%d\r", CYAN, RED, claptr->cminwis);
                    prf("%sDexterity:       %s%d\r", CYAN, RED, claptr->cmindex);
                    prf("%sConstitution:    %s%d\r", CYAN, RED, claptr->cmincon);
                    prf("%sCharisma:        %s%d\r", CYAN, RED, claptr->cmincha);
                    prf("%sIon Consumption: %s%d\r", CYAN, RED, claptr->ioncon);
                    prf("\r");
                    prf("%sLEVEL   EXP.    BONUES:   STR+  INT+  WIS+  DEX+  CON+  CHA+  HP+  SPELLS+\r", YELLOW);
                    for (ii=0; ii<10; ii++) {
                        prf("%s%-5d   %-7s             %-3d   %-3d   %-3d   %-3d   %-3d   %-3d   %-3d   %-3d\r", RED,
                        ii+2, spr("%ld", levptr->reqexp[ii]), levptr->strinc[ii],
                        levptr->intinc[ii], levptr->wisinc[ii], levptr->dexinc[ii], levptr->coninc[ii],
                        levptr->chainc[ii], levptr->mhpinc[ii], levptr->mspell[ii]);
                    }
                    dun_outply(dusrnum);
                }
                else dun_msg(dusrnum, NOCLAS, NONE4);
            }
        }
        else if (sameas(dmargv[1], "spell")) {
            if (dmargc == 2) {
                setmbk(dunmb);
                prf("%s", YELLOW);
                prfmsg(HLPSPELL);
                ctr = 0;
                for (i=0; i<sizspell; i++) {
                    prf("%s%-18s ", CYAN, pspelptr[i].spenam);
                    ctr++;
                    if (ctr > 3) {
                        prf("\r");
                        ctr = 0;
                    }
                }
                prf("\r");
                outprf(dusrnum);
            }
            else if (dmargc == 3) {
                flag = 0;
                if (strlen(dmargv[2]) > 2) {
                    setmbk(dunmb);
                    for (i=0; i<sizspell; i++) {
                        setmem(spell, 20, 0);
                        for (ii=0; ii<strlen(pspelptr[i].spenam); ii++) {
                            spell[ii] = tolower(pspelptr[i].spenam[ii]);
                        }
                        if (strncmp(dmargv[2], spell, strlen(dmargv[2])) == 0) {
                            prfmsg(pspelptr[i].hlpspell);
                            prf("\r%sCasting Cost     : %s%s Ions", CYAN, RED, spr("%ld", pspelptr[i].castcost));
                            prf("\r%sMaintenance Cost : %s%s Ions / Second\r", CYAN, RED, spr("%ld", pspelptr[i].durcost));
                            outprf(dusrnum);
                            flag = 1;
                            i = sizspell;
                        }
                    }
                }
                if (flag == 0) dun_msg(dusrnum, NOHELP, NONE4);
            }
        }
        else {
            if ((duncptr = pasearch(dmargv[1], dunarr, dunsiz)) != NULL) {
                hlpmsg = duncptr->cmdhlp;
                dun_hlp();
            }
            else dun_msg(dusrnum, NOHELP, NONE4);
        }
    }
}

void
dun_blurb(void)   /* shut off or on blurbs */
{
    if (dunwho->dunaptr.mutflags&BLURB ? (dunwho->dunaptr.mutflags&=~BLURB) :
    (dunwho->dunaptr.mutflags|=BLURB));
    prf("Incomming Blurbs %s\r", dunwho->dunaptr.mutflags&BLURB ? "ON" : "OFF");
    outprf(dusrnum);
}

void
dun_deaf(void)    /* make yourself deaf or not deaf */
{
    if (dunwho->dunaptr.mutflags&DEAF ? (dunwho->dunaptr.mutflags&=~DEAF) :
    (dunwho->dunaptr.mutflags|=DEAF));
    prf("%s deaf!\r", dunwho->dunaptr.mutflags&DEAF ? "You're now " : 
    "You're no longer ");
    outprf(dusrnum);
}

void
dun_score(void)    /* list user score */
{
    setbtv(dhghbb);
    if (qeqbtv(dunwho->dunname, 0)) {
        gcrbtv(&dhghptr, 0);
        dun_msg(dusrnum, URSCR, spr("%ld", dhghptr.hghscr), NONE3);
    }
    else dun_msg(dusrnum, URSCR, spr("%d", 0), NONE3);
}

int
buycreds(void)
{
    long amount, cost;
    char buffer[100];
    // buy credits at maintenance shops
    if (dusrnum > nterms-1) {
        return(0);
    }
    if (dmargc < 3) {
        dun_msg(dusrnum, HLPCRDS, NONE4);
    }
    else {
        dun_load(PLYROOM);
        if (proomptr.maint > 0) {
            if (doptions.crdrte < 1L) {
	        dun_msg(dusrnum, NOCREDS, NONE4);
	    }
	    else {
                amount = atol(dmargv[2]);
       	        if (amount < 1L) {
	            dun_msg(dusrnum, TOLO, "Credit", NONE3);
	        }
	        else {
	            cost = amount * doptions.crdrte;
		    if (cost < 0L || amount > 100000L) {
		        prf("Sorry, that would cost you a ridiculous amount!\r");
			outprf(usrnum);
			return(0);
		    }
	  	    if (dunwho->dungold > cost) {
		        dunwho->dungold = dunwho->dungold - cost;
	  	        uacoff(usrnum)->creds = uacoff(dusrnum)->creds + amount;
		        if (doptions.dspcrd == 1) {
		            sprintf(buffer, "MUTANTS: %s BOUGHT %ld CREDITS: MUTANTS", uacoff(dusrnum)->userid, amount);
			    shocst(buffer, buffer);
	  	        }
		        dun_msg(dusrnum, UBGTCR, spr("%ld", amount), "Credits", NONE2);
		    }
		    else {
		        dun_msg(dusrnum, ULNEED, spr("%ld", cost), NONE3);
	  	    }
	        }
	    } 
        }
        else {
            dun_msg(dusrnum, NOTRADE, NONE4);
        }
    }
    return(0);
}


int
buyions(void)
{
    long amount, cost;
    // buy ions at maintenance shops
    if (dmargc < 3) {
        dun_msg(dusrnum, HLPIONS, NONE4);
    }
    else {
        dun_load(PLYROOM);
        if (proomptr.maint > 0) {
            amount = atol(dmargv[2]);
    	    if (amount < 1L) {
	        dun_msg(dusrnum, TOLO, "Ion", NONE3);
	    }
	    else {
	        cost = amount * doptions.ionrte;
		if (cost < 0L) {
		    prf("Sorry, that would cost you a ridiculous amount!\r");
		    outprf(usrnum);
		    return(0);
		}
	  	if (dunwho->dungold > cost) {
		    dunwho->dungold = dunwho->dungold - cost;
		    dunwho->spcomp = dunwho->spcomp + amount;
      	            dun_msg(dusrnum, UBGTCR, spr("%ld", amount), "Ions", NONE2);
		}
		else {
		    dun_msg(dusrnum, ULNEED, spr("%ld", cost), NONE3);
	  	}
	    } 
        }
        else {
            dun_msg(dusrnum, NOTRADE, NONE4);
        }
    }
    return(0);
}