/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~
*   MJSMUTSP.C                                                            *
*   Version 2.30                                                          *
*   Copyright (C) 1991-93, MajorSoft Inc. and Eric Furrer                 *
*   This is the MUTANTS! spell handler                                    *
*   for the MajorBBS version 6.xx +                                       *
*   E. Furrer      12/24/91        "it's not how you play the game,       *
*                                   it's if you win or lose."             *
*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/
#include "gcomm.h"
#include "majorbbs.h"
#include "mjsmutx.h"           /* msg header file                      */
#include "mjsmuth.h"           /* mutants header file                  */
#include "mjsmutp.h"           /* mutants prototype file               */

struct duncmd *pasearch();

void
dun_memo(void)    /* memorize a spell */
{
    int pflag, cost;
    if (dmargc < 2) dun_hlp();
    else {
        pflag = dun_ispel(dmargv[1]);
        if (pflag == -1) dun_msg(dusrnum, NOSPE, NONE4);
        else {
            if (dunwho->dunspe[pflag] != dunwho->dunaptr.dunrsp) {
                dun_dispell();
                dunwho->dunaptr.dunrsp = dunwho->dunspe[pflag];
                cost = pspelptr[dunwho->dunspe[pflag]].spemem - dunwho->dunint;
                if (cost < 0) cost = 0;
                dunwho->dunaptr.dunmsp = cost;
                if (dunwho->dunaptr.dunmsp == 0) {
                    prf_msg(FINMEM, pspelptr[dunwho->dunaptr.dunrsp].spenam, NONE3);
                }
                else {
                    prf_msg(BEGMEM, pspelptr[dunwho->dunaptr.dunrsp].spenam, NONE3);
                }
            }
            else {
                prf_msg(ALRMEM, NONE4);
            }
            dun_outply(dusrnum);
        }
    }
}

void
dun_cast(void)  /* main casting routine */
{
    int ctr, flag;
    struct pspelrec *dspell;
    dspell=&pspelptr[dunwho->dunaptr.dunrsp];
    if (dmargc < dspell->hwords) {
        dun_hlp();
    }
    else if (dunwho->dunaptr.dunrsp == -1) dun_msg(dusrnum, NOTMEM, NONE4);
    else if (dunwho->dunaptr.dunmsp > 0) dun_msg(dusrnum, STIMEM, NONE4);
    else {
        dun_load(PLYROOM);
        if (dun_dark(0) == 0) {
            prf_msg(WAVES, dunwho->dunname, SEX, NONE2);
            dun_outdun(PLYROOM, dusrnum, -1, 0);
        }
        else {
            prf_msg(HRMUM, NONE4);
            dun_outdun(PLYROOM, dusrnum, -1, 0);
        }
        if (dunwho->spcomp > 0) {
            dunwho->spcomp = dunwho->spcomp - dspell->castcost;
            if (dunwho->spcomp < 1) {
                dunwho->spcomp = dunwho->spcomp + dspell->castcost;
                dun_msg(dusrnum, SPEOUT, NONE4);
            }
            else {
                if (dspell->speitem == -1) {
                    if (dunwho->dunaptr.lespe > 0) dun_dispell();
                    if (dspell->durcost > 0) {
                        dunwho->dunaptr.lespe = (dunwho->dunint + dunwho->dunwis);
                    }
                    (*(dspell->spout))();
                }
                else {
                    flag = 0;
                    for (ctr = 0; ctr < 10; ctr++) {
                        if (dunwho->dunite[ctr] == dspell->speitem) {
                            dun_msg(dusrnum, ITEMDIS, pitemptr[dunwho->dunite[ctr]].pitnam, NONE3);
                            prf_msg(ITEMDISP, pitemptr[dunwho->dunite[ctr]].pitnam, NONE3);
                            dun_outdun(PLYROOM, dusrnum, -1, 0);
                            dunwho->dunite[ctr] = -1;
                            dunwho->dunist[ctr] = -1;
                            flag = 1;
                            ctr = 11;
                        }
                    }
                    if (flag == 1) {
                        if (dunwho->dunaptr.lespe > 0) dun_dispell();
                        if (dspell->durcost > 0) {
                            dunwho->dunaptr.lespe = (dunwho->dunint + dunwho->dunwis);
                        }
                        (*(dspell->spout))();
                    }
                    else dun_msg(dusrnum, UNEEDIT, spr("%c", dun_aoran(pitemptr[dspell->speitem].pitnam, 0)), pitemptr[dspell->speitem].pitnam, NONE2);
                }
            }
        }
        else dun_msg(dusrnum, NOINS, NONE4);
    }
}

/**************************************************************************
*                          SPELLS ACTION ROUTINES                        *
**************************************************************************/

void
dun_ench(void)       /* enchantment spell */
{
    int flag1;
    long cost;
    flag1 = dun_ihand(dmargv[1], 2);
    if (flag1 > -1) {
        if (dunwho->dunist[flag1] > 99) {
            if (dunwho->dunist[flag1] < 200) {  /* max enchant. +100 */
                if (pitemptr[dunwho->dunite[flag1]].pitty == SWORD || pitemptr[dunwho->dunite[flag1]].pitty == ARMOR) {
                    cost = (long)(dunwho->dunist[flag1] - 99) * (dun_howgood(dunwho->dunite[flag1], dunwho->dunist[flag1]) * 10);
                    cost = cost * 4;
                    if (dunwho->spcomp >= cost) {
                        dun_msg(dusrnum, ENCHANT, pitemptr[dunwho->dunite[flag1]].pitnam, NONE3);
                        dunwho->dunist[flag1]++;
                        dunwho->spcomp-=cost;
                    }
                    else dun_msg(dusrnum, ECHF, spr("%ld", cost), pitemptr[dunwho->dunite[flag1]].pitnam, NONE2);
                }
                else dun_msg(dusrnum, NOTHAP, NONE4);
            }
            else dun_msg(dusrnum, NOTHAP, NONE4);
        }
        else dun_msg(dusrnum, PURE, NONE4);
    }
    else dun_msg(dusrnum, NOTCAR, dmargv[1], NONE3);
}

void
dun_ligs(void)   /* light spell */
{
    dun_load(PLYROOM);
    if (dun_dark(0) == 1) {
        prf_msg(ORA, NONE4);
        dun_outdun(PLYROOM, -1, -1, 0);
    }
    else {
        dun_msg(dusrnum, CASTED, NONE4);
    }
    dunwho->dunaptr.mutflags|=LIGHT;
}

void
dun_dismag(void)    /* spell of dispell magic */
{
    int i, temp;
    struct pspelrec *dspell;
    temp = dusrnum;
    for (i=0; i<maxcreat; i++) {
        if (getply(i)->dunaptr.stt == PLAYING && i != temp) {
            dunwho=getply(i);
            if (dunwho->dunaptr.lespe > 0) {
                dunwho->dunaptr.lespe = 0;
                dusrnum = i;
                dspell=&pspelptr[dunwho->dunaptr.dunrsp];
                (*(dspell->dispel))();
            }
        }
    }
    dusrnum = temp;
    dunwho=getply(dusrnum);
    dun_load(PLYROOM);
    if (proomptr.dark > 1) {
        proomptr.dark = proomptr.dark - dunwho->dunlev;
        if (proomptr.dark < 2) proomptr.dark = 0;
        if (proomptr.dark == 0) {
            prf_msg(DARKLI, NONE4);
            dun_outdun(PLYROOM, -1, -1, 0);
        }
        updcas();
    }
    dun_msg(dusrnum, CASTED, 0, NONE3);
}

void
dun_darks(void)   /* spell of darkness */
{
    dun_load(PLYROOM);
    if (proomptr.dark == 0) {
        proomptr.dark = (1 + dunwho->dunlev);
        updcas();
        prf_msg(DARKOV, NONE4);
        dun_outdun(PLYROOM, -1, -1,  0);
    }
    else dun_msg(dusrnum, NOTHAP, NONE4);
}

void
dun_invi(void)  /* invisibility spell */
{
    if (!(dunwho->dunaptr.mutflags&INVIS)) {
        dunwho->dunaptr.mutflags|=INVIS;
        dun_msg(dusrnum, UFADE, NONE4);
        prf_msg(HFADE, dunwho->dunname, NONE3);
        dun_outdun(PLYROOM, -1, dusrnum, 0);
    }
    else dun_msg(dusrnum, ALINV, NONE4);
}

void
dun_ices(void)   /* spell of ice */
{
    int flag, dir2;
    flag = dun_getdir(dmargv[1]);
    if (flag > -1 && flag < 4) {
        if (proomptr.prmdir[flag] == 1) {
            if (dun_areaok(0) == 1) {
                proomptr.prmdir[flag] = 2;
                updcas();
                prf_msg(WOICE, gendir[flag], NONE3);
                dun_outdun(PLYROOM, -1, -1, 0);
                if (dun_load(dun_getrm(dunwho->dunxc+genx[flag], dunwho->dunyc+geny[flag], dunwho->dunzc+genz[flag])) == 1) {
                    dir2 = 1;
                    if (flag == 1 || flag == 3 || flag == 5) dir2 = -1;
                    proomptr.prmdir[flag+dir2] = 2;
                    updcas();
                    prf_msg(WOICE, gendir[flag+dir2], NONE3);
                    dun_outdun(dun_getrm(dunwho->dunxc+genx[flag], dunwho->dunyc+geny[flag], dunwho->dunzc+genz[flag]), -1, -1, 0);
                }
            }
            else dun_msg(dusrnum, CANTHER, NONE4);
        }
        else dun_msg(dusrnum, NOTHAP, NONE4);
    }
    else dun_msg(dusrnum, NOTHAP, NONE4);
}

void
dun_forc(void)   /* spell of force */
{
    int flag, dir2;
    flag = dun_getdir(dmargv[1]);
    if (flag > -1 && flag < 4) {
        if (proomptr.prmdir[flag] == 1 && dunwho->dunzc < 30) {
            if (dun_areaok(0) == 1) {
                proomptr.prmdir[flag] = 19 + dunwho->dunlev;
                updcas();
                prf_msg(WALLR, gendir[flag], NONE3);
                dun_outdun(PLYROOM, -1, -1, 0);
                if (dun_load(dun_getrm(dunwho->dunxc+genx[flag], dunwho->dunyc+geny[flag], dunwho->dunzc+genz[flag])) == 1) {
                    dir2 = 1;
                    if (flag == 1 || flag == 3 || flag == 5) dir2 = -1;
                    proomptr.prmdir[flag+dir2] = 19 + dunwho->dunlev;
                    updcas();
                    prf_msg(WALLR, gendir[flag+dir2], NONE3);
                    dun_outdun(dun_getrm(dunwho->dunxc+genx[flag], dunwho->dunyc+geny[flag], dunwho->dunzc+genz[flag]), -1, -1, 0);
                }
            }
            else dun_msg(dusrnum, CANTHER, NONE4);
        }
        else dun_msg(dusrnum, NOTHAP, NONE4);
    }
    else dun_msg(dusrnum, NOTHAP, NONE4);
}

void
dun_write(void)   /* create a scroll */
{
    int i, flag, flag1;
    flag = -1;
    for (i=0; i<MAXSPELL; i++) {
        if (dunwho->dunspe[i] > -1) {
            if (sameto(dmargv[1], pspelptr[dunwho->dunspe[i]].spenam)) {
                flag = i;
                i = MAXSPELL;
            }
        }
    }
    if (flag > -1) {
        flag1 = 0;
        for (i=0; i<10; i++) {
            if (dunwho->dunite[i] == -1) {
                dunwho->dunite[i] = 3;
                dunwho->dunist[i] = dunwho->dunspe[flag];
                dun_msg(dusrnum, SCRMA, NONE4);
                i = 11;
                flag1 = 1;
            }
        }
        if (flag1 == 0) dun_msg(dusrnum, PROCFL, NONE4);
    }
    else dun_msg(dusrnum, NSIB, NONE4);
}

void
dun_clone(void)       /* clone an item */
{
    int i, ii, flag, flag2;
    long cost;
    i = dun_ihand(dmargv[1], 2);
    flag = -1;
    if (i > -1) {
        for (ii=0; ii<10; ii++) {
            if (dunwho->dunite[ii] == -1) {
                flag = ii;
                ii = 10;
            }
        }
        if (flag > -1) {
            cost = (dun_howgood(dunwho->dunite[i], dunwho->dunist[i]) * 100) * 2;
            if (dunwho->spcomp >= cost) {
                dunwho->spcomp-=cost;
                flag2 = 0;
                if (pitemptr[dunwho->dunite[i]].pitty == POTION) {
                    if (dun_rand(3) == 0) {
                        prf_msg(POTEXP, pitemptr[dunwho->dunite[i]].pitnam, NONE3);
                        prf_msg(DAMAGE, spr("%d", 9), NONE3);
                        dun_outply(dusrnum);
                        prf_msg(POTITEX, pitemptr[dunwho->dunite[i]].pitnam, dunwho->dunname, NONE2);
                        dun_outdun(PLYROOM, dusrnum, -1, 9);
                        dunwho->dunite[i] = -1;
                        dunwho->dunist[i] = -1;
                        dunwho->poison+=10;
                        dunwho->dunhp-=9;
                        if (dunwho->dunhp < 1) {
                            dun_msg(dusrnum, YOUDEAD, NONE4);
                            fade2blk(dusrnum);
                        }
                        flag2 = 1;
                    }
                }
                if (dunwho->dunite[i] == SATSWD ||
                dunwho->dunite[i] == SATARM) flag2 = 1;
                if (flag2 == 0) {
                    dunwho->dunite[flag] = dunwho->dunite[i];
                    dunwho->dunist[flag] = dunwho->dunist[i];
                    dun_msg(dusrnum, IMA, dun_aoran(pitemptr[dunwho->dunite[flag]].pitnam, 0), pitemptr[dunwho->dunite[flag]].pitnam, NONE2);
                    prf_msg(ISHA, dun_aoran(pitemptr[dunwho->dunite[flag]].pitnam, 0), pitemptr[dunwho->dunite[flag]].pitnam, dunwho->dunname, NONE1);
                    dun_outdun(PLYROOM, -1, dusrnum, 0);
                }
                else dun_msg(dusrnum, PROCFL, NONE4);
            }
            else dun_msg(dusrnum, COSCLO, spr("%ld", cost), pitemptr[dunwho->dunite[i]].pitnam, NONE2);
        }
        else dun_msg(dusrnum, PROCFL, NONE4);
    }
    else dun_msg(dusrnum, NOTCAR, dmargv[1], NONE3);
}

void
dun_summ(void)   /* summon monster */
{
    int i, flag;
    flag = -1;
    if (dmargc < 2) dun_hlp();
    else {
        for (i=monstart; i<maxcreat; i++) {
            if (sameto(dmargv[1], getply(i)->dunname)) {
                flag = i;
                i = maxcreat;
            }
        }
        for (i=monstart; i<maxcreat; i++) {
            if (getply(i)->dunaptr.stt == PLAYING) {
                if (getply(i)->dunaptr.summon == 1) {
                    if (sameas(getply(i)->dunaptr.pcomba, dunwho->dunname)) {
                        dun_monconf(i);
                    }
                }
            }
        }
        if (flag > -1) {
            if (dunwho->duncha > getply(flag)->duncha) getply(flag)->dunaptr.summon = 1;
            else getply(flag)->dunaptr.summon = 0;
            strncpy(getply(flag)->dunaptr.pcomba, dunwho->dunname, NAMSIZ);
            dun_msg(dusrnum, USUMM, getply(flag)->dunname, NONE3);
        }
        else dun_msg(dusrnum, PROCFL, NONE4);
    }
}

void
dun_comm(void)    /* command a creature */
{
    int tuser, i, flag;
    struct duncmd *duncptr;
    flag = -1;
    for (i=monstart; i<maxcreat; i++) {
        if (sameas(getply(i)->dunaptr.pcomba, dunwho->dunname)) {
            if (getply(i)->dunaptr.summon == 1) {
                flag = i;
                i = maxcreat;
            }
        }
    }
    if (flag > -1) {
        tuser = dmargc;
        if (tuser > 20) tuser = 20;
        for (i=0; i<tuser; i++) {
            strncpy(dmargv[i], dmargv[i+1], 18);
        }
        dmargc = tuser - 1;
        if ((duncptr = pasearch(dmargv[0], dunarr, dunsiz)) != NULL) {
            hlpmsg = duncptr->cmdhlp;
            if (duncptr->sysonly == 0) {
                tuser = dusrnum;
                dunwho=getply(flag);
                dusrnum = flag;
                (*(duncptr->dunout))();
                dusrnum = tuser;
                dunwho=getply(tuser);
                prf_msg(CASTED, NONE4);
            }
            else prf_msg(PROCFL, NONE4);
        }
        else prf_msg(PROCFL, NONE4);
    }
    else prf_msg(PROCFL, NONE4);
    dun_outply(dusrnum);
}

void
dun_clai(void)    /* lock an area to user specific */
{
    dun_load(PLYROOM);
    if (dun_areaok(0) != 0) {
        if (proomptr.trade == 1 && dunwho->dunzc < 30) {
            setbtv(psalebb);
            if (qeqbtv(proomptr.prmin, 0)) {
                gcrbtv(&psaleptr, 0);
                if (sameas(psaleptr.namind, dunwho->dunname)) {
                    strncpy(proomptr.bared, dunwho->dunname, NAMSIZ);
                    updcas();
                    prf_msg(AIYS, NONE4);
                }
                else prf_msg(PROCFL, NONE4);
            }
            else prf_msg(PROCFL, NONE4);
        }
        else prf_msg(PROCFL, NONE4);
    }
    else prf_msg(PROCFL, NONE4);
    dun_outply(dusrnum);
}

void
dun_mdex(void)   /* magical dexterity */
{
    dun_msg(dusrnum, UVDEX, NONE4);
    dunwho->dundex+=500;
}

void
dun_hstr(void)  /* hercules strength */
{
    dun_msg(dusrnum, UVSTG, NONE4);
    dunwho->dunstr+=500;
}

void
dun_lich(void)   /* lightning bolt */
{
    int dir, xc, yc, zc, flag, flag2, i, dir2, temp;
    PLAYER *dunoth;
    flag = -1;
    for (i=0; i<maxcreat; i++) {
        if (getply(i)->dunaptr.stt == PLAYING) {
            if (sameas(dunwho->dunaptr.pcomba, getply(i)->dunname)) {
                flag = i;
                i = maxcreat;
            }
        }
    }
    dir = dun_getdir(dmargv[1]);
    dir2 = 1;
    if (dir == 1 || dir == 3 || dir == 5) dir2 = -1;
    if (dir > -1) {
        if (flag > -1) dunoth=getply(flag);
        xc = dunwho->dunxc;
        yc = dunwho->dunyc;
        zc = dunwho->dunzc;
        dun_msg(dusrnum, URLIT, gendir[dir], NONE3);
        flag2 = 0;
        do {
            prf_msg(RMLU, NONE4);
            dun_outdun(dun_getrm(xc, yc, zc), -1, -1, 0);
            if (flag > -1) {
                if (xc == dunoth->dunxc && yc == dunoth->dunyc && zc == dunoth->dunzc) {
                    prf_msg(SHBB, dunoth->dunname, NONE3);
                    temp = dusrnum;
                    dusrnum = flag;
                    dun_outdun(OTHROOM, -1, dusrnum, 0);
                    dusrnum = temp;
                    dun_msg(flag, YHBB, NONE4);
                    if (dunwho->dunxc != xc || dunwho->dunyc != yc || dunwho->dunzc != zc) {
                        dun_msg(dusrnum, YHBP, dunoth->dunname, NONE3);
                    }
                    dun_dam2(dusrnum, flag, (dunwho->dunlev * 5), 5);
                    break;
                }
            }
            if (dun_load(dun_getrm(xc, yc, zc)) == 0) break;
            else {
                if (proomptr.prmdir[dir] == 2) {
                    proomptr.prmdir[dir] = 1;
                    updcas();
                    prf_msg(WOISH, gendir[dir], NONE3);
                    dun_outdun(dun_getrm(xc, yc, zc), -1, -1, 0);
                    dun_load(dun_getrm(xc+genx[dir], yc+geny[dir], zc+genz[dir]));
                    proomptr.prmdir[dir+dir2] = 1;
                    updcas();
                    prf_msg(WOISH, gendir[dir+dir2], NONE3);
                    dun_outdun(dun_getrm(xc+genx[dir+dir2],yc+geny[dir+dir2],zc+genz[dir+dir2]), -1, -1, 9);
                    break;
                }
                else if (proomptr.prmdir[dir] > 9 && proomptr.prmdir[dir] < 20) {
                    proomptr.prmdir[dir] = 1;
                    updcas();
                    prf_msg(DOSH, gendir[dir], NONE3);
                    dun_outdun(dun_getrm(xc, yc, zc), -1, -1, 0);
                    dun_load(dun_getrm(xc+genx[dir], yc+geny[dir], zc+genz[dir]));
                    proomptr.prmdir[dir+dir2] = 1;
                    updcas();
                    prf_msg(DOSH, gendir[dir+dir2], NONE3);
                    dun_outdun(dun_getrm(xc+genx[dir+dir2],yc+geny[dir+dir2],zc+genz[dir+dir2]), -1, -1, 9);
                    break;
                }
                else if (proomptr.prmdir[dir] != 1) break;
            }
            xc = xc + genx[dir];
            yc = yc + geny[dir];
            zc = zc + genz[dir];
            flag2++;
        } while (flag2 < 5);
    }
    else dun_hlp();
}

void
dun_mesw(void)   /* meteor swarm */
{
    int i;
    PLAYER *dunoth;
    prf_msg(SWMET, dunwho->dunname, NONE3);
    dun_outdun(PLYROOM, -1, dusrnum, 9);
    dun_msg(dusrnum, SWREL, NONE4);
    for (i=0; i<maxcreat; i++) {
        if (getply(i)->dunaptr.stt == PLAYING && i != dusrnum) {
            dunoth=getply(i);
	    if (dunoth->dunxc == dunwho->dunxc &&
	        dunoth->dunyc == dunwho->dunyc &&
		dunoth->dunzc == dunwho->dunzc) {
                dun_msg(i, UHITME, NONE4);
                prf_msg(HHITME, dunoth->dunname, NONE3);
                dun_outply(dusrnum);
                dun_dam2(dusrnum, i, (dunwho->dunlev * 15), 50);
            }
        }
    }
}


void
dun_searc(void)  /* search player sepll */
{
    int i, flag;
    PLAYER *dunoth;
    flag = 0;
    for (i=0; i<maxcreat; i++) {
        if (getply(i)->dunaptr.stt == PLAYING && i != dusrnum) {
            dunoth=getply(i);
            if (sameto(dmargv[1], dunoth->dunname)) {
                if (!(dunoth->dunaptr.mutflags&HIDDEN)) {
                    prf("%s is the year %d A.D.\r", dunoth->dunname, (dunoth->dunzc * 100) + 2000);
                    dun_outply(dusrnum);
                    i = maxcreat;
                    flag = 1;
                }
                else {
                    prf("For some reason, you can't search %s!\r", dunoth->dunname);
                    dun_outply(dusrnum);
                    i = maxcreat;
                    flag = 1;
                }
            }
        }
    }
    if (flag == 0) dun_msg(dusrnum, PROCFL, NONE4);
}

void
dun_find(void)  /* find player sepll */
{
    int i, xc, yc, flag;
    PLAYER *dunoth;
    flag = 0;
    for (i=0; i<maxcreat; i++) {
        if (getply(i)->dunaptr.stt == PLAYING && i != dusrnum) {
            dunoth=getply(i);
            if (sameto(dmargv[1], dunoth->dunname)) {
                if (!(dunoth->dunaptr.mutflags&HIDDEN) && i != monstart) {
                    xc = dunwho->dunxc - dunoth->dunxc;
                    yc = dunwho->dunyc - dunoth->dunyc;
                    if (dunwho->dunzc != dunoth->dunzc) dun_msg(dusrnum, PROCFL, NONE4);
                    else {
                        prf("%s is ", dunoth->dunname);
                        if (xc == 0 && yc == 0) {
                            prf("right here!\r");
                            dun_outply(dusrnum);
                        }
                        else {
                            if (xc < 0) prf("%d east; ", abs(xc));
                            else if (xc > 0) prf("%d west; ", xc);
                            if (yc < 0) prf("%d north; ", abs(yc));
                            else if (yc > 0) prf("%d south; ", yc);
                            prf("\r");
                            dun_outply(dusrnum);
                            dun_msg(i, SOMTHI, NONE4);
                        }
                    }
                    i = maxcreat;
                    flag = 1;
                }
                else {
                    prf("For some reason, you can't find %s!\r", dunoth->dunname);
                    dun_outply(dusrnum);
                    flag = 1;
                    i = maxcreat;
                }
            }
        }
    }
    if (flag == 0) dun_msg(dusrnum, PROCFL, NONE4);
}

void
dun_hide(void)  /* hide spell */
{
    dun_msg(dusrnum, UFADE, NONE4);
    prf_msg(DISAP, dunwho->dunname, NONE3);
    dun_outdun(PLYROOM, -1, dusrnum, 0);
    dunwho->dunaptr.mutflags|=INVIS;
    dunwho->dunaptr.mutflags|=HIDDEN;
}

void
dun_pois(void)  /*  Poison bolt */
{
    int dir, xc, yc, zc, flag, flag2, i;
    PLAYER *dunoth;
    flag = -1;
    for (i=0; i<maxcreat; i++) {
        if (getply(i)->dunaptr.stt == PLAYING) {
            if (sameas(dunwho->dunaptr.pcomba, getply(i)->dunname)) {
                flag = i;
                i = maxcreat;
            }
        }
    }
    dir = dun_getdir(dmargv[1]);
    if (dir > -1) {
        if (flag > -1) dunoth=getply(flag);
        xc = dunwho->dunxc;
        yc = dunwho->dunyc;
        zc = dunwho->dunzc;
        dun_msg(dusrnum, URELPO, gendir[dir], NONE3);
        prf_msg(HCASPO, dunwho->dunname, gendir[dir], NONE2);
        dun_outdun(PLYROOM, -1, dusrnum, 0);
        flag2 = 0;
        do {
            prf_msg(HISSO, NONE4);
            dun_outdun(dun_getrm(xc, yc, zc), -1, -1, 0);
            if (flag > -1) {
                if (xc == dunoth->dunxc && yc == dunoth->dunyc && zc == dunoth->dunzc) {
                    prf_msg(SOHBB, dunoth->dunname, NONE3);
                    dun_outdun(OTHROOM, flag, -1, 0);
                    dun_msg(flag, YBHBB, NONE4);
                    if (dunwho->dunxc != xc || dunwho->dunyc != yc || dunwho->dunzc != zc) {
                        dun_msg(dusrnum, YHBBB, dunoth->dunname, NONE3);
                    }
                    dun_dam2(dusrnum, flag, (dunwho->dunlev * 2), 5);
                    dunoth->poison = dunoth->poison + (dunwho->dunlev * 5);
                    break;
                }
            }
            if (dun_load(dun_getrm(xc, yc, zc)) == 0) break;
            if (proomptr.prmdir[dir] != 1) {
                if (proomptr.prmdir[dir] > 10 && proomptr.prmdir[dir] < 20) {
                    prf_msg(DARTSTCK, gendir[dir], NONE3);
                    dun_outdun(dun_getrm(xc, yc, zc), -1, -1, 0);
                    flag2 = 6;
                }
                else if (proomptr.prmdir[dir] > 19) {
                    prf_msg(LIGMELT, gendir[dir], NONE3);
                    dun_outdun(dun_getrm(xc, yc, zc), -1, -1, 0);
                    flag2 = 6;
                }
                else if (proomptr.prmdir[dir] == 2) {
                    prf_msg(DARTWALL, gendir[dir], NONE3);
                    dun_outdun(dun_getrm(xc, yc, zc), -1, -1, 0);
                    flag2 = 6;
                }
                else if (proomptr.prmdir[dir] != 10) flag2 = 6;
            }
            xc = xc + genx[dir];
            yc = yc + geny[dir];
            zc = zc + genz[dir];
            flag2++;
        } while (flag2 < 5);
    }
    else dun_hlp();
}


/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
*                         DIS-SPELL ACTION HANDLER                        *
*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

void
dun_dispell(void)   /* dispell current spell if in use on player */
{
    struct pspelrec *dspell;
    if (dunwho->dunaptr.lespe != 0) {
        dunwho->dunaptr.lespe = 0;
        dspell=&pspelptr[dunwho->dunaptr.dunrsp];
        dun_msg(dusrnum, SPEOVE, dspell->spenam, NONE3);
        (*(dspell->dispel))();
    }
}

void
dun_dislig(void)     /* dispell LIGHT */
{
    dun_load(PLYROOM);
    dunwho->dunaptr.mutflags&=~LIGHT;
    if (dun_dark(0) == 1) {
        prf_msg(DARKOV, NONE4);
        dun_outdun(PLYROOM, -1, -1, 0);
    }
}

void
dun_disin(void)   /* dispell INVISIBILITY */
{
    dunwho->dunaptr.mutflags&=~INVIS;
    dun_msg(dusrnum, HEMAP, NONE4);
    prf_msg(MAPP, dunwho->dunname, NONE3);
    dun_outdun(PLYROOM, -1, dusrnum, 0);
}

void
dun_nodex(void)   /* dispell magical dexterity */
{
    dunwho->dundex-=500;
}

void
dun_nostr(void)    /* dispell hercules strength */
{
    dunwho->dunstr-=500;
}

void
dun_nhide(void)    /* dispell hidden */
{
    dun_msg(dusrnum, HEMAP, NONE4);
    prf_msg(MAPP, dunwho->dunname, NONE3);
    dun_outdun(PLYROOM, -1, dusrnum, 0);
    dunwho->dunaptr.mutflags&=~INVIS;
    dunwho->dunaptr.mutflags&=~HIDDEN;
}

void
dun_rdsc(void)    /* read a scroll */
{
    int i;
    if (dmargc < 2) dun_hlp();
    else {
        i = dun_ihand(dmargv[1], 2);
        if (i > -1) {
            if (pitemptr[dunwho->dunite[i]].pitty == SCROLL) {
                dun_dispell();
                dun_msg(dusrnum, FINMEM, pspelptr[dunwho->dunist[i]].spenam, NONE3);
                dun_msg(dusrnum, SCRDIS, NONE4);
                prf_msg(MUMHIM, dunwho->dunname, SEX, NONE2);
                dun_outdun(PLYROOM, -1, dusrnum, 0);
                dunwho->dunaptr.dunrsp = dunwho->dunist[i];
                dunwho->dunaptr.dunmsp = 0;
                dunwho->dunite[i] = -1;
                dunwho->dunist[i] = -1;
            }
            else dun_msg(dusrnum, HLPREAD, NONE4);
        }
        else dun_msg(dusrnum, NOTCAR, dmargv[1], NONE3);
    }
}













