/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~
*   MJSMUTUT.C                                                            *
*   Version 2.30                                                          *
*   Copyright (C) 1991-93, MajorSoft Inc. and Eric Furrer                 *
*   This is the MUTANTS! utilities handler                                *
*   for the MajorBBS version 6.xx +                                       *
*   E. Furrer      12/24/91        "it's not how you play the game,       *
*                                   it's if you win or lose."             *
*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

#include "gcomm.h"
#include "majorbbs.h"
#include "mjsmutx.h"            /* msg header file                      */
#include "mjsmuth.h"            /* mutants header file                  */
#include "mjsmutp.h"            /* mutants prototype file               */

char *dun_aoran(parm1, parm2)   /* a or an??   parm2 = 0 for upper case */
char parm1[];
int parm2;
{
    static char dunret[4];
    char vowel[5];
    int i;
    strcpy(vowel, "AEIOU");
    setmem(dunret, 4, 0);
    dunret[1] = ' ';
    if (parm2 == 0) dunret[0] = 'A';
    else dunret[0] = 'a';
    for (i=0; i<5; i++) {
        if (toupper(parm1[0]) == vowel[i]) {
            dunret[1] = 'n';
            dunret[2] = ' ';
            i = 6;
        }
    }
    return(dunret);
}

char *dun_form(dunm1)       /* FORMAT A CO-ORDINATE */
int dunm1;
{
    char dunxf[4];
    static char prefor[4];
    setmem(prefor, 4, 0);
    setmem(dunxf, 4, 0);
    strncpy(dunxf, spr("%d", dunm1), 3);
    if (dunm1 >= 0) prefor[0] = '+';
    else prefor[0] = '-';
    if (dunm1 < 10 && dunm1 > -10) {
        prefor[1] = '0';
        if (dunm1 < 0) {
            prefor[2] = dunxf[1];
        }
        else {
            prefor[2] = dunxf[0];
        }
    }
    else {
        if (dunm1 < 0) {
            prefor[1] = dunxf[1];
            prefor[2] = dunxf[2];
        }
        else {
            prefor[1] = dunxf[0];
            prefor[2] = dunxf[1];
        }
    }
    prefor[3] = '\0';
    return(prefor);
}

char *dun_getrm(dunx, duny, dunz)    /* FORMAT A ROOM LOCATION BASED ON X,Y,Z */
int dunx, duny, dunz;
{
    static char pretrm[10];
    setmem(pretrm, 10, 0);
    strcpy(pretrm, dun_form(dunx));
    strcat(pretrm, dun_form(duny));
    strcat(pretrm, dun_form(dunz));
    strcat(pretrm, "\0");
    return(pretrm);
}

char *dun_ing(dunm1)   /* add ing to a verb */
char *dunm1;
{
    static char pretrm[255];
    char vowel[6], temp_cons[25];
    int i;
    strncpy(vowel, "aeiou", 6);
    setmem(pretrm, 255, 0);
    strcpy(pretrm, dunm1);
    for (i = 0; i < 5; i++) {
        if (tolower(pretrm[strlen(pretrm)-1]) == vowel[i]) {
            pretrm[strlen(pretrm)-1] = '\0';
            i = 5;
        }
    }
    if (strlen(pretrm) > 1) {
        if (tolower(pretrm[strlen(pretrm)-1]) != tolower(pretrm[strlen(pretrm)-2])) {
            strncpy(temp_cons, "bcdfmprstz", 25);
            for (i = 0; i < strlen(temp_cons); i++) {
                if (temp_cons[i] == tolower(pretrm[strlen(pretrm)-1])) {
                    pretrm[strlen(pretrm)] = temp_cons[i];
                    i = strlen(temp_cons);
                }
            }
        }
    }
    strcat(pretrm, "ing");
    return(pretrm);
}

long dun_worth(stat, itptr)  /* find the worth of an item */
int stat, itptr;
{
    long worth;
    worth = 0;
    worth+=(long)(pitemptr[itptr].fixval * stat);
    worth+=(long)(pitemptr[itptr].value);
    if (stat > 100) worth+=(long)((stat-100)*1000);
    return(worth);
}

int dun_mark(which)           /* find the markup/down of an item  1 = up */
int which;
{
    int flag;
    setbtv(psalebb);
    flag = 0;
    if (qeqbtv(PLYROOM, 0)) {
        gcrbtv(&psaleptr, 0);
        if (which == 1) flag = (int)psaleptr.markup;
        else flag = (int)psaleptr.markdown;
    }
    else flag = 0;
    if (sameas(psaleptr.namind, "Village Shop")) {
        if (which == 1) flag = doptions.stormu;
        else flag = doptions.stormd;
    }
    return(flag);
}

void dispclass(void)     /* ask user what class to select */
{
    int i, ii;
    char temp[NAMSIZ];
    setbtv(pplybb);
    prf("\r");
    i = 0;
    setmem(temp, NAMSIZ, 0);
    strcpy(temp, uacoff(usrnum)->userid);
    if (qeqbtv(temp, 0)) {
        gcrbtv(dunwho, 0);
        ii = 1;
        do {
            i++;
            prf("%d. %-18s Level: %-3d Year: %-4d  (%-3d%3d)", i, classptr[dunwho->duncla].clanam, dunwho->dunlev, (dunwho->dunzc*100)+2000, dunwho->dunxc, dunwho->dunyc);
            if (dunwho->dundead > -1) {
                prf(" DEAD: %d day(s) left.", dunwho->dundead);
            }
            prf("\r");
            ii = aqnbtv(dunwho);
            if (ii == 1) {
                gcrbtv(dunwho, 0);
                if (!sameas(temp, dunwho->dunname)) ii = 0;
            }
        } while (ii == 1);
    }
    prf("\rType BURY [class number] to reset a player.\r");
    dun_msg(dusrnum, CLASEL, NONE4);
}

long dun_howgood(itptr, itsta)   /* how good is an item for combat */
int itptr, itsta;
{
    long howgood;
    howgood = -1;
    if (itptr > 1) {
        howgood = itsta;
        howgood+=(pitemptr[itptr].pdspe * 10);
        howgood+=(pitemptr[itptr].pddam * 10);
        if (itsta > 100) howgood+=((itsta-100)*100);
    }
    return(howgood);
}

void prf_msg(wmesnum, dunm1, dunm2, dunm3, dunm4)   /* send a message - no outprf'ing */
int wmesnum;
char *dunm1, *dunm2, *dunm3, *dunm4;
{
    if (wmesnum < 500) {
        setmbk(dunmb);
        prf("%s", RED);
        if (dunm4 != '\0') prfmsg(wmesnum, dunm1, dunm2, dunm3, dunm4);
        else if (dunm3 != '\0') prfmsg(wmesnum, dunm1, dunm2, dunm3);
        else if (dunm2 != '\0') prfmsg(wmesnum, dunm1, dunm2);
        else if (dunm1 != '\0') prfmsg(wmesnum, dunm1);
        else prfmsg(wmesnum);
        prf("%s", WHITE);
    }
}

void dun_msg(towho, wmesnum, dunm1, dunm2, dunm3, dunm4)   /* SEND A MESSAGE TO USER */
int towho, wmesnum;
char *dunm1, *dunm2, *dunm3, *dunm4;
{
    if (wmesnum < 700) {
        if (towho < monstart) {
            setmbk(dunmb);
            prf("%s***\r%s", WHITE, YELLOW);
            if (dunm4 != '\0') prfmsg(wmesnum, dunm1, dunm2, dunm3, dunm4);
            else if (dunm3 != '\0') prfmsg(wmesnum, dunm1, dunm2, dunm3);
            else if (dunm2 != '\0') prfmsg(wmesnum, dunm1, dunm2);
            else if (dunm1 != '\0') prfmsg(wmesnum, dunm1);
            else prfmsg(wmesnum);
            outprf(towho);
	    clrprf();
        }
    }
}

void dun_hlp(void)   /* print help to user */
{
    if (hlpmsg > -1) {
        setmbk(dunmb);
        prfmsg(hlpmsg);
        outprf(dusrnum);
	clrprf();
    }
    else {
        prf("WHAT?\r");
        outprf(dusrnum);
	clrprf();
    }
}

int dun_load(pldrm)               /* room caching/loading/flushing */
char *pldrm;
{
    int flg, ii;
    ROOMS roomtemp;
    if (sameas(pldrm, proomptr.prmin)) return(1);
    flg = -1;
    setbtv(proombb);
    for (ii=0; ii<doptions.cachesize; ii++) {
        if (sameas(cacheptr[ii].prmin, pldrm)) {
            proomptr = cacheptr[ii];
            flg = 1;
            ii = doptions.cachesize;
        }
    }
    if (flg == -1) {
        flg = 0;
        if (qeqbtv(pldrm, 0)) {
            gcrbtv(&proomptr, 0);
            for (ii=doptions.cachesize; ii>0; ii--) {
                cacheptr[ii] = cacheptr[ii-1];
            }
            cacheptr[0] = proomptr;
            if (qeqbtv(cacheptr[doptions.cachesize].prmin, 0)) {
                gcrbtv(&roomtemp, 0);
                if (memcmp((char *)&roomtemp, (char *)&cacheptr[doptions.cachesize], sizeof(ROOMS)) != 0) {
                    updbtv(&cacheptr[doptions.cachesize]);
                }
            }
            flg = 1;
        }
    }
    return(flg);
}

void updcas(void)   /* update the cache/file */
{
    int i, flg;
    flg = -1;
    setbtv(proombb);
    for (i=0; i<doptions.cachesize; i++) {
        if (sameas(proomptr.prmin, cacheptr[i].prmin)) {
            cacheptr[i] = proomptr;
            i = doptions.cachesize;
            flg = 1;
        }
    }
    if (flg == -1) {
        if (qeqbtv(proomptr.prmin, 0) == 1) {
            gcrbtv(NULL, 0);
            updbtv(&proomptr);
        }
        else {
            insbtv(&proomptr);
            maxroom++;
        }
    }
}

void 
dun_clrmap(void)   /* clear player map */
{
    int x;
    if (dusrnum < monstart) { 
        for (x=0; x < 9; x++) {
	  strcpy(mutmap[dusrnum].play_map[x], ".........\0");
        }
        dun_load(PLYROOM);
        if (proomptr.maint == 1) mutmap[dusrnum].play_map[4][4] = 'm';
        if (proomptr.trade == 1) mutmap[dusrnum].play_map[4][4] = 't';
        if (mutmap[dusrnum].play_map[4][4] == '.') mutmap[dusrnum].play_map[4][4] = '#';
    }
}

void dun_flucas(void)   /* flush the cache and reset */
{
    int i;
    ROOMS dungtemp;
    setbtv(proombb);
    for (i=0; i<doptions.cachesize; i++) {    /* flush cache */
        if (qeqbtv(cacheptr[i].prmin, 0)) {
            gcrbtv(&dungtemp, 0);
            if (memcmp((char *)&dungtemp, (char *)&cacheptr[i], sizeof(ROOMS)) != 0) {
                updbtv(&cacheptr[i]);
            }
        }
        setmem(cacheptr[i].prmin, 10, 0);
    }
}

int dun_ispel(parm1)          /* is spell in book? if so, return member */
char *parm1;
{
    int i, pflag;
    pflag = -1;
    for (i=0; i<20; i++) {
        if (dunwho->dunspe[i] > -1) {
            if (sameto(parm1, pspelptr[dunwho->dunspe[i]].spenam)) {
                pflag = i;
                i = 21;
            }
        }
    }
    return(pflag);
}

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
* is player in room? if so, return member   *
* pid is player name, proom is room         *
* #, which is # of args in comm line - 1    *
*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/
int dun_isply(pid, proom, which)
char pid[], proom[];
int which;
{
    int i, pflg;
    char proom2[10], tname[NAMSIZ], pid2[NAMSIZ];
    PLAYER *dunoth;
    strncpy(proom2, proom, 10);
    strncpy(pid2, pid, NAMSIZ);
    pflg = -1;
    if (dmargc > which) which = atoi(dmargv[which]);
    else which = 0;
    if (strlen(pid2) > 0) {
        for (i=0; i<maxcreat; i++) {
            if (getply(i)->dunaptr.stt == PLAYING) {
                dunoth=getply(i);
                setmem(tname, NAMSIZ, 0);
                strncpy(tname, dunoth->dunname, strlen(pid2));
                strcat(tname, "\0");
                if (sameas(tname, pid2)) {
                    if (sameas(OTHROOM, proom2)) {
                        if (!(dunoth->dunaptr.mutflags&INVIS)) {
                            if (which != 0 && i > (monstart - 1)) {
                                if (which == (i - monstart + 1)) {
                                    pflg = i;
                                    i = maxcreat;
                                }
                            }
                            else {
                                pflg = i;
                                i = maxcreat;
                            }
                        }
                    }
                }
            }
        }
        if (pflg == -1) {
            for (i=0; i<maxcreat; i++) {
                if (getply(i)->dunaptr.stt == PLAYING) {
                    dunoth=getply(i);
                    setmem(tname, NAMSIZ, 0);
                    strncpy(tname, dunoth->dunname, strlen(pid2));
                    strcat(tname, "\0");
                    if (sameas(tname, pid2)) {
                        if (sameas(OTHROOM, proom2)) {
                            if (!(dunoth->dunaptr.mutflags&INVIS)) {
                                pflg = i;
                                i = maxcreat;
                            }
                        }
                    }
                }
            }
        }
    }
    return(pflg);
}

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
* is item on hand, if so, return member *
* dunx is the item desc, num is the     *
* number of args in comm line - 1       *
*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/
int dun_ihand(dunx, num)
char *dunx;
int num;
{
    int i, pflag, pctr, which;
    char ptemp[255];
    pctr = 0;
    pflag = -1;
    which = 0;
    if (dmargc > num) which = atoi(dmargv[num]);
    for (i=0; i<10; i++) {
        if (dunwho->dunite[i] > -1) {
            strncpy(ptemp, ITEMSCAN.pitnam, strlen(dunx));
            ptemp[strlen(dunx)] = '\0';
            if (sameas(ptemp, dunx) && pctr == which) {
                pflag = i;
                i = 11;
            }
            else if (sameas(ptemp, dunx)) pctr++;
        }
    }
    if (pflag == -1) {
        for (i=0; i<10; i++) {
            if (dunwho->dunite[i] > -1) {
                strncpy(ptemp, ITEMSCAN.pitnam, strlen(dunx));
                ptemp[strlen(dunx)] = '\0';
                if (sameas(ptemp, dunx)) {
                    pflag = i;
                    i = 11;
                }
            }
        }
    }
    return(pflag);
}

/*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*
* is item on ground, if so, return member *
* dunx is item desc, which is # of args   *
* in comm line - 1                        *
*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*~*/

int dun_ifloor(dunx, which)
char *dunx;
int which;
{
    int i, pflag, pctr;
    char ptemp[255];
    pctr = 0;
    pflag = -1;
    if (dmargc > which) which = atoi(dmargv[which]);
    else which = 0;
    for (i=0; i<6; i++) {
        if (proomptr.pitem[i] > -1) {
            strncpy(ptemp, pitemptr[proomptr.pitem[i]].pitnam, strlen(dunx));
            ptemp[strlen(dunx)] = '\0';
            if (sameas(ptemp, dunx) && pctr == which) {
                pflag = i;
                i = 6;
            }
            else if (sameas(ptemp, dunx)) pctr++;
        }
    }
    if (pflag == -1) {
        for (i=0; i<6; i++) {
            if (proomptr.pitem[i] > -1) {
                strncpy(ptemp, pitemptr[proomptr.pitem[i]].pitnam, strlen(dunx));
                ptemp[strlen(dunx)] = '\0';
                if (sameas(ptemp, dunx)) {
                    pflag = i;
                    i = 11;
                }
            }
        }
    }
    return(pflag);
}

void dun_dam(pusat, pusdef, itemcl)      /* damage a player from another player */
int pusat, pusdef, itemcl;
{
    int pdam, flag, temp;
    PLAYER *dunoth;
    temp = dusrnum;
    dunoth=getply(pusdef);
    dunoth->dunaptr.combat = doptions.comtime;
    dunwho->dunaptr.combat = doptions.comtime;
    pdam = 0;
    if (dunoth->dunhp > 0) {
        pdam = (dunwho->dunstr / 10);
        if (itemcl > -1) {
            if (pitemptr[dunwho->dunite[itemcl]].pitty != ARMOR) {
                pdam = pdam + pitemptr[dunwho->dunite[itemcl]].pddam;
                if (pitemptr[dunwho->dunite[itemcl]].pitty == SWORD && 
		    dunwho->dunite[itemcl] == 0) {
                    pdam = pdam - pitemptr[dunwho->dunite[itemcl]].pddam;
                }
            }
            else pdam = pdam + 4;
            if (pitemptr[dunwho->dunite[itemcl]].pitty == SWORD) {
	        if (dunwho->dunist[itemcl] < 100) {
                    pdam = pdam - ((100 - dunwho->dunist[itemcl]) / 10);
		}
                if (pdam < 0 ) pdam = 0;
                if (dunwho->dunist[itemcl] < 101 && dunwho->dunist[itemcl] > 0) dunwho->dunist[itemcl]-=dun_armor(pusdef);
                if (dunwho->dunist[itemcl] < 0 && dunwho->dunite[itemcl] != 0) {
                    dun_msg(dusrnum, SCRAK, pitemptr[dunwho->dunite[itemcl]].pitnam, NONE3);
                    prf_msg(HSCRA, dunwho->dunname, pitemptr[dunwho->dunite[itemcl]].pitnam, NONE2);
                    dun_outdun(PLYROOM, dusrnum, -1, 0);
                    dunwho->dunite[itemcl] = 0;
                    dunwho->dunist[itemcl] = 0;
                }
                if (dunwho->dunist[itemcl] > 100 && dunwho->dunist[itemcl] < 111) {
		    pdam+=(dunwho->dunist[itemcl] - 100);
		}
                else if (dunwho->dunist[itemcl] > 110) {
                    dunoth->poison = dunoth->poison + 10;
                    if (dunoth->poison > 50) dunoth->poison = 50;
		    pdam+=(dunwho->dunist[itemcl] - 100);
                }
            }
        }
        pdam-=(dun_armor(pusdef)/3);
        if (dunoth->dunast > 100) pdam-=((dunoth->dunast - 100)/2);
        if (itemcl > -1) {
            if (pitemptr[dunwho->dunite[itemcl]].pitty == SWORD) {
                if (dunwho->dunist[itemcl] > 100) {
                    pdam = pdam + ((dunwho->dunist[itemcl] - 100) * 3);
                }
            }
        }
        else pdam = pdam / 2;
        if (pdam < 0) pdam = 0;
        if (pdam > 0) dun_msg(pusdef, DAMAGE, spr("%d", pdam), NONE3);
        if (pusdef > monstart -1) {
            if (dunoth->dunhp > 10) {
                if (dunoth->dunhp - pdam < 11) {
                    dunoth->dunhp = 9;   /* made 9 so retreating is always possible */
                }
                else dunoth->dunhp-=pdam;
            }
            else dunoth->dunhp-=pdam;
        }
        else dunoth->dunhp-=pdam;
        if (dunoth->dunarm > 1) {    /* damage armor */
            if (dunoth->dunast < 101 && dunoth->dunast > 0) {
                if (pdam > 1) dunoth->dunast-=pdam;
                else dunoth->dunast-=2;
            }
            if (dunoth->dunast < 0) {
                dunoth->dunast = 0;
                dunoth->dunarm = 1;
                dun_msg(pusdef, ACIH, NONE4);
                prf_msg(HACIH, dunoth->dunname, NONE3);
                dun_outdun(OTHROOM, -1, pusdef, 0);
            }
        }
        if (dunoth->dunhp <= 0) {
            dun_kill(pusdef, pusat);
        }
        else {
            if (pusdef > monstart -1 && !sameas(dunoth->dunaptr.pcomba, dunwho->dunname)) {
                flag = 0;
                if (sameas(dunoth->dunaptr.pcomba, "ROAM IT")) flag = 1;
                else {
                    if (dun_isply(dunoth->dunaptr.pcomba, OTHROOM, 10) == -1) flag = 1;
                }
                if (flag == 1) {
                    pdam = dusrnum;
                    dusrnum = pusdef;
                    strncpy(dmargv[0], "combat", 10);
                    strncpy(dmargv[1], dunwho->dunname, NAMSIZ);
                    dmargc = 2;
                    dunwho=getply(pusdef);
                    dun_comb();
                    dunwho=getply(pdam);
                    dusrnum = pdam;
                }
            }
        }
    }
    dusrnum = temp;
}

void dun_dam2(pusat, pusdef, howmuch, special)   /* damage player->player with special spells */
int pusat, pusdef, howmuch, special;
{
    int damage;
    PLAYER *dunoth;
    dunoth=getply(pusdef);
    dunoth->dunaptr.combat = doptions.comtime;
    dunwho->dunaptr.combat = doptions.comtime;
    damage = howmuch;
    damage = damage + special;
    damage = damage - (dun_armor(pusdef) / 4);
    if (damage < 6) damage = 6;
    dun_msg(pusdef, DAMAGE, spr("%d", damage), NONE3);
    dunoth->dunhp = dunoth->dunhp - damage;
    if (dunoth->dunhp <= 0) dun_kill(pusdef, pusat);
    else {
        if (pusdef > monstart - 1) {
            if (!sameas(dunwho->dunname, dunoth->dunaptr.pcomba)) {
                damage = dusrnum;
                dunwho = getply(pusdef);
                strncpy(dunwho->dunaptr.pcomba, getply(damage)->dunname, NAMSIZ);
                prf("%s %s's %s, %s!\r", dunwho->dunname, pmonsptr[dunwho->duncla].montal, pmonsptr[dunwho->duncla].monbat, dunwho->dunaptr.pcomba);
                dun_outdun(PLYROOM, -1, -1, 4);
                dun_monconf(dusrnum);
                dusrnum = damage;
                dunwho = getply(dusrnum);
            }
            if (dunoth->dunlev > 10) {
                dun_load(PLYROOM);
                if (proomptr.dark > 0) {
                    proomptr.dark = 0;
                    updcas();
                    prf_msg(DARKLI, NONE4);
                    dun_outdun(PLYROOM, -1, -1, 0);
                }
            }
        }
    }
}


/* who died; who got killed */
void dun_kill(pwhod, pwhok)       /* kill a player */
int pwhod, pwhok;
{
    int temp;
    long ion, expbon;
    char what[255];
    PLAYER *dunoth;
    setmem(what, 255, 0);
    dunoth=getply(pwhod);
    if (pwhok < monstart) strcat(what, classptr[dunwho->duncla].clanam);
    sprintf(what, " %s has slain ", dunwho->dunname);
    if (pwhod < monstart) strcat(what, spr("%s ", classptr[dunoth->duncla].clanam));
    strcat(what, spr("%s!", dunoth->dunname));
    dun_telm(what);
    dun_msg(pwhod, HKILL, dunwho->dunname, NONE3);
    dun_msg(pwhod, YOUDEAD, NONE4);
    if (pwhod != pwhok) {
        ion = 0;
        if (dunoth->spcomp > 0) ion = (dunoth->spcomp / 2);
        if (ion < 0) ion = 0;
        if (dunoth->dunzc == 30 && pwhod > monstart) {
            if (getply(monstart)->dunaptr.stt == PLAYING) {
                setmem(what, 255, 0);
                if (dunoth->dunyc > getply(monstart)->dunyc) strcat(what, "south-");
                else if (dunoth->dunyc < getply(monstart)->dunyc) strcat(what, "north-");
                if (dunoth->dunxc > getply(monstart)->dunxc) strcat(what, "west-");
                else if (dunoth->dunxc < getply(monstart)->dunxc) strcat(what, "east-");
                if (strlen(what) > 0) {
                    what[strlen(what)-1] = '\0';
                    prf_msg(WHRSAT, dunoth->dunname, dunwho->dunname, what, NONE1);
                    dun_outdun(PLYROOM, -1, -1, 0);
                }
            }
        }
        prf_msg(YSLAY, dunoth->dunname, NONE3);
        expbon = dunoth->dunscr/15;
	if (expbon > doptions.maxplp && pwhod < monstart) {
	    expbon = doptions.maxplp;
	}
        prf_msg(YEXPI, spr("%ld", expbon), NONE3);
        prf_msg(YCOLL, spr("%ld", dunoth->dungold), spr("%ld", ion), NONE2);
        dun_outply(pwhok);
        dunwho->dunscr+=expbon;
        if (pwhod < monstart || pwhok < monstart) dunwho->dungold+=dunoth->dungold;
        dunwho->spcomp+=ion;
        if (pwhok > monstart - 1) {
            if (dunwho->dunscr > (dunwho->dunlev * 10000)) dun_levinc(pwhok);
        }
        else {
            if (dunwho->dunlev < MAXPLEVL) {
                if (dunwho->dunscr >= levelptr[dunwho->duncla].reqexp[dunwho->dunlev-1]) dun_levinc(pwhok);
            }
            else {
                if (dunwho->dunscr >= (levelptr[dunwho->duncla].reqexp[MAXPLEVL-1]) * (dunwho->dunlev - MAXPLEVL + 1)) dun_levinc(pwhok);
            }
        }
    }
    dunoth->dunhp = 0;
    temp = dusrnum;
    dunwho=getply(pwhod);
    dusrnum = pwhod;
    dun_dispell();
    dunwho=getply(temp);
    dusrnum = temp;
    dunoth->dunaptr.combat = 0;
    fade2blk(pwhod);
}

void dun_levinc(pwho)
int pwho;
{
    int i, t, new_lev;
    LEVEL *levptr;
    if (pwho < monstart) {   /* increase a player's level */
        dun_msg(pwho, LEVINC, NONE4);
        new_lev = dunwho->dunlev-1;
        if (new_lev > MAXPLEVL-1) new_lev = MAXPLEVL-1;
        levptr=&levelptr[dunwho->duncla];
        dunwho->dunstr+=levptr->strinc[new_lev];
        dunwho->dunint+=levptr->intinc[new_lev];
        dunwho->dunwis+=levptr->wisinc[new_lev];
        dunwho->dundex+=levptr->dexinc[new_lev];
        dunwho->duncon+=levptr->coninc[new_lev];
        dunwho->duncha+=levptr->chainc[new_lev];
        dunwho->maxhp+=levptr->mhpinc[new_lev];
        dunwho->dunhp+=levptr->mhpinc[new_lev];
        if (levptr->mspell > 0) {
            for (t=0; t<levptr->mspell[new_lev]; t++) {
                for (i=0; i<sizspell; i++) {
                    if (dunwho->dunspe[i] == -1) {
                        dunwho->dunspe[i] = i;
                        dun_msg(dusrnum, GRSP, pspelptr[i].spenam, NONE3);
                        i = 20;
                    }
                }
            }
        }
        dunwho->dunlev++;
    }
    else {    /* increase a monster's level */
        dunwho->dunlev++;
        dunwho->dunstr+=2;
        dunwho->dunint+=2;
        dunwho->dunwis+=2;
        dunwho->dundex+=2;
        dunwho->duncon+=2;
        dunwho->duncha+=2;
        dunwho->maxhp+=10;
        dunwho->dunhp = dunwho->maxhp;
    }
}

void dun_outply(dunm)   /* special dungeon prf() command */
int dunm;
{
    if (dunm < monstart) {
        btuxmt(dunm, spr("%s***\r", WHITE));
        outprf(dunm);
	clrprf();
    }
    clrprf();
}

void dun_outdun(dunroom, exp1, exp2, noise)   /* special out message function */
char dunroom[];
int exp1, exp2, noise;
{
    int i;
    char droom[10];
    PLAYER *dunoth;
    strncpy(droom, dunroom, 10);
    for (i=0; i<nterms; i++) {
        if (getply(i)->dunaptr.stt == PLAYING && i != exp1 && i != exp2) {
            dunoth=getply(i);
            if (sameas(droom, OTHROOM)) {
                btuxmt(i, "***\r");
                outprf(i);
            }
        }
    }
    clrprf();
    dun_noise(droom, noise);
}

void dun_noise(dunroom, noise)   /* dungeon out noise function */
char dunroom[];
int noise;
{
    char temp[40], howfar[10], howloud[10], droom[10];
    int i, flag, xx, yy, zz;
    int effect[] = {0, METAL, DEATH, FOOTSTEP, YELLSCR, BATTLE, CRASH,
    THUMP, MUMBLE, EXPLODE};
    PLAYER *dunoth;
    if (noise > 0) {
        strncpy(droom, dunroom, 10);
        xx = atoi(spr("%c%c%c", droom[0], droom[1], droom[2]));
        yy = atoi(spr("%c%c%c", droom[3], droom[4], droom[5]));
        zz = atoi(spr("%c%c%c", droom[6], droom[7], droom[8]));
        for (i=0; i<nterms; i++) {
            if (getply(i)->dunaptr.stt == PLAYING) {
                dunoth=getply(i);
                if (!sameas(droom, OTHROOM)) {
                    flag = abs(xx - dunoth->dunxc);
                    flag = flag + abs(yy - dunoth->dunyc);
                    if (flag <= doptions.range && zz == dunoth->dunzc) {
                        setmem(temp, 40, 0);
                        if (yy - dunoth->dunyc < 0) strcat(temp, "south");
                        else if (yy - dunoth->dunyc > 0) strcat(temp, "north");
                        if (!sameas(temp, "")) strcat(temp, "-");
                        if (xx - dunoth->dunxc < 0) strcat(temp, "west");
                        else if (xx - dunoth->dunxc > 0) strcat(temp, "east");
                        if (strlen(temp) < 7) temp[5] = '\0';
                        setmem(howfar, 10, 0);
                        setmem(howloud, 10, 0);
                        if (flag < doptions.range/2) {
                            strcpy(howfar, "");
                            strcpy(howloud, "loud");
                        }
                        else {
                            strcpy(howfar, " far");
                            strcpy(howloud, "faint");
                        }
                        if (!(dunoth->dunaptr.mutflags&DEAF)) {
                            dun_msg(i, effect[noise], howloud, howfar, temp, NONE1);
                        }
                    }
                }
            }
        }
    }
}

void
dun_timer(void)   /* dungeon master player timing function */
{
    int i, cost;
    struct pspelrec *dspell;
    PLAYER *dunoth;
    if (doptions.dunclean == 0) {
        for (i=0; i<nterms; i++) {    /* user activities */
            if (getply(i)->dunaptr.stt == PLAYING) {
                dunoth=getply(i);
		if (dunoth->dunaptr.totwt > (doptions.mxwgt * dunoth->dunstr)) {
		    if (!(dunoth->dunaptr.mutflags&ENCUMD)) {
	  	        dunoth->dunaptr.mutflags|=ENCUMD;
		        dun_msg(i, ENCUMB, NONE4);
		    }
		}
		else {
		    if (dunoth->dunaptr.mutflags&ENCUMD) {
		        dunoth->dunaptr.mutflags&=~ENCUMD;
			prf("***\rYou regain your strength.\r");
			outprf(i);
	            }
		}
		/* subract time from spell memorization */
                if (dunoth->dunaptr.dunrsp > -1 && dunoth->dunaptr.dunmsp > 0) {
                    dunoth->dunaptr.dunmsp = dunoth->dunaptr.dunmsp - DUNTIMER;
                    if (dunoth->dunaptr.dunmsp < 1) {
                        dunoth->dunaptr.dunmsp = 0;
                        dun_msg(i, FINMEM, pspelptr[dunoth->dunaptr.dunrsp].spenam, NONE3);
                    }
                }
                if (dunoth->dunaptr.lespe > 0) {
                    dunoth->dunaptr.lespe-=DUNTIMER;
                    if (dunoth->dunaptr.lespe <= 0) {
                        dunoth->dunaptr.lespe = 0;
                        dspell=&pspelptr[dunoth->dunaptr.dunrsp];
                        dun_msg(i, SPEOVE, dspell->spenam, NONE3);
                        dunwho=getply(i);
                        dusrnum = i;
                        (*(dspell->dispel))();
                    }
                    else {
                        dspell=&pspelptr[dunoth->dunaptr.dunrsp];
                        if (i < monstart) {
                            dunoth->spcomp-=(dspell->durcost * DUNTIMER);
                        }
                        if (dunoth->spcomp < 1) {
                            usrnum = -1;
                            dunoth->spcomp = 0;
                            dun_msg(i, NOION, NONE4);
                            dunwho=getply(i);
                            dusrnum = i;
                            (*(dspell->dispel))();
                            dunoth->dunaptr.lespe = 0;
                        }
                    }
                }
                if (dunoth->dunaptr.combat > 0) dunoth->dunaptr.combat-=DUNTIMER;
                if (i < monstart) {
                    if (dunoth->poison > 0) {
                        dun_msg(i, UPOIS, NONE4);
                        cost = dunoth->poison;
                        cost = cost - (dunoth->duncon / 100);
                        if (cost < 2) cost = 2;
                        dunoth->dunhp-=cost;
                        dunoth->poison--;
                        if (dunoth->dunhp < 15) {
                            dun_msg(i, ILLS, NONE4);
                            if (dunoth->dunhp < 1) {
                                dun_msg(i, POKY, NONE4);
                            }
                        }
                        if (dunoth->poison <= 0) {
                            dunoth->poison = 0;
                            dun_msg(i, POWO, NONE4);
                        }
                    }
                    if (dunoth->dunhp < 1) {
                        dun_msg(i, YOUDEAD, NONE4);
                        fade2blk(i);
                    }
                }
            }
        }
    }
    rtkick(DUNTIMER, dun_timer);
}

void
dun_timer2(void)  /* dungeon rtkick routine 2 */
{
    int i;
    if (doptions.dunclean == 0) {
        for (i=0; i<nterms; i++) {    /* user activities */
            if (getply(i)->dunaptr.stt == PLAYING) {
                dunwho=getply(i);
                dusrnum = i;
                if (dunwho->dunaptr.exhaust > 0) {
                    dunwho->dunaptr.exhaust = dunwho->dunaptr.exhaust - dunwho->duncon;
                    if (dunwho->dunaptr.exhaust < 0) dunwho->dunaptr.exhaust = 0;
                }
		// reduced it just a little june 3/93 EGF
                dunwho->spcomp-=(classptr[dunwho->duncla].ioncon * (dunwho->dunlev/2));
                if (dunwho->spcomp < 1) {
                    dunwho->spcomp = 0;
                    dun_msg(dusrnum, NOILE, NONE4);
                    dunwho->dunhp-=dunwho->dunlev;
                    if (dunwho->dunhp < 1) dun_msg(dusrnum, DISTA, NONE4);
                }
                if (dunwho->dunhp < 1) fade2blk(dusrnum);
            }
        }
    }
    rtkick(DUNTIME2, dun_timer2);
}


void
dun_montime(void) /* dungeon master monster timing function */
{
    if (doptions.dunclean == 0) {
        dun_monat(-1);
    }
    rtkick(MONTIME, dun_montime);
}

void dun_regni(void)
{
    long pirm;
    int rndit;
    if (doptions.dunclean == 0 && regenptr.regen_size > 0) {
        pirm = dun_rand((int)maxroom);
        setbtv(proombb);
        if (qeqbtv(&pirm, 1)) {
            gcrbtv(&proomptr, 1);
            dun_load(proomptr.prmin);
            if (proomptr.pitem[0] == -1) {
                if (dun_rand(9) < 8) {
                    rndit = dun_rand(regenptr.regen_size);
                    proomptr.pitem[0] = regenptr.regen_ptr[rndit];
                    proomptr.pitst[0] = regenptr.regen_stat[rndit];
                }
                else {
                    rndit = dun_rand(itemsiz);
                    if (pitemptr[rndit].pddam < 20) {
                        proomptr.pitem[0] = rndit;
                        proomptr.pitst[0] = pitemptr[rndit].pdsta;
                    }
                    else {
                        rndit = dun_rand(regenptr.regen_size);
                        proomptr.pitem[0] = regenptr.regen_ptr[rndit];
                        proomptr.pitst[0] = regenptr.regen_stat[rndit];
                    }
                }
                updcas();
                prf_msg(ITAP, pitemptr[proomptr.pitem[0]].pitnam, NONE3);
                dun_outdun(proomptr.prmin, -1, -1, 0);
            }
        }
    }
    rtkick(DUNTIME3, dun_regni);
}

void
dun_monbait(void)   /* monster bait routine */
{
    int size_table, ctr, pick, flag;
    PLAYER *dunoth;
    size_table = 0;
    for (ctr = 0; ctr < nterms; ctr++) {
        if (getply(ctr)->dunaptr.stt == PLAYING) {
            tableptr[size_table].table = ctr;
            size_table++;
        }
    }
    if (size_table > 0) {
        pick = dun_rand(size_table);
        dunoth = getply(tableptr[pick].table);
        flag = 0;
        for (ctr = 0; ctr < 10; ctr++) {
            if (dunoth->dunite[ctr] == BAIT) {
                flag = 1;
                ctr = 10;
            }
        }
        if (flag == 1) {
            for (ctr = monstart+1; ctr < maxcreat; ctr++) {
                if (getply(ctr)->dunaptr.stt == PLAYING) {
                    if (getply(ctr)->dunzc == dunoth->dunzc) {
                        if (sameas(getply(ctr)->dunaptr.pcomba, "ROAM IT")) {
                            prf_msg(HEWPORT, getply(ctr)->dunname, NONE3);
                            dun_outdun(dun_getrm(getply(ctr)->dunxc,
                            getply(ctr)->dunyc,
                            getply(ctr)->dunzc), -1, -1, 0);
                            getply(ctr)->dunxc = dunoth->dunxc;
                            getply(ctr)->dunyc = dunoth->dunyc;
                            prf_msg(HECPORT, getply(ctr)->dunname, NONE3);
                            dun_outdun(OTHROOM, -1, -1, 0);
                            if (!(dunoth->dunaptr.mutflags&INVIS)) {
                                prf_msg(GIMBAIT, getply(ctr)->dunname, dunoth->dunname, NONE2);
                                dun_outdun(OTHROOM, -1, -1, 0);
                                strncpy(getply(ctr)->dunaptr.pcomba, dunoth->dunname, NAMSIZ);
                            }
                            ctr = maxcreat;
                        }
                    }
                }
            }
        }
    }
    rtkick(DUNTIME4, dun_monbait);
}

int dun_armor(plynum)   /* whats a players armor class? */
int plynum;
{
    int dunmor;
    PLAYER *dunoth;
    dunoth=getply(plynum);
    dunmor = 0;
    if (dunoth->dunarm > -1) {
        dunmor = dunmor + pitemptr[dunoth->dunarm].pddam;  /* add protection */
        dunmor = dunmor - ((100 - dunoth->dunast)/10);     /* - armor damage */
        if (dunmor < 0) dunmor = 0;
        if (dunoth->dunast > 100) {
            dunmor = dunmor + dunoth->dunast - 100;            /* add magic   */
            dunmor = dunmor + pitemptr[dunoth->dunarm].pdspe;  /* add special */
        }
    }
    dunmor = dunmor + (dunoth->dundex / 10);  /* add dexterity */
    return(dunmor);
}

void dun_spre(void)     /* print ready spell, and memorized status */
{
    if (dunwho->dunaptr.dunrsp == -1) {
        prf("No spell memorized.");
    }
    else {
        prf("%s: ", pspelptr[dunwho->dunaptr.dunrsp].spenam);
        if (dunwho->dunaptr.dunmsp < 1 && dunwho->dunaptr.lespe > 0) prf("CASTED.");
        else if (dunwho->dunaptr.dunmsp < 1 && dunwho->dunaptr.lespe == 0) prf("READY.");
        else prf("(memorizing %d)", dunwho->dunaptr.dunmsp);
    }
    prf("\r");
}

void fade2blk(parm1)  /* make player fade away */
int parm1;
{
    int i, ctr;
    PLAYER *dunoth;
    dunoth=getply(parm1);
    dun_load(OTHROOM);
    dunoth->dunite[9] = dunoth->dunarm;
    dunoth->dunist[9] = dunoth->dunast;
    dunoth->dunite[8] = 2;
    dunoth->dunist[8] = dunoth->duncla;
    dunoth->dunaptr.summon = 0;
    if (parm1 < monstart) dunoth->dunist[8] = 111;
    for (i=0; i<10; i++) {
        if (dunoth->dunite[i] > 1) {
            for (ctr=0; ctr<6; ctr++) {
                if (proomptr.pitem[ctr] == -1) {
                    prf("\r%s%s is falling from %s's body!\r***", dun_aoran(pitemptr[dunoth->dunite[i]].pitnam, 0), pitemptr[dunoth->dunite[i]].pitnam, dunoth->dunname);
                    proomptr.pitem[ctr] = dunoth->dunite[i];
                    proomptr.pitst[ctr] = dunoth->dunist[i];
                    ctr = 6;
                }
            }
        }
    }
    prf_msg(CRUMB, dunoth->dunname, NONE3);
    dun_outdun(OTHROOM, -1, -1, 0);
    updcas();
    for (i=0; i<maxcreat; i++) {
        if (getply(i)->dunaptr.stt == PLAYING) {
            if (sameas(getply(i)->dunaptr.pcomba, dunoth->dunname)) {
	        if (i > (monstart-1)) {
                    strncpy(getply(i)->dunaptr.pcomba, "ROAM IT", NAMSIZ);
                    dun_monconf(i);
		}
		else setmem(getply(i)->dunaptr.pcomba, NAMSIZ, 0);
            }
        }
    }
    if (parm1 > monstart-1) {
        getply(parm1)->dunaptr.stt = 0;
	if (parm1 > monstart) dun_genmo(parm1);
    }
    else {
        dun_plyrem(parm1);
        getply(parm1)->dunaptr.stt = SELCLASS;
    }
}

int dun_getdir(dir)   /* convert a direction input to a number */
char dir[];
{
    int flag;
    flag = -1;
    if (dir[0] == 'n') flag = 0;
    else if (dir[0] == 's') flag = 1;
    else if (dir[0] == 'e') flag = 2;
    else if (dir[0] == 'w') flag = 3;
    return(flag);
}

void dun_log(who, log, stat) /* logging utilities for events */
char *who, *log;
long stat;
{
    char logr[100];
    int i, flag;
    PLAYER *dunoth;
    if (!sameas(who, "Village Shop")) {
        setmem(logr, 100, 0);
        if (sameas(log, "POST")) {
            sprintf(logr, "%ld Riblets have been added to your bank balance.", stat);
        }
        else strncpy(logr, log, 100);
        flag = 0;
        for (i=0; i<monstart; i++) {
            if (getply(i)->dunaptr.stt == PLAYING) {
                dunoth=getply(i);
                if (sameas(dunoth->dunname, who)) {
                    if (sameas(log, "POST")) dunoth->dungold = dunoth->dungold + stat;
                    prf("%s\r", logr);
                    dun_outply(i);
                    flag = 1;
                    i = monstart;
                }
            }
        }
        if (flag == 0 && stat != -10) {
            strncpy(mlogptr.logind, who, NAMSIZ);
            strncpy(mlogptr.logdes, logr, 100);
            mlogptr.logstat = stat;
            setbtv(plogbb);
            insbtv(&mlogptr);
        }
    }
}

void dun_flulog(void)   /* flush a log */
{
    char temp_name[NAMSIZ];
    setmem(temp_name, NAMSIZ, 0);
    strcpy(temp_name, uacoff(usrnum)->userid);
    setbtv(plogbb);
    if (qeqbtv(temp_name, 0)) {
        dun_msg(usrnum, LOGR, NONE4);
        setbtv(plogbb);
        do {
            gcrbtv(&mlogptr, 0);
            if (sameas(mlogptr.logind, temp_name)) {
                if (sameas(mlogptr.logdes, "POST")) {
                    dunwho->dungold = dunwho->dungold + mlogptr.logstat;
                }
                prf("%s\r", mlogptr.logdes);
                delbtv();
            }
            else break;
        } while(qnxbtv());
        outprf(dusrnum);
	clrprf();
    }
}

int dun_rand(number)    /* generate a random number */
int number;
{
    int retval;
    retval = 0;
    if (number > 0) {
        retval = random(number);
    }
    return(retval);
}

int dun_chkhit(who, itmem)    /* did player manage to hit other player */
int who, itmem;
{
    int retval, combo;
    PLAYER *dunoth;
    dunoth=getply(who);
    combo = dunoth->dundex - dunwho->dundex;
    if (combo < 10 && combo > 0) retval = dun_rand(6);
    else retval = 1;
    if (retval > 2) retval = 1;
    if (dunwho->dunist[itmem] > 100) retval = 1; /* hit if magical weopon */
    if (dusrnum > monstart - 1) retval = 1; /* hit if monster */
    return(retval);
}

void 
dun_creusr(void)  /* create new player - all classes put on file */
{
    int i;
    setbtv(pplybb);
    for (i=0; i<MAXCLASS; i++) {
        dun_resply(i);
        strncpy(dunglb.dunname, uacoff(usrnum)->userid, NAMSIZ);
        insbtv(&dunglb);
    }
}

void dun_resply(wclass)   /* reset a player */
int wclass;
{
    int ii;
    dunglb.duncla = wclass;
    dunglb.dunstr = classptr[dunglb.duncla].cminstr;
    dunglb.dunint = classptr[dunglb.duncla].cminint;
    dunglb.dunwis = classptr[dunglb.duncla].cminwis;
    dunglb.dundex = classptr[dunglb.duncla].cmindex;
    dunglb.duncon = classptr[dunglb.duncla].cmincon;
    dunglb.duncha = classptr[dunglb.duncla].cmincha;
    dunglb.dunhp = classptr[dunglb.duncla].maxchp;
    dunglb.dunxc = 0;                             /* x location          */
    dunglb.dunyc = 0;                             /* y location          */
    dunglb.dunzc = 0;                             /* z location          */
    dunglb.dunlev = 1;                            /* level               */
    dunglb.dunscr = 0;                            /* score               */
    dunglb.maxhp = dunglb.dunhp;                  /* maximum hp's        */
    dunglb.dunarm = -1;                           /* wearing armor       */
    dunglb.dunast = -1;                           /* armor stat          */
    for (ii=0; ii<10; ii++) {
        dunglb.dunite[ii] = -1;                   /* clear items         */
        dunglb.dunist[ii] = -1;                   /* item statistic      */
    }
    for (ii=0; ii<20; ii++) {
        dunglb.dunspe[ii] = -1;                   /* set spells          */
    }
    dunglb.dungold = 0;                           /* gold riblets        */
    dunglb.spcomp = 30000;                        /* spell ions          */
    dunglb.dundead = -1;                          /* player dead flag    */
    dunglb.poison = 0;                            /* player not poisoned */
}

int dun_chklight(who)  /* check if other players have light source */
int who;
{
    int i;
    char temp[10];
    PLAYER *dunoth;
    who = 0;
    for (i=0; i<nterms; i++) {
        if (getply(i)->dunaptr.stt == PLAYING) {
            dunoth=getply(i);
            strncpy(temp, OTHROOM, 10);
            if (sameas(temp, PLYROOM)) {
                if (dunoth->dunaptr.mutflags&LIGHT) {
                    who = 1;
                    i = maxcreat;
                }
            }
        }
    }
    return(who);
}

void dun_chknlig(void)   /* check if player entered has light source */
{
    if (dunwho->dunaptr.mutflags&LIGHT) {
        prf_msg(LIGHTR, dunwho->dunname, NONE3);
        dun_outdun(PLYROOM, dusrnum, -1, 0);
    }
}

int dun_dark(where)  /* is room dark? */
int where;
{
    where = 0;
    if (proomptr.dark > 0) {
        if (dun_chklight(0) == 0) {
            where = 1;
        }
    }
    return(where);
}

void dun_crm(dunx, duny, dunz)   /* create a room */
int dunx, duny, dunz;
{
    int i, flag;
int dundir[4] = {0, 0, 0, 0};
    char *desc[] = {
        "You see rubble everywhere.",
        "Crumbling buildings surround you.",
        "You're in an abandoned building.",
        "The two moons are rising above.",
        "You hear volcanoes erupt in the distance.",
        "You feel a cold breeze.",
        "Graffiti lines the city walls.",
        "Relics of the war line the streets.",
        "Broken lamp posts line the streets.",
        "The street is cracked here.",
        "You're in a wrecked building.",
        "An old hydro line has fallen here.",
        "Broken glass covers the road.",
        "The wind is whistling through open windows.",
        "An eerie calm settles in the distance.",
    };
    for (i=0; i<4; i++) {
        flag = 1;
        if (i == 1 || i == 3) flag = -1;
        dundir[i] = 0;
        if (dun_load(dun_getrm(dunx+genx[i], duny+geny[i], dunz+genz[i])) == 1) {
            if (proomptr.prmdir[i+flag] == 0) {
                proomptr.prmdir[i+flag] = 1;
                updcas();
                dundir[i] = 1;
                prf_msg(NEXIT, gendir[i+flag], NONE3);
                dun_outdun(dun_getrm(dunx+genx[i], duny+geny[i], dunz+genz[i]), -1, -1, 0);
            }
        }
    }
    flag = 0;
    if (dun_load(dun_getrm(dunx, duny, dunz)) == 0) {
        strncpy(proomptr.prmin, dun_getrm(dunx, duny, dunz), 10);
        proomptr.prind = maxroom;
        proomptr.prmst = 0;
        proomptr.trade = 0;
        proomptr.maint = 0;
        proomptr.dark = 0;
        strncpy(proomptr.portal, "NONE", 10);
        for (i=0; i<4; i++) {
            proomptr.prmdir[i] = dundir[i];
        }
        for (i=0; i<6; i++) {
            proomptr.pitem[i] = -1;
            proomptr.pitst[i] = -1;
        }
        strncpy(proomptr.bared, "", NAMSIZ);
        setmem(proomptr.sign, 50, 0);
        strcat(proomptr.sign, desc[dun_rand(sizeof(desc)/sizeof(*desc))]);
        flag = 1;
    }
    else {
        for (i=0; i<4; i++) {
            if (dundir[i] == 1) {
                proomptr.prmdir[i] = 1;
            }
        }
    }
    updcas();
    if (flag > 0) {
        if (dun_rand(6) == 0) {
            dun_sale(proomptr.prmin);
            if (dun_rand(6) == 0) {
                setmem(proomptr.sign, 50, 0);
                strcat(proomptr.sign, "City Trading Centre");
                proomptr.trade = 1;
                updcas();
                setbtv(psalebb);
                if (qeqbtv(&proomptr.prmin, 0)) {
                    gcrbtv(&psaleptr, 0);
                    psaleptr.cash = 999999999L;
                    psaleptr.taxrate = doptions.startax;
                    psaleptr.sellval = doptions.inisell;
                    psaleptr.security = 99999999L;
                    strncpy(psaleptr.namind, "Village Shop", NAMSIZ);
                    updbtv(&psaleptr);
                }
            }
        }
        else {
            if (dun_rand(6) == 0) {
                setmem(proomptr.sign, 50, 0);
                strcat(proomptr.sign, "You're in a maintenance shop.");
                proomptr.maint = 1;
                updcas();
            }
        }
    }
}

void 
dun_iniply(void)   /* initialize a player */
{
    int i;
    if (uacoff(usrnum)->sex == 'M') dunwho->dunaptr.plysex = 0;
    else dunwho->dunaptr.plysex = 1;
    setmbk(dunmb);
    dunwho->dunaptr.exhaust = 0;
    setmem(dunwho->dunaptr.pcomba, NAMSIZ, 0);
    dunwho->dunaptr.totwt = 0;
    for (i=0; i<10; i++) {
        if (dunwho->dunite[i] > -1) {
            dunwho->dunaptr.totwt = dunwho->dunaptr.totwt + pitemptr[dunwho->dunite[i]].wieght;
        }
    }
    dunwho->dunaptr.mutflags = BLURB;
    dunwho->dunaptr.lespe = 0;             /* no spells active    */
    dunwho->dunaptr.dunrsp = -1;           /* set no spells ready */
    dunwho->dunaptr.dunmsp = -1;           /* memorize timer      */
    dunwho->dunaptr.summon = 0;            /* not able to summon  */
    dunwho->dunaptr.combat = 0;            /* combat flag         */
}

void dun_saveply(void)   /* save a player to disk */
{
    int i, flag;
    PLAYER duntemp;
    if (dunwho->dunaptr.lespe > 0) dun_dispell();
    setbtv(pplybb);
    if (qeqbtv(dunwho->dunname, 0)) {
        flag = 0;
        do {
            gcrbtv(&duntemp, 0);
            if (duntemp.duncla == dunwho->duncla) {
                flag = 1;
            }
            else {
                if (aqnbtv(&duntemp) == 0) flag = 1;
                else gcrbtv(&duntemp, 0);
            }
        } while (flag == 0);
        updbtv(dunwho);
    }
    else shocst("MUTANT ERROR", "MUTANTS->CANT SAVE PLAYER");
    setmem(dunwho->dunaptr.pcomba, NAMSIZ, 0);
    setbtv(pplybb);
    for (i=0; i<maxcreat; i++) {
        if (sameas(getply(i)->dunaptr.pcomba, dunwho->dunname)) {
	    if (i > (monstart-1)) {
                strncpy(getply(i)->dunaptr.pcomba, "ROAM IT", NAMSIZ);
                dun_monconf(i);
	    }
	    else setmem(getply(i)->dunaptr.pcomba, NAMSIZ, 0);
        }
    }
}

void dun_sale(area)  /* make area sellable */
char area[];
{
    int i, x, y, z;
    if (dun_load(area) == 1) {
        strncpy(psaleptr.rmind, area, 10);
        strncpy(psaleptr.namind, "FOR SALE", NAMSIZ);
        for (i=0; i<20; i++) {
            psaleptr.itsale[i] = -1;
            psaleptr.itstat[i] = -1;
        }
        psaleptr.markup = doptions.stormu;
        psaleptr.markdown = doptions.stormd;
        psaleptr.cash = 0;
        z = atoi(spr("%c%c", area[7], area[8]));
        z++;
        psaleptr.taxrate = doptions.startax * (long)z;
        psaleptr.security = 0;
        psaleptr.sellval = doptions.inisell * (atoi(spr("%c%c", area[7], area[8])) + 1);
        setbtv(psalebb);
        if (qeqbtv(area, 0) == 0) {
            insbtv(&psaleptr);
            dun_load(area);
            setmem(proomptr.sign, 50, 0);
            sprintf(proomptr.sign, "A sign reads: FOR SALE $ %ld", psaleptr.sellval);
            proomptr.trade = 2;
            for (i=0; i<4; i++) {
                if (proomptr.prmdir[i] == 1) {
                    proomptr.prmdir[i] = 10;
                    updcas();
                    x = atoi(spr("%c%c%c", proomptr.prmin[0], proomptr.prmin[1], proomptr.prmin[2]));
                    y = atoi(spr("%c%c%c", proomptr.prmin[3], proomptr.prmin[4], proomptr.prmin[5]));
                    z = atoi(spr("%c%c%c", proomptr.prmin[6], proomptr.prmin[7], proomptr.prmin[8]));
                    dun_load(dun_getrm(x+genx[i], y+geny[i], z+genz[i]));
                    if (i == 1 || i == 3) proomptr.prmdir[i-1] = 10;
                    else proomptr.prmdir[i+1] = 10;
                    updcas();
                    dun_load(dun_getrm(x, y, z));
                }
            }
            updcas();
        }
    }
}

void dun_plyrem(who)   /* reset a player on file */
int who;
{
    int flag, i;
    PLAYER *dunoth, duntemp;
    dunoth=getply(who);
    setbtv(pplybb);
    if (qeqbtv(dunoth->dunname, 0)) {
        flag = 0;
        do {
            gcrbtv(&duntemp, 0);
            if (duntemp.duncla == dunoth->duncla) break;
            else {
                if (aqnbtv(&duntemp) == 0) break;
                else gcrbtv(&duntemp, 0);
            }
        } while (flag == 0);
    }
    dunoth->dungold = 0;
    dunoth->spcomp = 0;
    dunoth->poison = 0;
    dunoth->dundead = dunoth->dunlev;
    for (i=0; i<10; i++) {
        dunoth->dunite[i] = -1;
        dunoth->dunist[i] = -1;
    }
    dunoth->dunarm = -1;
    dunoth->dunast = -1;
    dunoth->dunhp = dunoth->maxhp;
    updbtv(dunoth);
    getply(who)->dunaptr.stt = SELCLASS;
}

void dun_punusr(void)     /* punish a user */
{
    char temp[200];
    dunwho->dunstr-=doptions.penpl;
    dunwho->dundex-=doptions.penpl;
    dunwho->duncon-=doptions.penpl;
    dunwho->dunint-=doptions.penpl;
    dunwho->dunwis-=doptions.penpl;
    dunwho->duncha-=doptions.penpl;
    if (dunwho->dunstr < 0) dunwho->dunstr = 0;
    if (dunwho->dunint < 0) dunwho->dunint = 0;
    if (dunwho->dunwis < 0) dunwho->dunwis = 0;
    if (dunwho->dundex < 0) dunwho->dundex = 0;
    if (dunwho->duncon < 0) dunwho->duncon = 0;
    if (dunwho->duncha < 0) dunwho->duncha = 0;
    setmem(temp, 200, 0);
    sprintf(temp, "Your %s has been punished for exiting the last battle! (%d points per stat lost)", 
    classptr[dunwho->duncla].clanam, doptions.penpl);
    dun_log(dunwho->dunname, temp, 0);
}

void dun_telm(what)  /* send message to all users in game */
char *what;
{
    int i;
    prf("***\rTelepathic Blurb: %s\r", what);
    for (i=0; i<monstart; i++) {
        if (getply(i)->dunaptr.stt == PLAYING && i != dusrnum) {
            if (getply(i)->dunaptr.mutflags&BLURB) {
                outprf(i);
            }
        }
    }
    clrprf();
}


void dun_mapit(x, y)   /* update map */
int x, y;
{
    int xx, yy;
    if (dusrnum < monstart) {
        if (x == 1) {
            for (xx=0; xx<8; xx++) {
                for (yy=0; yy<9; yy++) {
                    mutmap[dusrnum].play_map[xx][yy] = mutmap[dusrnum].play_map[xx+1][yy];
                    if (xx == 0) {
                        mutmap[dusrnum].play_map[8][yy] = '.';
                    }
                }
            }
        }
        else if (x == -1) {
            for (xx=8; xx>0; xx--) {
                for (yy=0; yy<9; yy++) {
                    mutmap[dusrnum].play_map[xx][yy] = mutmap[dusrnum].play_map[xx-1][yy];
                    if (xx == 8) {
                        mutmap[dusrnum].play_map[0][yy] = '.';
                    }
                }
            }
        }
        if (y == 1) {
            for (yy=8; yy>0; yy--) {
                for (xx=0; xx<9; xx++) {
                    mutmap[dusrnum].play_map[xx][yy] = mutmap[dusrnum].play_map[xx][yy-1];
                    if (yy == 8) {
                        mutmap[dusrnum].play_map[xx][0] = '.';
                    }
                }
            }
        }
        else if (y == -1) {
            for (yy=0; yy<8; yy++) {
                for (xx=0; xx<9; xx++) {
                    mutmap[dusrnum].play_map[xx][yy] = mutmap[dusrnum].play_map[xx][yy+1];
                    if (yy == 0) {
                        mutmap[dusrnum].play_map[xx][8] = '.';
                    }
                }
            }
        }
        if (proomptr.maint == 1) mutmap[dusrnum].play_map[4][4] = 'm';
        if (proomptr.trade == 1) mutmap[dusrnum].play_map[4][4] = 't';
        if (mutmap[dusrnum].play_map[4][4] == '.') mutmap[dusrnum].play_map[4][4] = '#';
    }
}

int dun_areaok(retval)
int retval;
{
    int re2val;
    re2val = retval;
    if (abs(dunwho->dunxc) > 5 || abs(dunwho->dunyc) > 5) re2val = 1;
    return(re2val);
}

struct player *
getply(int who)
{
#ifdef PHARLAP
    return((struct player *)((long)(plybas+(who<<3))<<16));
#else
    #ifdef ECLIPSE
        return((struct player *)((long)(plybas+(who<<3))<<16));
    #else
        return((struct player *)(player+(who*(long)sizeof(struct player))));
    #endif
#endif
}

// credit surcharge - may 25/93
void
dun_surcharge(void)
{
    int ctr;
    for (ctr = 0; ctr < nterms; ctr++) {
        if (getply(ctr)->dunaptr.stt == PLAYING) {
	    usaptr = uacoff(ctr);
	    if (tstcrd(doptions.surcharge)) {
	        uacoff(ctr)->creds-=doptions.surcharge;
	    }
	} 
    }
    rtkick(60, dun_surcharge);
}
	









